<?php
/**
 * Created by PhpStorm.
 * User: leeyifiei
 * Date: 15-10-27
 * Time: 上午12:59
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class Code
{

    /**
     * 服务器出错
     */
    const SERVER_ERROR = -1;

    /**
     * 非法请求
     */
    const ILLEGAL_REQUEST = -2;

    /**
     * 帖子不存在
     */
    const POST_NOT_EXIST = -3;

    /**
     * discuz_model -> showmessage  抛出的错误
     */
    const DISCUZ_MODEL_ERROR = 99;

    //用户名为空
    const USERNAME_EMPTY = 100;

    //用户不存在
    const USER_NOT_EXISTS = 101;

    //密码错误
    const PASSWORD_ERROR = 102;

    //登录失败次数过多
    const LOGIN_PERM = 103;

    //密码中包含非法字符
    const PASSWORD_ILLEGAL = 104;

    /**
     * 第三方账号尚未绑定论坛用户
     */
    const THIRD_ACCOUNT_NOT_BIND = 105;

    /**
     * 非法手机号
     */
    const ILLEGAL_MOBILE = 105;

    /**
     * 用户名已经存在
     */
    const USERNAME_EXISTS = 107;

    /**
     * 账号尚未激活
     */
    const NOT_ACTIVATION = 108;

    /**
     * 账号已经绑定其其他平台
     */
    const BIND_OTHER_PLATFORM = 109;

    /**
     * 平台账号已经绑定了其他论坛账号
     */
    const BIND_OTHER_ACCOUNT = 110;

    /**
     * 绑定第三方平台账号失败
     */
    const BIND_PLATFORM_FAIL = 111;

    /**
     * 帖子不存在
     */
    const THREAD_NOT_EXISTS = 201;

    /**
     * 用户组无权限
     */
    const GROUP_HAS_NOT_PERMISSION = 202;

    /**
     * 板块无法访问
     */
    const FORUM_NOPERMISSION = 203;

    /**
     * 需要密码访问
     */
    const NEED_PASSWORD = 204;

    /**
     * 帖子阅读权限
     */
    const THREAD_READPERM = 205;

    /**
     * 板块不存在
     */
    const FORUM_NOT_EXISTS = 206;

    /**
     * 板块浏览权限不足
     */
    const FORUM_VIEW_PERM = 207;

    /**
     * 需要密码访问板块
     */
    const FORUM_NEED_PASSWORD = 208;

    /**
     * 板块需要付费浏览
     */
    const FORUM_NEED_PRICE = 209;

    /**
     * 上传图片失败
     */
    const ATTACHMENT_UPLOAD_ERROR = 301;

    /**
     * 发布失败
     */
    const POST_FAIL = 401;

    /**
     * 群组功能关闭
     */
    const GROUP_OFF = 402;

    /**
     * 不是群组
     */
    const FORUM_NOT_GROUP = 403;

    /**
     * 群组已关闭
     */
    const FORUM_GROUP_STATUS_OFF = 403;

    /**
     * 没有群组权限
     */
    const FORUM_GROUP_NOALLOWED = 404;

    /**
     * 等待群主审核
     */
    const FORUM_GROUP_MODERATED = 405;

    /**
     * 不是群组成员
     */
    const FORUM_GROUP_NOT_GROUPMEMBER = 406;

    /**
     * 不是群组成员
     */
    const FORUM_GROUP_NOT_GROUPMEMBER_GUEST = 407;

    /**
     * 本版块暂时无法发帖
     */
    const FORUM_DISABLEPOST = 408;

    /**
     * 帖子不允许访问
     */
    const THREAD_NOPERMISSION = 409;

    /**
     * 帖子被关闭
     */
    const POST_THREAD_CLOSED = 410;

    /**
     * 发帖IP时间段限制
     */
    const POSTBANPERIODS = 411;

    /**
     * 板块无权限操作
     */
    const FORUM_ACCESS_VIEW_DISALLOW = 412;

    /**
     * 注册后发帖时间限制
     */
    const POST_NEWBIE_SPAN = 413;

    /**
     * 帖子标题非法
     */
    const POST_SUBJECT_ILLEGAL = 414;

    /**
     * 帖子内容非法
     */
    const POST_MESSAGE_ILLEGAL = 415;

    /**
     * 发布HIDE内容权限
     */
    const POST_HIDE_NOPERMISSION = 416;

    /**
     * 交易积分关闭
     */
    const REWARD_LCREDITS_CLOSED = 417;

    /**
     * 用户组没权限
     */
    const GROUP_NOPERMISSION = 418;

    /**
     * 板块动作不允许
     */
    const FORUM_ACCESS_DISALLOW = 419;

    /**
     * 指定板块不存在
     */
    const FORUM_NONEXISTENCE = 420;

    /**
     * 只有QQ登录才有发布权限
     */
    const POSTPERM_QQONLY_NOPERMISSION = 421;

    /**
     * 尚未登录，并且板块不允许游客操作
     */
    const POSTPERM_LOGIN_NOPERMISSION = 422;

    /**
     * 发帖权限
     */
    const POSTPERM_NONE_NOPERMISSION = 423;

    /**
     * 发帖权限
     */
    const POSTPERM = 424;

    /**
     * 板块不允许发布主题
     */
    const POST_FORUM_NEWTHREAD_NOPERMISSION = 425;

    /**
     * 未登录不允许发帖
     */
    const REPLYPERM_LOGIN_NOPERMISSION = 426;

    /**
     * 没有权限在该板块回帖
     */
    const REPLYPERM_NONE_NOPERMISSION = 427;

    /**
     *
     */
    const POST_FORUM_NEWREPLY_NOPERMISSION = 428;

    /**
     * 注册成功后一段时间内无法发帖
     */
    const NO_PRIVILEGE_NEWBIESPAN = 429;

    /**
     * 上传头像才能做操作
     */
    const NO_PRIVILEGE_AVATAR = 430;

    /**
     * 验证EMAIL才能操作
     */
    const NO_PRIVILEGE_EMAIL = 431;

    /**
     * 好友数量到达后才能操作
     */
    const NO_PRIVILEGE_FRIENDNUM = 432;

    /**
     * 不支持特殊贴发布
     */
    const NOT_SUPPORT_SPECIAL = 433;

    /**
     * 禁止引用自己和主题帖之外的帖子
     */
    const REPLY_QUOTEPOST_ERROR = 434;

    /**
     * 未登录
     */
    const NOT_LOG_IN = 500;

    /**
     * 帖子，版块已经收藏
     */
    const ALREADY_COLLECTED = 501;

    /**
     *版块不能被收藏
     */
    const FORUM_CANNOT_COLLECT = 502;

    /**
     * 点赞功能未开放
     */
    const NO_PRIVILEGE_RECOMMEND = 503;

    /**
     * 不能赞自己主题
     */
    const RECOMMEND_SELF_DISALLOW = 504;

    /**
     * 已赞过本主题
     */
    const RECOMMEND_DUPLICATE = 505;

    /**
     * 今日点赞机会已用完
     */
    const RECOMMEND_OUTOFTIMES = 506;

    /**
     * 收藏失败
     */
    const COLLECT_FAIL = 507;

    /**
     * 您尚未收藏
     */
    const NOT_COLLECTED = 508;

    /**
     * 论坛不允许注册
     */
    const REGISTER_DISABLE = 510;

    /**
     * 开放了邀请注册，不能直接注册
     */
    const REGISTERATION_INVITE = 511;

    /**
     * 用户名太短
     */
    const PROFILE_USERNAME_TOOSHORT = 512;

    /**
     * 用户名太长
     */
    const PROFILE_USERNAME_TOOLONG = 513;

    /**
     * 密码复杂度太弱
     */
    const PASSWORD_WEAK = 514;

    /**
     *密码太短
     */
    const PROFILE_PASSWORD_TOOSHORT = 515;

    /**
     *两次输入的密码不一致
     */
    const PROFILE_PASSWD_NOTMATCH = 516;

    /**
     * 密码空或包含非法字符
     */
    const PROFILE_PASSWD_ILLEGAL = 517;

    /**
     * IP在24时间内不能注册
     */
    const REGIP_REGCTRL = 518;

    /**
     *同一IP不能多次注册
     */
    const REGIP_REGFLOODCTRL = 519;

    /**
     * 注册的手机号已存在
     */
    const TELPHONE_EXIST = 520;

    /**
     * 用户名不合法
     */
    const PROFILE_USERNAME_ILLEGAL = 521;

    /**
     * 用户名包含被系统屏蔽的字符
     */
    const PROFILE_USERNAME_PROTECT = 522;

    /**
     * 注册用户名已经存在
     */
    const PROFILE_USERNAME_DUPLICATE = 523;

    /**
     * email 地址无效
     */
    const PROFILE_EMAIL_ILLEGAL = 524;

    /**
     * email 包含不可使用的邮箱域名
     */
    const PROFILE_EMAIL_DOMAIN_ILLEGAL = 525;

    /**
     * 该 email 已经被注册
     */
    const PROFILE_EMAIL_DUPLICATE = 526;

    /**
     * 参数错误
     */
    const UNDEFINED_ACTION = 527;

    /**
     * 用户 ID {uid}已经存在
     */
    const PROFILE_UID_DUPLICATE = 528;

    /**
     * 第三方注册失败
     */
    const THIRD_REGISTER_FAILED = 529;

    /**
     * 激活失败，请重新登录验证需要激活的用户
     */
    const REGISTER_ACTIVATION_INVALID = 530;

    /**
     * 非法上传
     */
    const ILLEGAL_UPLOAD = 540;

    /**
     * 头像上传失败
     */
    const UPLOAD_FAIL = 541;

    /**
     * 上传文件大小超出范围
     */
    const FILE_SIZE_TOO_LARGE = 542;

    /**
     * 手机号已经存在 | 需要与云服务器配合使用
     */
    const MOBILE_EXISTS = 705;

    /**
     * 手机号未注册
     */
    const PHONE_NOT_REG = 709;

    /**
     * 验证码不存在
     */
    const VERIFYCODE_NOT_EXISTS = 710;

    /**
     * 验证码不正确
     */
    const VERIFYCODE_NOT_CORRECT = 711;

    /**
     * 本主题已关闭，无法继续投票
     */
    const THREAD_POLL_CLOSED = 702;

    /**
     * 抱歉，您没有选择投票选项
     */
    const THREAD_POLL_INVALID = 703;

    /**
     * 投票未找到
     */
    const POLL_NOT_FOUND = 704;

    /**
     * 投票已过期
     */
    const POLL_OVERDUE = 705;

    /**
     * 此投票最多只能选择 {maxchoices} 项
     */
    const POLL_CHOOSE_MOST = 706;

    /**
     * 已经投过票了
     */
    const THREAD_POLL_VOTED = 707;

    /**
     * 该用户受保护，无权限更改密码
     */
    const USER_PROTECTED = 600;

    /**
     * 修改失败
     */
    const CHANGE_FAILED = 601;

    /**
     * 原密码不正确
     */
    const OLD_PASSWORD_INCORRECT = 602;

    /**
     * 尚未绑定该平台
     */
    const NOT_BIND_PLATFORM = 603;

    /**
     * 该账号尚未绑定手机号
     */
    const NOT_BIND_PHONE = 604;
	
	/**
     * 分类信息错误
     */
    const SORTS_THREAD_ERROR = 708;

    /**
     * 用户名或密码错误
     */
    const USERNAME_PASSWORD_INCORRECT = 709;

    /**
     * 帖子正在审核中
     */
    const THREAD_CHECK = 710;

    /**
     * uc_server数据库连接失败
     */
    const UC_DATABASE_CONNECT_FAIL = 711;

    /**
     * 改名失败
     */
    const RENAME_FAIL = 712;
	
	
	/**
     * 管理接口参数错误
     */
    const MANAGER_ERR = 800;
    /**
     * 无禁言操作权限
     */
    const UN_BAN_USER = 801;
    /**
     * 不能对该用户直接禁言
     */
    const UN_BNA_SPECIAL_USER = 802;
    /**
     * 没有输入变更理由
     */
    const EMPTY_REASON = 803;
    /**
     * 无置顶操作权限
     */
    const UN_STICK_THREAD = 810;
    /**
     * 无移动帖子操作权限
     */
    const UN_MOVE_THREAD = 811;
    /**
     * 无删除帖子操作权限
     */
    const UN_DEL_THREAD = 812;
    /**
     * 有效期无效
     */
    const INVALID_EXPIRATION = 813;
    /**
     * 需要审核
     */
    const NEED_CHECK = 814;
    /**
     * 无发帖权限
     */
    const UN_POST_THREAD = 815;
    /**
     * 未选择主题，不执行
     */
    const UN_DO_ACTION = 816;
    /**
     * 无权限屏蔽
     */
    const UN_DO_BAN_POST = 817;
    /**
     * 无权限操作
     */
    const NO_PERMISSION = 818;
    /**
     * 无编辑权限
     */
    const EDIT_NOPERMISSION = 820;
    /**
     * 帖子超时不可编辑
     */
    const EDIT_TIMEOUT = 821;
    /**
     * 帖子标题长度不能超过80
     */
    const SUBJECT_TOOLONG = 830;
    /**
     * 帖子标题不能为空
     */
    const SUBJECT_EMPTY = 831;
}