<?php
/**
 * Controller is the customized base controller class.
 * All controller classes for this application should extend from this base class.
 */

if (!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

class Controller extends CController
{
	/**
	 * @var string the default layout for the controller view. Defaults to '//layouts/column1',
	 * meaning using a single column layout. See 'protected/views/layouts/column1.php'.
	 */
	public $layout = false;
	/**
	 * @var array context menu items. This property will be assigned to {@link CMenu::items}.
	 */
	public $menu=array();
	/**
	 * @var array the breadcrumbs of the current page. The value of this property will
	 * be assigned to {@link CBreadcrumbs::links}. Please refer to {@link CBreadcrumbs::links}
	 * for more details on how to specify this property.
	 */
	public $breadcrumbs=array();

	protected $_map = array();

	/**
	 * 获取相关动作
	 * @return array
	 */
	public function getExecuter()
	{
		//$action = Yii::app()->request->getPost( 'action', '' );
		$action = Yii::app()->request->getPost('action', '');
		if ($action) {
			foreach ($this->_map as $key => $value) {
				if (in_array($action, $value['actions'])) {
					return array(
						'controller' => strtolower($value['controller']),
						'action' => $action
					);
				}
			}
		}

		return array();
	}

}