<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/11
 * Time: 下午2:41
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ForumThread
{

    const DISPLAY_ORDER_GLOBAL = 3;  // 全局置顶
    const DISPLAY_ORDER_GROUP = 2;   // 分类置顶
    const DISPLAY_ORDER_FORUM = 1;   // 本版置顶
    const DISPLAY_ORDER_NORMAL = 0;
    const DISPLAY_ORDER_CHECK = -2;  // 审核中

    /**
     * @param $post
     * @return mixed
     */
    public static function parsePostMessage( &$post ,$type=0 )
    {
        if ($post['bbcodeoff'] != 1) {
            // 转换视音频，为了不走 discuz 原先的流程
            $post['message'] = preg_replace_callback(
                '/\[(audio|media|flash).*?\](.*?)\[\/\1\]/s',
                create_function('$matches', '
                    $string = "";
                    switch ($matches[1]) {
                        case "audio":
                            $string = "[qianfan_audio={$matches[2]}]";
                            break;
                        case "media":
                        case "flash":
                            $string = "[qianfan_media]{$matches[2]}[/qianfan_media]";
                            break;
                        default:
                            break;
                    }
                    return $string . "\r\n";
                '),
                $post['message']
            );

            //兼容html <embed>标签
            if(preg_match_all('/<embed src="(.+?)".*?>(<\/embed>)?/', $post['message'], $matches)) {
                foreach( $matches[1] as $key => $val ) {
                    $post['message'] = str_replace( $matches[0][$key], '[qianfan_media]'.$matches[1][$key].'[/qianfan_media]', $post['message'] );
                }
            }

            //qq交谈
            if(preg_match_all('/\[qq\](.+?)\[\/qq\]/', $post['message'], $matches)) {
                foreach( $matches[1] as $key => $val ) {
                    $post['message'] = str_replace( $matches[0][$key], '[qianfan_qq]'.$matches[1][$key].'[/qianfan_qq]', $post['message'] );

                }
            }

        }

        /*
        // 转换超链接
        $post['message'] = preg_replace_callback('/\[url=?(.*?)\](.*?)\[\\/url\]/', create_function('$matches', '
                $matches[1] || $matches[1] = $matches[2];
                $matches[1] = WebUtils::getHttpFileName($matches[1]);
                return "[mobcent_br]\r\n[mobcent_url={$matches[1]}(title={$matches[2]})]\r\n";
            '),
            $post['message']
        );
        */

        $post = ForumThread::parsePostMessage2Html($post,$type);

        $content = ForumThread::handlePostContent( $post['message'] );

        return $content;
    }


    /**
     * 处理主题帖内容，将内容转换成HTML
     * @param $content
     * @return mixed
     */
    public static function parsePostMessage2Html( &$post , $type=0 )
    {
        global $_G;

        require_once( Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php' );

        loadcache('usergroups');
        $userInfo = getuserbyuid( $post['authorid'],1 );
        $post = array_merge( $userInfo, $post );

        //处理主题价格
        $_G['forum_threadpay'] = false;
        if ($post['first']) {
            if($_G['forum_thread']['price'] > 0 && $_G['forum_thread']['special'] == 0) {
                if($_G['setting']['maxchargespan'] && TIMESTAMP - $_G['forum_thread']['dateline'] >= $_G['setting']['maxchargespan'] * 3600) {
                    C::t('forum_thread')->update($_G['tid'], array('price' => 0), false, false, $archiveid);
                    $_G['forum_thread']['price'] = 0;
                } else {
                    $exemptvalue = $_G['forum']['ismoderator'] ? 128 : 16;
                    if(!($_G['group']['exempt'] & $exemptvalue) && $_G['forum_thread']['authorid'] != $_G['uid']) {
                        if(!(C::t('common_credit_log')->count_by_uid_operation_relatedid($_G['uid'], 'BTC', $_G['tid']))) {
                            require_once libfile('thread/pay', 'include');
                            $_G['forum_threadpay'] = true;
                        }
                    }
                }
            }
        }

        $lastvisit = $_G['member']['lastvisit'];
        $ordertype = $maxposition = 0;

        // 处理附件
        $_G['forum_attachpids'] = $_G['forum_attachtags'] = '';
        $_G['tid'] = $post['tid'];

        // 去掉干扰码
        $_G['forum']['jammer'] = 0;
        // 用户组默认允许访问图片
        $_G['group']['allowgetimage'] = 1;

        $postlist = array();
        //处理帖子内容
        $post = viewthread_procpost($post, $lastvisit, $ordertype, $maxposition);

        $postlist[$post['pid']] = $post;
        //处理帖子附件
        if ($_G['forum_attachpids'] && !defined('IN_ARCHIVER')) {
            require_once libfile('function/attachment');
            if (is_array($threadsortshow) && !empty($threadsortshow['sortaids'])) {
                $skipaids = $threadsortshow['sortaids'];
            }
            parseattach($_G['forum_attachpids'], $_G['forum_attachtags'], $postlist, $skipaids);
        }

        //如果找不到内容
        if ( empty($postlist)  )
        {

        }
        elseif( !defined('IN_MOBILE_API') )
        {
            foreach($postlist as $pid => $post)
            {
                // 取出没有插入的附件
                if (!empty($post['imagelist']))
                {
                    $postlist[$pid]['message'] .= showattach($post, 1);
                }

                if($post['attachlist'])
                {
                    $postlist[$pid]['message'] .= showattach($post);
                }

                $postlist[$pid]['message'] = preg_replace("/\[attach\]\d+\[\/attach\]/i", '', $postlist[$pid]['message']);
            }
        }

        //将主题帖内容转换成 需要购买的文案
        if ($post['first'] && $_G['forum_threadpay']) {
            $postlist[$pid]['message'] = $thread['freemessage'];
        }

        // 处理楼层屏蔽
        $shield = 0;
        if (($postlist[$pid]['status'] & 1)) {
            if( $_G['forum']['ismoderator']  )
            {
                $postlist[$pid]['message'] = Tool::getInstance()->lang( 'shield by manager to admin' ) . '<p></p>' . $postlist[$pid]['message'];
            }
            else
            {
                if($type == 1){
                    //是主题的情况
                    $postlist[$pid]['message'] = Tool::getInstance()->lang( 'shield by manager to user' );
                }else{
                    $postlist[$pid]['message'] = Tool::getInstance()->lang( 'shield by manager' );
                }

            }
            $shield = 1;
        }

        // 已经屏蔽过
        if( !$shield )
        {
            if( $_G['setting']['bannedmessages'] & 1 && (($post['authorid'] && !$post['username']) || ($_G['thread']['digest'] == 0 && ($post['groupid'] == 4 || $post['groupid'] == 5 || $post['memberstatus'] == '-1') )) )
            {
                if( $_G['forum']['ismoderator'] )
                {
                    $postlist[$pid]['message'] = Tool::getInstance()->lang( 'author shield by manager to admin' ) . '<p></p>' .
                        $postlist[$pid]['message'] ;
                }
                else
                {
                    if($type == 1){
                        //是主题的情况
                        $postlist[$pid]['message'] = Tool::getInstance()->lang( 'author shield by manager to user' );
                    }else{
                        $postlist[$pid]['message'] = Tool::getInstance()->lang( 'author shield by manager' );
                    }

                }
            }
        }

        return $postlist[$post['pid']];
    }

    /**
     * 处理POST的内容
     * @param $content
     * @return mixed
     */
    public static function handlePostContent( $content )
    {
        global $_G;
        //处理\r \n
        $content = str_replace("\r", '', $content);
        $content = str_replace("\n", '', $content);

        //处理引用内容 to do

        // 处理图片缩略图
        $content = preg_replace('/<style>.*?<\/style>/', '', $content);

        // 处理表情
        if( preg_match_all('/<img src="(.[^>)]+?)" smilieid="(\d+)".*?>/', $content, $matches) )
        {
            foreach( $matches[1] as $key => $val )
            {
                if( !is_int(strpos( $val, 'http://' )) && !is_int(strpos( $val, 'https://' )) )
                {
                    $content = str_replace( $matches[0][$key], '<img src="' . rtrim($_G['setting']['siteurl'], '/') . '/' . ltrim( $val, '/' ) . '" smilieid="' . $matches[2][$key] . '" width="24" height="24" />', $content );
                }
            }
        }

        if( preg_match_all( '/<ignore_js_op>[\s\S]+?<\/ignore_js_op>/', $content, $matches ) )
        {
            // 处理下载附件
            $attachPattern = '/<a.*?href=\"(.+?)\".*?>(.+?)<\/a>/';
            // 处理图片附件
            $imgPattern = "/<img.*?id=\".*?\".*?aid=\"(\d+)\".*?(zoomfile|makefile)=\"(.+?)\".*?\/>/";
            foreach( $matches[0] as $key => $val )
            {
                if( preg_match( $imgPattern, $val, $match ) )
                {
                    if( !is_int( strpos( $match[3], $_G['setting']['siteurl'] ) ) && is_int( strpos( $match[3],
                                'forum.php' )
                        ) )
                    {
                        $match[3] = rtrim( $_G['setting']['siteurl'] , '/' ) . '/' . $match[3];
                    }
                    $content = str_replace( $matches[0][$key], '<div style="text-align: center;"><img aid="' . $match[1] . '" src="' . $match[3]
                        . '" /></div>', $content );
                }
                elseif( preg_match($attachPattern, $val, $match) )
                {

                    $content = str_replace( $matches[0][$key], '', $content );
                }


            }
        }

        //qq交谈
        if(preg_match_all('/\[qianfan_qq\](.+?)\[\/qianfan_qq\]/', $content, $matches)) {
            foreach( $matches[1] as $key => $val ) {
                $content = str_replace( $matches[0][$key], '<a href="mqq://im/chat?chat_type=wpa&uin='.$matches[1][$key].'&version=1&src_type=web" target="_blank"><img src="static/image/common/qq_big.gif" border="0"></a><br/>', $content );

            }
        }

        return $content;
    }

    /**
     * 更新帖子阅读量
     * @param $tableid
     */
    public static function updateThreadViews( $tableid , $readnum = 1 )
    {
        global $_G;
        $reads = intval(Yii::app()->params['cloud_reads']);
        if(!is_numeric($reads)){
            $reads = 1;
        }
        $reads = $reads * $readnum;//缓存过来的值
        if(!$_G['setting']['preventrefresh'] || $_G['cookie']['viewid'] != 'tid_'.$_G['tid']) {
            if(!$tableid && $_G['setting']['optimizeviews']) {
                if($_G['forum_thread']['addviews']) {
                    if($_G['forum_thread']['addviews'] < 100) {
                        //C::t('forum_threadaddviews')->update_by_tid($_G['tid']);
						DB::query('UPDATE %t SET `addviews`=`addviews`+%d WHERE tid=%d', array('forum_threadaddviews',$reads, $_G['tid']));
                    } else {
                        if(!discuz_process::islocked('update_thread_view')) {
                            $row = C::t('forum_threadaddviews')->fetch($_G['tid']);
                            C::t('forum_threadaddviews')->update($_G['tid'], array('addviews' => 0));
                            C::t('forum_thread')->increase($_G['tid'], array('views' => $row['addviews']+$reads), true);
                            discuz_process::unlock('update_thread_view');
                        }
                    }
                } else {
                    C::t('forum_threadaddviews')->insert(array('tid' => $_G['tid'], 'addviews' => $reads), false, true);
                }
            } else {
                C::t('forum_thread')->increase($_G['tid'], array('views' => $reads), true, $tableid);
            }
        }
    }

    /**
     * 帖子附件地址
     * @param $attach
     * @return string
     */
    public static function getAttachUrl( $attach )
    {
        global $_G;
        $attachUrl = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']).'forum/';
        return $attachUrl . $attach['attachment'];
    }

    /**
     * 获取投票贴信息
     * 使用该方法先加载qianfan/protected/components/func/forum_viewthread.php
     * @param $tid
     * @return array
     */
    public static function getVoteInfo($tid)
    {
        global $_G;
        $_G['tid'] = $tid;
        $_G['forum_thread']['starttime'] = gmdate($_G['forum_thread']['dateline']);
        $_G['forum_thread']['remaintime'] = '';
        $polls = $polloptions = array();
        require_once libfile('function/forumlist');
        require_once libfile('thread/poll', 'include');

        $voters = array_slice($voters, 0, 20);
        if(!empty($voters)) {
            $user = DB::fetch_all('SELECT uid,username FROM %t WHERE uid IN (%n)', array('common_member', $voters));
        }

        if(isset($options) && isset($expiration)) {
            $polls = array
            (
                'allowvotepolled' => intval(!$allowvotepolled), // 是否已经投过票
                'visiblepoll' => $visiblepoll, // 是否可见
                'isimage' => intval($isimagepoll), // 是否是图片投票
                'multiple' => $multiple, // 是否多选，checkbox or radio
                'maxchoices' => $maxchoices, // 最大可选数
                'expiration' => $expiration, // 过期时间
                'overt' => $overt, // 是否公开投票参与人
                'voters' => $voterscount, //  投票人数
                'data' => $polloptions,
                'user' => $user
            );
        }

        return $polls;
    }
	
    /**
     * 活动贴的重新编辑
     * @param $topic
     * @return array
     */
    public static function getActivityThread( $topic )
    {
        global $_G;
        $activity = DB::fetch_first( "SELECT * FROM %t WHERE tid = %d LIMIT 1",array('forum_activity',$topic['tid']) );
        if(!empty($activity)){
            //$apply已经参与活动的人的消息
            $apply = DB::fetch_all( "SELECT * FROM %t WHERE tid = %d",array('forum_activityapply',$topic['tid']) );
            $numbs = 0; //已通过审核的人数
            if(!empty($apply)){
                foreach($apply as $val){
                    if($val['verified'] == 1)$numbs++;
                }
            }
            //编码转换
            if( strtoupper( $_G['charset'] ) != 'UTF-8' )
            {
                foreach($activity as &$value){
                    if(is_string($value)){
                        $value = iconv( 'GBK', 'UTF-8//IGNORE', $value );
                    }
                }
                unset($value);
                if(!empty($apply)){
                    foreach($apply as &$val){
                        foreach($val as &$v){
                            if(is_string($v)){
                                $v = iconv( 'GBK', 'UTF-8//IGNORE', $v );
                            }
                        }
                    }
                    unset($v);
                    unset($val);
                }
            }
            $uids = array();//已参加的 uids
            $content_app = ''; //已通过的详细内容
            if(!empty($apply)){
                $content_app .= '<p >已通过 ('.$numbs.' 人)</p><table >
                        <tr><th >&nbsp;</th><th >每人花销</th><th>申请时间</th></tr>';
                foreach($apply as $val){
                    $val['payment'] = $val['payment'] == -1 ? '自付' : $val['payment'].'元';
                    if(time() - $val['dateline'] > 0){
                        $day = floor((time() - $val['dateline'])/(3600*24));//日期显示的微调
                        if($day < 1 && $val['dateline'] < strtotime(date('Y-m-d',time())))$day =1;
                        switch($day){
                            case 0:
                                $val['dateline'] = date('H:i',$val['dateline']);
                                break;
                            case 1:
                                $val['dateline'] = '昨天&nbsp;'.date('H:i',$val['dateline']);
                                break;
                            case 2:
                                $val['dateline'] = '前天&nbsp;'.date('H:i',$val['dateline']);
                                break;
                            default:
                                $val['dateline'] = $day.'天前&nbsp;'.date('H:i',$val['dateline']);
                        }
                    }else{
                        $val['dateline'] = date('Y-m-d H:i',$val['dateline']);  //前天&nbsp;09:53
                    }

                    $content_app .='<tr><td><a >'.$val['username'].'</a></td><td>'.$val['payment'].'</td><td>'.$val['dateline'].'</td></tr>';
                    $uids[] = $val['uid'];
                }
                $content_app .= '</table>';
                unset($val);
            }

            $act = array();//暂时这个数组没用
            $act['category'] = $activity['class'];
            $act['start_time'] = date('Y-m-d H:i',$activity['starttimefrom']);
            $act['end_time'] = $activity['starttimeto'];
            $act['address'] = $activity['place'];
            $act['per_cash'] = $activity['cost'];
            $act['applynumber'] = $activity['applynumber'];  //&nbsp;请在pc端进行管理
            $act['listnumber'] = $activity['number'] - $numbs;
            $act['last_time'] = date('Y-m-d H:i',$activity['expiration']);
            $act['gender'] = $activity['gender'] == 0? '不限' : ($activity['gender'] == 1 ? '男' : '女');
            //输出信息调整
            if($act['end_time'] != 0){
                $act['start_time'] = $act['start_time']. '至 '.date('Y-m-d H:i',$act['end_time']).' 商定';
            }
            if($_G['uid'] && $_G['uid']==$topic['authorid']){
                $act['applynumber'] = $act['applynumber'].'</em> 人&nbsp;请在pc端进行管理';
            }else{
                $act['applynumber'] = $act['applynumber'].'</em> 人';
            }

            $content_act = '';//活动的详细
            $content_act .= '<dt>活动类型: <strong>'.$act['category'].'</strong></dt>
                                <dt>开始时间:'.$act['start_time'].'</dt>
                                <dt>活动地点: '.$act['address'].' </dt>
                                <dt>性别:'.$act['gender'].'</dt>
                                <dt>每人花销: '.$act['per_cash'].' 元</dt>
                                <dt>已报名人数:<em>'.$act['applynumber'].'
                                <dt>剩余名额:'.$act['listnumber'].' 人</dt>
                                <dt>报名截止: '.$act['last_time'].'</dt>';
            if($_G['uid'] && !empty($uids) && in_array($_G['uid'],$uids)){
                $content_act .= '<p>您已经参加了此活动</p>';
            }
            //统一编码
            if( strtoupper( $_G['charset'] ) != 'UTF-8' ) {
                $content_act = mb_convert_encoding($content_act, 'gbk', 'utf-8');
                $content_app = mb_convert_encoding($content_app, 'gbk', 'utf-8');
            }
            $content_act = addslashes($content_act);
            $content_app = addslashes($content_app);

            return array(
                'act' =>$content_act,
                'app' =>$content_app
            );
        }else{
            Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
        }
    }

    /**
     * 商品贴的重新编辑
     * @param $topic
     * @return array
     */
    public static function getTradeThread( $topic )
    {
        global $_G;
        $trade = DB::fetch_all( "SELECT * FROM %t WHERE tid = %d ",array('forum_trade',$topic['tid']) );
        if(!empty($trade)){
            //编码转换
            if( strtoupper( $_G['charset'] ) != 'UTF-8' )
            {
                foreach($trade as &$val){
                    foreach($val as &$v){
                        if(is_string($v)){
                            $v = iconv( 'GBK', 'UTF-8//IGNORE', $v );
                        }
                    }
                }
                unset($v);
                unset($val);
            }
            $content_con = '';
            $extra_pid = array();
            foreach($trade as $value){
                //商品这边商品内容的介绍跑到1楼去了
                //设置多余的楼层
                if($value['pid'] > 0){
                    $extra_pid[] = $value['pid'];
                }
                //商品类型
                $value['quality'] = $value['quality'] == 1 ? '全新商品' : '二手商品';
                //剩余时间
                $time = $value['expiration'] - time();
                if($time > 0){
                    $d = floor($time/(3600 * 24));
                    $h = floor(($time - ($d * 3600 * 24))/3600);
                    $t = $d.'天'.$h.'小时';
                }else{
                    $t = '成交结束';
                }
                //物流    3   虚拟物品
                //       1   卖家承担运费
                //       2  平邮 10 元 快递 12 元 EMS 22 元
                //      4   买家收到货物后直接支付给物流公司平邮 10 元 快递 12 元 EMS 22 元
                //      0   线下交易
                $transport = $value['transport'];
                $fee = '';
                if($value['ordinaryfee'] > 0) $fee .= '平邮&nbsp;'.$value['ordinaryfee'].'元&nbsp;';
                if($value['expressfee'] > 0) $fee .= '快递&nbsp;'.$value['expressfee'].'元&nbsp;';
                if($value['emsfee'] > 0) $fee .= 'EMS&nbsp;'.$value['emsfee'].'元';
                switch($transport){
                    case 0:
                        $transport = '线下交易';
                        break;
                    case 1:
                        $transport = '卖家承担运费';
                        break;
                    case 2:
                        if($fee == '')$fee = '无运费';
                        $transport = $fee;
                        break;
                    case 3:
                        $transport = '虚拟物品';
                        break;
                    case 4:
                        $transport = '买家收到货物后直接支付给物流公司'.$fee;
                        break;
                    default:
                        $transport = '';
                }
                if($transport)$transport = '<dt>运费:&nbsp;'.$transport.'</dt>';
                $address = $value['locus'] ? '<dt>地点:&nbsp;'.$value['locus'].'</dt>' : '';
                $content_con .= '<special><h4>'.$value['subject'].'</h4>
                                            <dt>商品类型:&nbsp;'.$value['quality'].'</dt>
                                            '.$transport.'
                                            <dt>商品数量:&nbsp;'.$value['amount'].'</dt>
                                            <dt>累计售出:&nbsp;'.$value['totalitems'].'</dt>
                                            '.$address.'
                                            <dt>剩余时间:&nbsp;'.$t.'</dt>
                                            <strong>'.$value['price'].'</strong>&nbsp;元&nbsp;&nbsp;
                                            <p ><del>'.$value['costprice'].' 元</del></p></special>[re]'.$value['pid'].'[/re]<br>';

            }

            if( strtoupper( $_G['charset'] ) != 'UTF-8' ) {
                $content_con = mb_convert_encoding($content_con, 'gbk', 'utf-8');
            }
            $content_con = addslashes($content_con);

            return array(
                'con'=>$content_con,
                'pid'=>$extra_pid
            );

        }else{
            Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
        }
    }

    //获取分类信息相关类容
    public static function getSortInfo($sortid, $tid, $sort, $postdate) {
        global $_G;
        require_once libfile('function/threadsort');
        $sortMessage = '';
        if(!function_exists('threadsortshow')) {
            return $sortMessage;
        }
        $threadsortshow = threadsortshow($sortid, $tid);
        if( strtoupper( $_G['charset'] ) != 'UTF-8' ) {
            foreach($threadsortshow['optionlist'] as &$val){
                foreach($val as &$vv){
                    foreach($vv as &$v) {
                        if (is_string($v)) {
                            $v = iconv('GBK', 'UTF-8//IGNORE', $v);
                        }
                    }
                }
            }
            unset($v);
            unset($val);
        }
        if($threadsortshow['optionlist'] == 'expire') {
            $sortMessage = '该信息已经过期';
        }else{
            if( !empty($threadsortshow['optionlist']) && is_array($threadsortshow['optionlist']) ) {
                $html = '<div class="typeoption"><table summary="threadsort" cellpadding="0" cellspacing="0" class="cgtl"><tr><th colspan="2" class="sorttitle">'.$sort.'</th></tr>';
                $htmlString = '';
                foreach($threadsortshow['optionlist'] as $val) {
                    if($val != 'info') {
                        $htmlStr = '<tr><th>'.$val['title'].'</th><td>'.$val['value'].$val['unit'].'</td></tr>';
                        $htmlString .= $htmlStr;
                    }
                }
                $htmlString .= '</table></div>';
                $html .= $htmlString;
                $sortMessage = $html;
                if( strtoupper( $_G['charset'] ) != 'UTF-8' ) {
                    $sortMessage = mb_convert_encoding($sortMessage, 'utf-8', 'gbk');
                }
                if(preg_match_all('/<td><a href="([^"]*)"([^<]*)>点击查看<\/a>([^<]*)<\/td>/i', $sortMessage, $matches)) {
                    foreach( $matches[1] as $key => $val ) {
						$sortMessage = str_replace( $matches[0][$key], '<td><img sortid="'.$sortid.'" aid="'.$threadsortshow['sortaids'][$key].'" src="'.$matches[1][$key]. '"></td>', $sortMessage );
                    }
                }elseif(preg_match_all('/<td>data\/attachment([^<]*)<\/td>/i', $sortMessage, $matches)){
					foreach( $matches[1] as $key => $val ) {
                        $sortMessage = str_replace( $matches[0][$key], '<td><img sortid="'.$sortid.'" aid="'.$threadsortshow['sortaids'][$key].'" src="data/attachment'.$matches[1][$key]. '"></td>', $sortMessage );
                    }
				}elseif(preg_match_all('/<td><img src="([^"]*)"([^<]*)>([^<]*)<\/td>/i', $sortMessage, $matches)){
					foreach( $matches[1] as $key => $val ) {
						$sortMessage = str_replace( $matches[0][$key], '<td><img sortid="'.$sortid.'" aid="'.$threadsortshow['sortaids'][$key].'" src="'.$matches[1][$key]. '"></td>', $sortMessage );
                    }
				}

            }

        }
        // 分类信息期限
        $expi = DB::fetch_all('SELECT expiration FROM %t WHERE tid=%d', array('forum_typeoptionvar', $tid));
        if($expi[0]['expiration'] != 0){
            if( (time()-$expi[0]['expiration']) > 0 ) {
                $sortMessage .= '<i>该信息已超过有效期，内容可能已失效</i><br>'.PHP_EOL;
            }
        }
//        if( !empty($postdate) && (time()-$postdate) > 8640000 ) {
//            $sortMessage .= '<i>该信息已超过100天，内容可能已失效</i><br>'.PHP_EOL;
//        }
        if( strtoupper( $_G['charset'] ) != 'UTF-8' ) {
            $sortMessage = mb_convert_encoding($sortMessage, 'gbk', 'utf-8');
        }

        $sortImg = array();
        if( preg_match_all('/<td><img.*?src=\"(.*?)\".*?><\/td>/i', $sortMessage, $matches) ) {
            $sortImg = $matches[1];
        }

        return array($sortMessage, $sortImg);
    }

    /**
     * 处理内容中img标签图片，下载到本地
     * @param $img
     * @param int $time
     * @param int $timeout
     * @return array|bool
     *
     */
    public static function uploadImg($img, $time=5) {
        $save_dir = Yii::app()->getRuntimePath() . DIRECTORY_SEPARATOR;
        if(trim($save_dir) == '') {
            return false;
        }
        $filename = '';
        if( preg_match('/^http.*?:\/\/.*?(\/(.+?)\.(png|jpg|jpeg|gif|bmp)).*?/i', $img, $matchs) ) {
            $imgName  = $matchs[1];
            if( preg_match('/([^\/])+$/', $imgName, $matchs) ) {
                $filename = $matchs[0];
            }
        }
        //创建保存目录
        if ( !is_dir($save_dir) && !mkdir($save_dir, 0777, true) && empty($filename) ) {
            return false;
        }
        $path = $save_dir . $filename;
        if ( file_exists($save_dir . $filename) ) {
            return array('tmp_name' => $path, 'name' => $filename, 'type' => 'image/jpeg');
        }

        //获取远程文件
        $content = @dfsockopen($img, 0, '', '', FALSE, '', $time);

        if( !$content ) {
            return false;
        }
//        if( empty($content) ) {
//            $ch = curl_init();
//            curl_setopt($ch, CURLOPT_URL, $img);
//            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
//            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
//            curl_setopt($ch , CURLOPT_TIMEOUT, $time);
//
//            $content = curl_exec($ch);
//            $status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
//            if( $status != 200 ) {
//                return false;
//            }
//            curl_close($ch);
//        }
        $fp2 = @fopen($save_dir . $filename, 'wb');
        fwrite($fp2, $content);
        fclose($fp2);
        unset($content, $smiles_url);
        return array('tmp_name' => $path, 'name' => $filename, 'type' => 'image/jpeg');
    }

    /**
     * 把下载下来的图片，移动到data/attachment/对应文件夹，并且生成aid，插入对应表
     *
     * @param $file
     * @param $uid
     * @param string $type
     * @param int $extid
     * @param string $forcename
     * @return bool
     */
    public static function qianfanUpload($file, $uid, $type = 'forum', $extid = 0, $forcename = '') {
        global $_G;

        $attach = $file;
        $attach['name'] =  trim($file['name']);
        $attach['size'] = filesize($file['tmp_name']);
        $attach['thumb'] = '';
        $upload = new discuz_upload();
        $attach['ext'] = $upload->fileext($file['name']);
        $type = $upload->check_dir_type($type);

        $attach['name'] =  dhtmlspecialchars($file['name'], ENT_QUOTES);
        if(strlen($attach['name']) > 90) {
            $attach['name'] = cutstr($file['name'], 80, '').'.'.$file['ext'];
        }
        $attach['isimage'] = $upload->is_image_ext($attach['ext']);
        $attach['extension'] = $upload->get_target_extension($attach['ext']);
        $attach['attachdir'] = $upload->get_target_dir($type, $extid);
        $attach['attachment'] = $attach['attachdir'].$upload->get_target_filename($type, $extid, $forcename).'.'.$attach['extension'];
        $attach['target'] = getglobal('setting/attachdir').'./'.$type.'/'.$attach['attachment'];

        // 复制到dz/data/attachment/对应文件夹
        $source = $attach['tmp_name'];
        $target = $attach['target'];
        if(@copy($source, $target)) {
            $succeed = true;
        }elseif(function_exists('move_uploaded_file') && @move_uploaded_file($source, $target)) {
            $succeed = true;
        }elseif (@is_readable($source) && (@$fp_s = fopen($source, 'rb')) && (@$fp_t = fopen($target, 'wb'))) {
            while (!feof($fp_s)) {
                $s = @fread($fp_s, 1024 * 512);
                @fwrite($fp_t, $s);
            }
            fclose($fp_s); fclose($fp_t);
            $succeed = true;
        }
        if($succeed)  {
            @chmod($target, 0644); @unlink($source);
        } else {
            return false;
        }

        // 插入数据库
        $aid = getattachnewaid($uid);
        list($width,$height) = @getimagesize($attach['target']);

        if( $width*$height > 1280*1280 ) {
            return false;
        }

        $insert = array(
            'aid' => $aid,
            'dateline' => $_G['timestamp'],
            'filename' => dhtmlspecialchars(censor($attach['name'])),
            'filesize' => $attach['size'],
            'attachment' => $attach['attachment'],
            'isimage' => $attach['isimage'],
            'uid' => $uid,
            'thumb' => 0,
            'remote' => 0,
            'width' => $width,
        );
        C::t('forum_attachment_unused')->insert($insert);
        if($attach['isimage'] && $_G['setting']['showexif']) {
            require_once libfile('function/attachment');
            $exif = getattachexif(0, $attach['target']);
            C::t('forum_attachment_exif')->insert($aid, $exif);
        }

        return $aid;
    }

}