<?php

$php_version = phpversion();
$wp_version = '5.3.0'; //_DIR_只能在5.3以上版本使用
if(version_compare( $php_version, $wp_version, '>='))
{
	$data_path = dirname(__DIR__);
}else{
	$dir = dirname(__FILE__);
	$data_path = dirname($dir);
}
if(is_dir($data_path)){
	$qianfan_data_path = realpath($data_path . '/../../../../data/') . '/qianfan/';
	if (!is_writable($qianfan_data_path)) {
		!is_dir($qianfan_data_path) && mkdir($qianfan_data_path, 0777, true);
		chmod($qianfan_data_path, 0777);
	}
	$qianfan_runtime_path = $qianfan_data_path . 'runtime';
	if (!is_writable($qianfan_runtime_path)) {
		!is_dir($qianfan_runtime_path) && mkdir($qianfan_runtime_path, 0777, true);
		chmod($qianfan_runtime_path, 0777);
	}
	$qianfan_assets_path = $qianfan_data_path . 'assets';
	if (!is_writable($qianfan_assets_path)) {
		!is_dir($qianfan_assets_path) && mkdir($qianfan_assets_path, 0777, true);
		chmod($qianfan_assets_path, 0777);
	}
}
return array(
	'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
	'runtimePath' => $qianfan_runtime_path,
	'name'=>'QianfanAppPlugin',

	'preload'=>array('log'),

	'import'=>array(
		'application.models.*',
		'application.components.*'
	),

	'language' => 'zh_cn',

	'charset' => 'GBK',

	'modules'=>array(

	),

	'components'=>array(
		'assetManager'=>array(
			'basePath'=> $qianfan_assets_path
		),

		'errorHandler'=>array(
			'errorAction'=>'site/error',
		),

		// Yii cache
		'cache' => array(
			'class' => 'system.caching.CFileCache',
			'directoryLevel' => 2
		),

		'log'=>array(
			'class'=>'CLogRouter',
			'routes'=>array(
				array(
					'class'=>'CFileLogRoute',
					'levels'=>'error, warning, info',
				),
			),
		),

	),

	'params'=>array(
		'site_charset' => 'GBK',
		'api_version' => '1.0.9'
	),
);
