<?php
/**
 * QIANFAN 找回密码
 * Created by PhpStorm.
 * User: leeyifiei
 * Date: 16/2/19
 * Time: 下午4:06
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}


class FindpwdController extends PluginController
{

    public $layout = '//findpwd/layouts/base';

    public $scriptPath;

    public function init()
    {
        parent::init();

        $pathAry = array(
            '.', 'source', 'plugin', 'qianfan', 'static', 'findpwd', 'js', ''
        );
        $this->scriptPath = implode(DIRECTORY_SEPARATOR, $pathAry);
    }

    /**
     * 找回密码首页
     */
    public function actionIndex()
    {
        global $_G;

        $this->render( 'index' );
    }

    /**
     * 设置新密码
     * @throws CHttpException
     */
    public function actionSetPwd()
    {
        $type = 0; // 用于判断是否是正常post请求，如果不是直接关闭页面
        if( !Yii::app()->request->isPostRequest )
        {
            $type = 1;;
//            throw new CHttpException('404');
        }

        $mobile = WebHelper::getPost('mobile', '');
        $yzm = WebHelper::getPost('yzm', '');

        if( !$this->_validateYzm( $mobile, $yzm) )
        {
            $type = 1;
//            throw new CHttpException(403);
        }

        $user = $this->_getUserByMobile( $mobile );
        if( empty($user) )
        {
            echo "Sorry! The user does not exist, or has been deleted by the administrator!";
            Yii::app()->end();
        }

        $this->render( 'setPwd', array(
            'user' => $user,
            'mobile' => $mobile,
            'yzm' => $yzm,
            'type' => $type
        ) );
    }

    /**
     * 重置密码
     */
    public function actionPwdReset()
    {
        if( !Yii::app()->request->isPostRequest )
        {
            throw new CHttpException(403);
        }
        $mobile = WebHelper::getPost("mobile", '');
        $yzm = WebHelper::getPost("yzm", '');
        if( !$this->_validateYzm($mobile, $yzm) )
        {
            throw new CHttpException(403);
        }

        $password = WebHelper::getPost('password', '');
        $passwordRepeat = WebHelper::getPost('password_repeat', '');

        $checkResult = $this->_validatePassword( $password, $passwordRepeat );
        if( !empty($checkResult) )
        {
            throw new CHttpException(403);
        }

        $user = $this->_getUserByMobile($mobile);
        if( empty($user) )
        {
            throw new CHttpException(404);
        }

        $uid = $user['uid'];
        loaducenter();
        $ucuser = uc_get_user( $uid, 1 );

        if( $ucuser )
        {
            $ucresult = uc_user_edit( $ucuser[1], NULL, $_POST['password'], NULL, 1 );

            if( $ucresult == -8 )
            {
                $message = $this->tplLang('user_protected');
            }
            else
            {
                C::t('common_member')->update($uid, array('password' => md5(random(10))));
                $message = $this->tplLang('reset_message', array('{username}' => $user['username']));
                // 销毁验证码记录
                Yii::app()->cache->delete("find_password_mobile_" . $mobile);
            }
        }

        $this->render("finish", array(
            'message' => $message,
            'user' => $user
        ));
    }

    /**
     * 发送验证码
     */
    public function actionSendYzm()
    {

        if( !Yii::app()->request->isPostRequest || !Yii::app()->request->isAjaxRequest )
        {
            throw new CHttpException('404');
        }

        global $_G;

        $mobile = WebHelper::getPost( "mobile", '' );

        $data = array(
            "ret" => 1,
            "text" => '发送失败'
        );

        // 手机合法验证
        if( !preg_match('/^1[34578]{1}\d{9}$/', $mobile, $match) ) {
            $data['text'] = "请填写正确的手机号";
        }
        // 手机号是否绑定用户
        elseif( !$uid = DB::result_first( "SELECT uid FROM %t WHERE phone = %s LIMIT 1", array( "phonebind", $mobile ) ) )
        {
            $data['text'] = '该手机号尚未绑定任何用户';
        }
        elseif( !DB::fetch_first("SELECT * FROM %t WHERE uid=%d LIMIT 1", array("common_member", $uid)) )
        {
            $data['text'] = '没有匹配到用户名，请联系管理员';
        }
        else
        {
            // 生成验证码
            $verifyCode = random(6,int);
            $param = array(
                'mobile' => $mobile,
                'content' => mb_convert_encoding( '找回密码，你的验证码为：' . $verifyCode . '【验证码】', 'GBK', 'UTF-8')
            );

            //$response = @file_get_contents( Yii::app()->params['cloud_host'] . 'api/send-sms?' . http_build_query($param) );
			//重新兼容下
			$requestUrl = trim(Yii::app()->params['cloud_host'],' /') . '/api/send-sms?' . http_build_query($param);
			$response = @dfsockopen($requestUrl, 0,array(), '', 0, '', 1, 1, 'URLENCODE', 1, 0);
			//临时兼容 上面2个 都不管用
			if($response == null){
				$ch = curl_init();
				$timeout = 10;
				curl_setopt ($ch, CURLOPT_URL, $requestUrl);
				curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
				curl_setopt ($ch, CURLOPT_USERAGENT , 'qianfan iphone');
				$response = curl_exec($ch);
				//$status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
				curl_close($ch);
			}
            $response = CJSON::decode($response);
            if( $response['ret'] === 0 )
            {
                Yii::app()->cache->set( "find_password_mobile_" . $mobile, $verifyCode, 600 );

                $data['ret'] = 0;
                $data['text'] = '发送成功';
            }
            else
            {
                $data['text'] = $response['text'];
            }
        }

        echo $this->ajaxResponse($data);
        Yii::app()->end(0);
    }

    /**
     * AJAX VALIDATE YZM
     */
    public function actionValidateYzm()
    {
        if( !Yii::app()->request->isPostRequest || !Yii::app()->request->isAjaxRequest )
        {
            throw new CHttpException('404');
        }

        $mobile = WebHelper::getPost("mobile", "");
        $yzm = WebHelper::getPost("yzm", "");

        $data = array(
            'ret' => 1,
            'text' => '验证码不正确'
        );

        if( $this->_validateYzm($mobile, $yzm) )
        {
            $data['ret'] = 0;
            $data['text'] = '';
        }

        echo $this->ajaxResponse( $data );
    }

    /**
     * AJAX VALIDATE PASSWORD
     */
    public function actionValidatePassword()
    {
        if( !Yii::app()->request->isPostRequest || !Yii::app()->request->isAjaxRequest )
        {
            throw new CHttpException('404');
        }

        global $_G;

        $password = WebHelper::getPost('password', '');
        $passwordRepeat = WebHelper::getPost('password_repeat', '');

        $data = array(
            'ret' => 1,
            'text' => '密码填写不正确'
        );

        $strongpw_str = $this->_validatePassword($password,$passwordRepeat);
        if($strongpw_str)
        {
            $data['text'] = implode("\r\n", $strongpw_str);
        }
        else
        {
            $data['ret'] = 0;
            $data['text'] = '';
        }

        echo $this->ajaxResponse($data);
    }

    /**
     * 验证密码
     * @param $password
     * @param $password_repeat
     * @return array
     */
    public function _validatePassword( $password, $password_repeat )
    {
        global $_G;
        $setting = $_G['setting'];
        $strongpw_str = array();

        if( $password != $password_repeat )
        {
            $strongpw_str[] = '两次输入的密码不一致';
        }

        // 密码长度验证
        if( $setting['pwlength'] )
        {
            if(strlen($password) < $setting['pwlength']) {
                $strongpw_str[] = '密码不能少于' . $setting['pwlength'] . '位';
            }
        }

        // 密码复杂度验证
        if( $setting['strongpw'] )
        {
            if(in_array(1, $setting['strongpw']) && !preg_match("/\d+/", $_GET['password'])) {
                $strongpw_str[] = '密码中必须包含数字';
            }
            if(in_array(2, $setting['strongpw']) && !preg_match("/[a-z]+/", $_GET['password'])) {
                $strongpw_str[] = '密码中必须包含小写字母';
            }
            if(in_array(3, $setting['strongpw']) && !preg_match("/[A-Z]+/", $_GET['password'])) {
                $strongpw_str[] = '密码中必须包含大写字母';
            }
            if(in_array(4, $setting['strongpw']) && !preg_match("/[^a-zA-z0-9]+/", $_GET['password'])) {
                $strongpw_str[] = '密码中必须包含特殊符号';
            }
        }

        return $strongpw_str;
    }

    /**
     * 通过手机号获取用户
     * @param $mobile
     * @return array|null
     */
    private function _getUserByMobile( $mobile )
    {
        $user = null;
        if( $mobile )
        {
            $uid = DB::result_first("SELECT * FROM %t WHERE phone=%s", array("phonebind", $mobile));
            if( $uid )
            {
                $user = DB::fetch_first("SELECT * FROM %t WHERE uid=%d LIMIT 1", array("common_member", $uid));

            }
        }

        return $user;
    }

    /**
     * 判断手机、验证码是否匹配
     * @param $mobile
     * @param $yzm
     * @return bool
     */
    private function _validateYzm( $mobile, $yzm )
    {
        if( !$mobile || !$yzm )
        {
            return false;
        }

        if( Yii::app()->cache->offsetExists("find_password_mobile_" . $mobile) )
        {
            $cacheYzm = Yii::app()->cache->get("find_password_mobile_" . $mobile);
            if( $cacheYzm == $yzm )
            {
                return true;
            }
        }

        return false;
    }
}