<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/24
 * Time: 下午2:38
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ForumController extends Controller
{

    /**
     * 板块分类
     */
    public function actionForumcategory()
    {
        $forumGroups = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d ORDER BY displayorder ASC", array( 'forum_forum', 'group', 1 ));

        $all = array('forums' => array());
        if( !empty( $forumGroups ) )
        {
            foreach( $forumGroups as $key => $group )
            {
                $g = array();
                $forums = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d AND fup = %d", array( 'forum_forum', 'forum', 1, $group['fid'] ));

                $g['fid'] = $group['fid'];
                $g['name'] = Tool::getInstance()->stripHtmlTags( $group['name'] );
                $g['child'] = array();

                if( !empty( $forums ) )
                {
                    foreach( $forums as $k => $v )
                    {
                        $g['child'][$k]['fid'] = $v['fid'];
                        $g['child'][$k]['name'] = Tool::getInstance()->stripHtmlTags( $v['name'] );
                        $g['child'][$k]['isFavored'] = 0;
                        $g['child'][$k]['tpost'] = 0;
                        $g['child'][$k]['lastpost'] = '';
                        $g['child'][$k]['lastposter'] = '';
                        $g['child'][$k]['contentmin'] = 0;
                        $g['child'][$k]['child'] = array();
                        $subs = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d AND fup = %d", array( 'forum_forum', 'sub', 1, $v['fid'] ));
                        if( !empty($subs) )
                        {
                            foreach( $subs as $j => $s )
                            {
                                $g['child'][$k]['child'][$j]['fid'] = $s['fid'];
                                $g['child'][$k]['child'][$j]['name'] = Tool::getInstance()->stripHtmlTags( $s['name'] );
                                $g['child'][$k]['child'][$j]['isFavored'] = 0;
                                $g['child'][$k]['child'][$j]['tpost'] = 0;
                                $g['child'][$k]['child'][$j]['lastpost'] = '';
                                $g['child'][$k]['child'][$j]['lastposter'] = '';
                                $g['child'][$k]['child'][$j]['contentmin'] = 0;
                            }
                        }
                    }
                }

                $all['forums'][] = $g;
            }
        }

        Tool::getInstance()->success_json( $all );
    }

    /**
     * 主题列表
     * 注意点
     * 是否显示置顶帖
     * 是否显示附件
     * 性能调优
     */
    public function actionGetthreads()
    {
        //板块ID
        $fid = Yii::app()->request->getPost( 'fid', 0 );
        //只看精华帖
        $digest = Yii::app()->request->getPost( 'digest', 0 );
        //排序方式  1 发帖日期倒序 0 最后回复时间倒序
        $ordertype = Yii::app()->request->getPost( 'ordertype', 0 );
        //SQL OFFSET
        $offset = dintval( Yii::app()->request->getPost( 'offset', 0 ) );
        //SQL LIMIT
        $limit = dintval( Yii::app()->request->getPost( 'limit', 0 ) );
        //上次列表页最后的帖子ID
        $lastid = dintval( Yii::app()->request->getPost( 'lastid', 0 ) );
        //是否显示图片附件
        $isshowattach = Yii::app()->request->getPost( 'isshowattach', 0 );
        //是否显示置顶帖
        $showtopthread = WebHelper::getPost('showtopthread', 0);

        // 2.0新增参数
        // 分类信息id
        $sortid = WebHelper::getPost('sortid', 0);

        // 主题分类id
        $typeid = WebHelper::getPost('typeid', 0);

        // 分类项目筛选信息，json字符串
        $sortinfo = WebHelper::getPost('sortinfo', '');

        // 2.0.0新版的参数，用来兼容旧版
        $type = WebHelper::getPost('type', 0);

        global $_G;
        if( $fid > 0 )
        {
            if( !function_exists('loadforum') )
            {
                require_once( libfile( 'function/forum' ) );
            }
            require_once( Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php' );

            loadforum( $fid );
            //检查是否该板块不存在
            if( !$_G['forum']['fid'] )
            {
                Tool::getInstance()->fail_json( Code::FORUM_NOT_EXISTS, Tool::getInstance()->lang('forum not exists') );
            }

            //板块阅读权限判断
            if( $_G['forum']['viewperm'] && !forumperm($_G['forum']['viewperm']) && !$_G['forum']['allowview'] )
            {
                $res = qf_showmessagenoperm( 'viewperm', $_G['fid'], $_G['forum']['formulaperm'] );
                Tool::getInstance()->fail_json( Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags( lang('message' ,$res['message'], $res['params']) ) );
            }
            //限定只有某些用户能访问板块
            elseif ( $_G['forum']['formulaperm'] ) {
                $msg = qf_formulaperm($_G['forum']['formulaperm']);
                if ($msg['message'] != '') {
                    Tool::getInstance()->fail_json( Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags( lang('message', $msg['message'], $msg['params']) ) );
                }
            }

            //需要输入密码才能访问板块，由于客户端目前无法让用户手动输入密码，所以直接抛出错误，管理员可以访问
            if( $_G['forum']['password'] && !$_G['forum']['ismoderator'] )
            {
                Tool::getInstance()->fail_json( Code::FORUM_NEED_PASSWORD,  Tool::getInstance()->lang('need password view forum') );
            }

            //板块需要付费才能浏览，版主、管理员默认能访问
            //直接抛出错误，暂未判断其付费记录
            if($_G['forum']['price'] && !$_G['forum']['ismoderator'])
            {
                Tool::getInstance()->fail_json( Code::FORUM_NEED_PRICE, Tool::getInstance()->lang('need price view forum') );
            }

            // 置顶帖处理
            $topLists = array();
            if( $showtopthread && !$offset )
            {
                loadcache('globalstick', 'forumstick');

                $thisgid = $_G['forum']['type'] == 'forum' ? $_G['forum']['fup'] : (!empty($_G['cache']['forums'][$_G['forum']['fup']]['fup']) ? $_G['cache']['forums'][$_G['forum']['fup']]['fup'] : 0);
                $stickytids = '';
                $forumstickytids = array();

                if($_G['setting']['globalstick'] && $_G['forum']['allowglobalstick']) {
                    $stickytids = explode(',', str_replace("'", '', $_G['cache']['globalstick']['global']['tids']));
                    if(!empty($_G['cache']['globalstick']['categories'][$thisgid]['count'])) {
                        $stickytids = array_merge($stickytids, explode(',', str_replace("'", '', $_G['cache']['globalstick']['categories'][$thisgid]['tids'])));
                    }

                    if($_G['forum']['status'] != 3) {
                        $stickycount = $_G['cache']['globalstick']['global']['count'];
                        if(!empty($_G['cache']['globalstick']['categories'][$thisgid])) {
                            $stickycount += $_G['cache']['globalstick']['categories'][$thisgid]['count'];
                        }
                    }
                }

                if($_G['forum']['allowglobalstick']) {
                    $forumstickycount = 0;
                    $forumstickfid = $_G['forum']['status'] != 3 ? $_G['fid'] : $_G['forum']['fup'];
                    if(isset($_G['cache']['forumstick'][$forumstickfid])) {
                        $forumstickycount = count($_G['cache']['forumstick'][$forumstickfid]);
                        $forumstickytids = $_G['cache']['forumstick'][$forumstickfid];
                    }
                    if(!empty($forumstickytids)) {
                        $stickytids = array_merge($stickytids, $forumstickytids);
                    }
                }

                if(is_array($stickytids) && $stickytids[0])
                {
                    $filterarr1 = array(
                        'inforum' => '',
                        'intids' => $stickytids,
                        'displayorder' => array(2, 3, 4)
                    );
                    $topLists = C::t('forum_thread')->fetch_all_search($filterarr1, 0, 0, 20, 'displayorder DESC,
                    lastpost DESC', '');
                }
            }

            //开始获取帖子列表
            $filterarr = array(
                'inforum' => $_G['fid'],
                'sticky' => 4,
                'displayorder' => $showtopthread ? array(0, 1) : array(0)
            );
            //关联其他版块
            if($_G['forum']['relatedgroup']) {
                $relatedgroup = explode(',', $_G['forum']['relatedgroup']);
                $relatedgroup[] = $_G['fid'];
                $filterarr['inforum'] = $relatedgroup;
            } else {
                $filterarr['inforum'] = $_G['fid'];
            }
            //获取精华帖
            if($digest) {
                $filterarr = array(
                    'digest' => 1,
                    'inforum' => $filterarr['inforum'],
                    'sticky' => 4,
                    'displayorder' => array(0)
                );
            }

            // 主题分类
            if( !empty($typeid) ) {
                $filterarr['intype'] = intval($typeid);
            }

            // 分类信息
            if( !empty($sortid) ) {
                $filterarr['insort'] = intval($sortid);
                if( !empty($sortinfo) ) {
                    $sort = CJSON::decode($sortinfo);
                    $sortid = $sort['sortid'].' ';
                    //$tidArray = $tidArr = $tidTemp = array();
					$tidArray = $tidTemp = array();
                    $i = 0;
                    foreach( $sort['select'] as $k => $v ) {
						$tidArr = array();
                        if($v['optionid'] == 0) continue;
                        $sql['option'] = 'optionid='.$v['kindid'];
                        $sql['value'] = 'value='.$v['optionid'];

                        $sql['sql'] = ' AND '.$sql['option'].' AND '.$sql['value'];
                        $tids = DB::fetch_all( "SELECT tid from %t where sortid=".$sortid.$sql['sql'], array('forum_typeoptionvar') );
						
                        //$tidArr = array_merge($tids, $tidArr);
                        //$tidTemp = array_intersect_assoc($tids,$tidArr); // 取交集
						foreach($tids as $valued){
							$tidArr[] = $valued['tid'];
						}
						if($i == 0){
							$tidTemp = $tidArr;
						}else{
							$tidTemp = array_intersect($tidArr,$tidTemp);
						}
                        $i++;
                    }

                    foreach( $tidTemp as $kk => $vv ) {
                        if($kk>1000) break;
                        $tidArray[$kk] = $vv;
                    }

                    if( empty($tidArray) && $i != 0 ) {
                        $tidArray = array(0 => '0');
                    }
                }
            }

            //主题帖排序
            $order = 'displayorder DESC, ';
            if( $ordertype )
            {
                $order = 'dateline DESC';
            }
            else
            {
                $order = 'lastpost DESC';
            }
//            $threadlist = C::t('forum_thread')->fetch_all_search($filterarr, 0, $offset, $limit, $order, '');

            $threadlist = $this->_searchThread($filterarr, 0, $offset, $limit, $order, '', $tidArray);
            $threadlist = array_merge( $topLists, $threadlist );
			//是否开启远程附件
			$setting = C::t('common_setting')->fetch_all(null);
            $setting['ftp'] = dunserialize($setting['ftp']);
			
            $threads = array();
            if( !empty( $threadlist ) ) {
                foreach ($threadlist as $key => $val)
                {
                    $thread = array();
                    $thread['fid'] = $val['fid'];
                    $thread['fname'] = $_G['forum']['name'];
                    $thread['tid'] = intval($val['tid']);
                    $thread['subject'] = $val['subject'];
                    $thread['authorid'] = $val['authorid'];
                    $thread['author'] = $val['author'];
                    $thread['icon'] = discuz_uc_avatar( $val['authorid'], 'big', 1 );
                    $thread['postdate'] = $val['dateline'];
                    $thread['lastpost'] = $val['lastpost'];
                    $thread['lastposter'] = $val['lastposter'];
                    $thread['favors'] = $val['recommend_add'];
                    $thread['hits'] = $val['views'];
                    $thread['replies'] = $val['replies'];
                    $thread['digest'] = $val['digest'] ? 1 : 0;
                    $thread['special'] = $val['special'];
                    $thread['ifupload'] = $val['attachment'] == 2 ? 1 : 0;
                    $thread['topped'] = $val['displayorder'] > 0 ? 1 : 0;
                    $thread['attach'] = array();

                    $thread['pid'] = DB::result_first("SELECT pid FROM %t WHERE tid = %d AND first = 1", array("forum_post" , $thread['tid']));
                    //获取帖子附件
                    if( $isshowattach && ($val['attachment'] == 2 || $val['attachment'] == 1) )
                    {
						/* 图片方案和 热点贴处理方式统一，优化，解决部分图片不显示问题
                        $attachs = C::t('forum_attachment_n')->fetch_all_by_id( 'tid:' . $val['tid'], 'tid', $val['tid'], '', 1 );
                        if( !empty($attachs) )
                        {
                            $i = 0;
                            foreach( $attachs as $k => $attach )
                            {
                                if($thread['pid'] == $attach['pid'])
                                {
                                    if (!$attach['isimage']) continue;
									//分类信息，远程附件开启后 论坛本地的图片不显示
									$attachurl = $this->_Sortimg($attach,$setting['ftp']['on'],$val['sortid']);
									if($attachurl === false){
										continue;
									}
                                    $thread['attach'][] = $attachurl;
                                    $i++;
                                }
                            }
                            $thread['attnum'] = ''.$i;
//                            $thread['attnum'] = '' . count($attachs);
                        }
						*/
						$attachs = C::t('forum_attachment')->fetch_all_by_id('tid', array($thread['tid']));
                        if($attachs && is_array($attachs) && !empty($attachs)) {
                            $i = 0;
                            foreach ($attachs as $attach) {
                                if($thread['pid'] == $attach['pid']){
                                    $table_index = $attach['tableid'];
                                    $attach = C::t('forum_attachment_n')->fetch($table_index, $attach['aid'], false);
                                    if(!$attach['isimage']) continue;

                                    if( !empty($attach) ) {
                                        //分类信息图片兼容
                                        $attachurl = $this->_Sortimg($attach,$setting['ftp']['on'],$thread['sortid']);
                                        if($attachurl == false){
                                            continue;
                                        }
                                        $thread['attach'][] = $attachurl;
                                    }
                                    $i++;
                                }
                            }
                            $thread['attnum'] = ''.$i;
                        }
                    }

                    $addviews = DB::result_first("SELECT addviews FROM %t WHERE tid=%d", array("forum_threadaddviews", $val['tid']));
                    $thread['hits'] += $addviews;

                    $threads[] = $thread;
                }
            }

            // 2.0.0帖子列表页数据整合分类信息,做好之前版本的兼容
            if( !empty($type) ) {
                $data = array(
                    'is_sort' => 0,
                    'thread' => array(),
                    'sort' => array(),
                    'type' => array()
                );

                $data['thread'] = $threads;

                // 主题分类
                $threadType = array();
                if( !empty($_G['forum']['threadtypes']) ) {
                    $threadType['required'] = $_G['forum']['threadtypes']['required'] ? 1 : 0;
                    $typeArray = $_G['forum']['threadtypes']['types'];
                    foreach( $typeArray as $typeid => $v ) {
                        if(!empty($_G['forum']['threadtypes']['moderators'][$typeid])) continue;
                        $typeTemp[] = array(
                            'typeid' => $typeid,
                            'typename' => strip_tags($v)
                        );
                    }
                    $threadType['types'] = $typeTemp;
                    $data['type'] = $threadType;
                }

                // 分类信息
                if( !empty($_G['forum']['threadsorts']['types']) ) {
                    require_once libfile('function/threadsort');
                    $threadSort['required'] = $_G['forum']['threadsorts']['required'] ? 1 : 0;
                    $threadSortArr = $_G['forum']['threadsorts']['types'];
                    $data['is_sort'] = 1;
                    require_once libfile('function/threadsort');
                    foreach( $threadSortArr as $sortid => $vv ) {
                        $sortTemp = array(
                            'sortid' => $sortid,
                            'sortname' => $vv,
                            'data' => array()
                        );
                        threadsort_checkoption($sortid);
                        $sortArray = $_G['forum_optionlist'];
                        foreach( $sortArray as $optionid => $option ) {
                            $select = array();
                            if( $option['type'] == 'radio' ) {
                                if (!empty($option['choices'])) {
                                    foreach ($option['choices'] as $kkk => $vvv) {
                                        $selectArr['optionid'] = $kkk;
                                        $selectArr['content'] = $vvv;

                                        $select[] = $selectArr;
                                    }
                                    unset($selectArr);
                                }

                                if (!empty($sortArray)) {
                                    $optionTemp = array(
                                        'kindid' => $optionid,
                                        'name' => $option['title'],
                                        'type' => $option['type'],
                                        'select' => !empty($select) ? $select : array(),
                                    );
                                }

                                $sortTemp['data'][] = $optionTemp;
                            }
                        }
                        if(empty($sortTemp['data'])) continue;
                        $data['sort'][] = $sortTemp;
                    }
                }
                Tool::getInstance()->success_json( $data );
            }

            Tool::getInstance()->success_json( $threads );
        }
    }

    public function actionAllthreads()
    {
        $fid = WebHelper::getPost('fid', 0);
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 0);

        global $_G;

        $threads = array();
        if( $fid )
        {
            $threads = $this->_allThreadByFid($fid, $offset, $limit);
        }
        else
        {
            $threads = $this->_allThread( $offset, $limit );
        }
		$setting = C::t('common_setting')->fetch_all(null);
        $setting['ftp'] = dunserialize($setting['ftp']);
        $data = array();
        if( !empty($threads) )
        {
            $offset = 0;
            foreach( $threads as $key => $val )
            {
                $data[$offset]['tid'] = $val['tid'];
                $data[$offset]['subject'] = $val['subject'];
                $data[$offset]['authorid'] = $val['authorid'];
                $data[$offset]['author'] = $val['author'];
                $data[$offset]['fid'] = $val['fid'];
                $data[$offset]['forumname'] = DB::result_first("SELECT name FROM %t WHERE fid = %d", array
                ('forum_forum', $val['fid']));
                $data[$offset]['hits'] = $val['views'];
                $data[$offset]['replies'] = $val['replies'];
                $data[$offset]['postdate'] = $val['dateline'];
                $data[$offset]['attachs'] = array();
                if( $val['attachment'] == 2 )
                {
                    $attachs = C::t('forum_attachment_n')->fetch_all_by_id( 'tid:' . $val['tid'], 'tid', $val['tid'], '', 1 );
                    if( !empty($attachs) )
                    {
                        foreach( $attachs as $k => $attach )
                        {
                            $attachurl = $this->_Sortimg($attach,$setting['ftp']['on'],$val['sortid']);
                            if($attachurl == false){
                                continue;
                            }
                            $data[$offset]['attachs'][] = $attachurl;
                        }
                    }
                }


                $offset++;
            }
        }

        Tool::getInstance()->success_json( $data );
    }

    private function _allThreadByFid( $fid, $offset, $limit )
    {
        return DB::fetch_all("SELECT * FROM %t WHERE fid=%d AND displayorder >= %d ORDER by dateline DESC " .
            DB::limit($offset, $limit), array('forum_thread', $fid, 0));
    }

    private function _allThread($offset, $limit)
    {
        return DB::fetch_all( "SELECT * FROM %t WHERE displayorder >= %d ORDER BY tid DESC " . DB::limit( $offset,
                $limit ), array( 'forum_thread', 0 ) );
    }

    // 获取帖子列表
    private function _searchThread( $conditions, $tableid = 0, $start = 0, $limit = 0, $order = '', $sort = 'DESC', $tidArray ) {
        $ordersql = '';
        if(!empty($order)) {
            $ordersql =  " ORDER BY $order $sort ";
        }

        if( !empty($tidArray) ) {
            $ordersql = ' AND '.DB::field('tid', $tidArray) . $ordersql;
        }
        $data = array();
        $forumThread = new table_forum_thread();
        if(count($conditions) < 5) {
            foreach(array_keys($conditions) as $key) {
                if(!in_array($key, array('inforum', 'sticky', 'displayorder', 'intids'))) {
                    break;
                }
            }
        }

        $data = DB::fetch_all("SELECT * FROM ".DB::table($forumThread->get_table_name($tableid)) . $forumThread->search_condition($conditions)." $ordersql ".DB::limit($start, $limit));

        return $data;
    }

    /**
     * 24小时热点帖子列表
     *
     * 只取当前前10000贴
     * 预留后台版块筛选功能
     * 预留后台热度控制
     * 注意性能问题
     */
    public function actionGethotthreads()
    {
        global $_G;
        $order = WebHelper::getPost('order', '');
        $time = WebHelper::getPost('time', '');
        $offset = WebHelper::getPost('offset', '');
        $limit = WebHelper::getPost('limit', '');
        $fids = WebHelper::getPost('fids', '');
        $heatslimit = WebHelper::getPost('heatslimit', '');

        $start = !empty($offset)? intval($offset) : 0;
        $heatslimit = !($heatslimit==='') ? intval($heatslimit) : 3;
        $num = $limit ? intval($limit) : 20;
        $fids = $fids ? explode(',', $fids ) : 0;
        if($heatslimit == 0 && $order == 'hits') {
            $order = 'postdate';
        }

        //热帖的时间范围
        $current = 0;
        if( $order == 'hits') {
            $current = time() - $time;
        }

//        //显示在热帖列表里帖子的热度的最小值 - 改为由后台控制2016-05-03
//        $heatslimit = $_G['setting']['heatthread']['guidelimit'];

        //热点帖子，最新发布，最新回复
        switch( !empty($order) ) {
            case $order == 'hits';
                $order = 'hot';
                break;
            case $order == 'postdate';
                $order = 'newthread';
                break;
            case $order == 'lastpost';
                $order = 'reply';
                break;
            default:
                $order = 'reply';
        }

        //版块过滤
        if(!$fids) {
            loadcache('forums');
            $fids = array();
            foreach ($_G['cache']['forums'] as $fid => $forum) {
                if ($forum['type'] != 'group' && $forum['status'] > 0 && !$forum['viewperm'] && !$forum['havepassword']) {
                    $fids[] = $fid;
                }
            }
        }

        if( !function_exists('loadforum') )
        {
            require_once( libfile( 'function/forum' ) );
        }

        //只取前10000贴
        $limittid = DB::result_first('
            SELECT tid
            FROM %t
            ORDER BY tid DESC
            LIMIT %d
            ',
            array('forum_thread', 1));
        $limittid = intval($limittid) - 10000;
        $limittid = $limittid > 0 ? $limittid : 0;
        $threadlist = C::t('forum_thread')->fetch_all_for_guide($order, $limittid, null, $heatslimit, $current, $start , $num, $fids);
		
		$setting = C::t('common_setting')->fetch_all(null);
        $setting['ftp'] = dunserialize($setting['ftp']);
		
        $data = array();
        foreach($threadlist as $k => $v) {
            $temp['tid'] = $v['tid'];
            $temp['subject'] = $v['subject'];
            $temp['authorid'] = $v['authorid'];
            $temp['author'] = $v['author'];
            $temp['authoricon'] = discuz_uc_avatar( $temp['authorid'], 'big', 1 );
            $temp['fid'] = $v['fid'];
            $foruminfo = C::t('forum_forum')->fetch_info_by_fid($temp['fid']);
            $temp['forumname'] = $foruminfo['name'];

            //修正帖子查看数
            $_GET['tid'] = dintval($v['tid']);
            loadforum();
            if (isset($_G['forum_thread']['views']) && $_G['forum_thread']['tid'] == $v['tid'] && $_G['forum_thread']['views'] > $v['views'])
            {
                $v['views'] = strval($_G['forum_thread']['views']);
            }
            $temp['hits'] = $v['views'];
            $temp['replies'] = $v['replies'];
            $temp['postdate'] = $v['dateline'];
            $temp['lastpost'] = $v['lastpost'];
            $temp['attnum'] = '0';

            //获取附件
            $attach = array();
            $pre = DB::$db->tablepre;
            $v['pid'] = DB::result_first('SELECT pid FROM '.$pre.'forum_post WHERE tid = '.intval($v['tid']).' AND first = 1');

            if($v['attachment'] == 2 || $v['attachment'] ==1) {
                $attachments = C::t('forum_attachment')->fetch_all_by_id('tid', array($v['tid']));
                if($attachments && is_array($attachments) && !empty($attachments)) {
                    $i = 1;
                    foreach ($attachments as $attachment) {
                        if($v['pid'] == $attachment['pid']){
                            $table_index = $attachment['tableid'];
                            $attachment = C::t('forum_attachment_n')->fetch($table_index, $attachment['aid'], false);
                            if(!$attachment['isimage']) continue;
                            //获取附件数量
                            $temp['attnum'] = C::t('forum_attachment_n')->count_image_by_id($table_index,'pid',$attachment['pid']);

                            if( $temp['attnum'] == 2 ) {
                                if($i>1)break;
                            }else {
                                if($i>3)break;
                            }

                            if( !empty($attachment) ) {
							//分类信息图片兼容
                                $attachurl = $this->_Sortimg($attachment,$setting['ftp']['on'],$v['sortid']);
                                if($attachurl == false){
                                    continue;
                                }
                                $attach[] = $attachurl;
                            }
                            $i++;
                        }
                    }
                }
            }
            $temp['attachs'] = $attach;
            $data[] = $temp;
        }
        Tool::getInstance()->success_json($data);
    }

	/*
     * 置顶贴
     *
	*/
    public function actionTopthread()
    {
        //板块ID
        $fid = WebHelper::getPost('fid', 0);

        if ($fid > 0) {
            $lists = DB::fetch_all("SELECT tid,subject,authorid,author,dateline,lastpost,views,replies,displayorder,fid FROM %t WHERE displayorder > 0".DB::limit(0, 1000),array('forum_thread'));
            //分区id

            $gid = DB::fetch_first("SELECT fup FROM %t WHERE fid=%d",array('forum_forum',$fid));
            $fids = $list1 = $list2 = $list3 = $list = array();
            if($gid['fup']){
                $fids = DB::fetch_all("SELECT fid FROM %t WHERE fup=%d",array('forum_forum',$gid['fup']));
            }

            foreach($lists as $val){
                if($val['fid'] == $fid && $val['displayorder'] == 1){
                    $list1[] = $val;
                }elseif(in_array($val['fid'],$fids) && $val['displayorder'] == 2){
                    $list2[] = $val;
                }elseif($val['displayorder'] == 3){
                    $list3[] = $val;
                }
            }

            $list = array_merge($list3,$list2,$list1);
            $threads = array();
            foreach ($list as $key => $val)
            {
                $thread = array();
                $thread['tid'] = $val['tid'];
                $thread['subject'] = $val['subject'];
                $thread['authorid'] = $val['authorid'];
                $thread['author'] = $val['author'];
                $thread['postdate'] = $val['dateline'];
                $thread['lastpost'] = $val['lastpost'];
                $thread['hits'] = $val['views'];
                $thread['replies'] = $val['replies'];

                $threads[] = $thread;
            }

            Tool::getInstance()->success_json($threads);
        }
        else
        {
            Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request'));
        }

    }

    /**
     * 根据fid获取版主
     */
    public function actionForummaster()
    {
        global $_G;
        $_G['fid'] = WebHelper::getPost('fid', '');

        $forumfield = C::t('forum_forumfield')->fetch_all_by_fid(array($_G['fid']));
        $moderators = explode("\t", $forumfield[$_G['fid']]['moderators']);
        $data =array();
        if(!$moderators || !is_array($moderators) || empty($moderators)) {
            Tool::getInstance()->success_json($data);
        }

        foreach ($moderators as $moderator) {
            $user = C::t('common_member')->fetch_by_username($moderator);

            if($user['uid'] > 0){
                $data[] = array(
                    'uid' => $user['uid'] ? $user['uid'] : 0,
                    'username' => $user['username'] ? $user['username'] : '',
                    'icon' => avatar( $user['uid'], 'big', true ),
                );
            }
        }
        Tool::getInstance()->success_json($data);
    }

    /**
     * 根据fid获取版块主题分类，分类信息的相关内容
     *
     */
    public function actionGetForumInfo() {
        global $_G;
        $fid = WebHelper::getPost('fid', '');
        if( !function_exists('loadforum') ) {
            require_once( libfile( 'function/forum' ) );
        }
        require_once( Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php' );

        loadforum( $fid );
        $data = array(
            'type' => array(),
            'sort' => array()
        );
        $threadType = $threadSort = array();

        // 主题分类
        if( !empty($_G['forum']['threadtypes']) ) {
            $threadType['required'] = $_G['forum']['threadtypes']['required'] ? 1 : 0;
//            Yii::log(var_export($_G['forum'], true));
            $typeArray = $_G['forum']['threadtypes']['types'];
            foreach( $typeArray as $typeid => $v ) {
                if(!empty($_G['forum']['threadtypes']['moderators'][$typeid])) continue;
                $typeTemp[] = array(
                    'typeid' => $typeid,
                    'typename' => strip_tags($v)
                );
            }
            $threadType['types'] = $typeTemp;

        }

        // 分类信息
        if( !empty($_G['forum']['threadsorts']) ) {
            $threadSort['required'] = $_G['forum']['threadsorts']['required'] ? 1 : 0;
            $threadSortArr = $_G['forum']['threadsorts']['types'];
            require_once libfile('function/threadsort');
            foreach( $threadSortArr as $sortid => $vv ) {
				$expiration = 0;
                if(!empty($_G['forum']['threadsorts']['expiration'])) {
                    $expiration = $_G['forum']['threadsorts']['expiration'][$sortid];
                }
                $sortTemp = array(
                    'sortid' => $sortid,
                    'sortname' => $vv,
					'expiration'=> $expiration, //是否开启有效期
                    'data' => array()
                );
                threadsort_checkoption($sortid);
                $sortArray = $_G['forum_optionlist'];
                foreach( $sortArray as $optionid => $option ) {
                    $select = array();
                    if( $option['type'] == 'radio' || $option['type'] == 'checkbox' ) {
                        if( !empty($option['choices']) ) {
                            foreach( $option['choices'] as $kkk => $vvv ) {
                                $selectArr['content'] = $vvv;
                                $selectArr['optionid'] = $kkk;

                                $select[] = $selectArr;
                            }
                            unset($selectArr);
                        }
                    }elseif( $option['type'] == 'select' ) {
                        $items = $option['choices'];
                        $topid = 0;

                        // 哇一行代码实现无限级分类
                        foreach( $items as $item ) {
                            $items[$item['foptionid']]['children'][] = &$items[$item['optionid']];
                        }
                        $select = isset($items[$topid]['children']) ? $items[$topid][ 'children' ] : array();
                    }
                    // 范围类型规则处理
                    if(in_array($option['type'],array('range','number'))) {
                        $option['minnum'] = !empty($option['minnum']) ? $option['minnum'] : 0;
                        $option['maxnum'] = !empty($option['maxnum']) ? $option['maxnum'] : 0;
                        $option['maxlength'] = $option['minnum'] .','. $option['maxnum'];
                    }
                    if( !empty($sortArray) ) {
                        $optionTemp = array(
                            'kindid' => $optionid,
                            'name' =>  $option['title'],
                            'type' => $option['type'],
							'identifier' => $option['identifier'],
                            'desc' => $option['description'],
                            'required' => $option['required'],
                            'maxlength' => !empty($option['maxlength']) ? $option['maxlength'].'' : '',
                            'select' => $select,
                        );
                    }
                    $sortTemp['data'][] = $optionTemp;
                }
				if($expiration){
                    if( strtoupper( $_G['charset'] ) != 'UTF-8' ) {
                        $zero  = mb_convert_encoding('3天', 'gbk', 'utf-8');
                        $one   = mb_convert_encoding('5天', 'gbk', 'utf-8');
                        $two   = mb_convert_encoding('7天', 'gbk', 'utf-8');
                        $three = mb_convert_encoding('1月', 'gbk', 'utf-8');
                        $four  = mb_convert_encoding('3月', 'gbk', 'utf-8');
                        $five  = mb_convert_encoding('半年', 'gbk', 'utf-8');
                        $six   = mb_convert_encoding('1年', 'gbk', 'utf-8');
						$name  = mb_convert_encoding('有效期', 'gbk', 'utf-8');
						$desc  = mb_convert_encoding('信息的有效期', 'gbk', 'utf-8');
                    }
					
                    $array = array(
                        'kindid' => $optionid+1,
                        'name' =>  isset($name) ? $name : '有效期',
                        'type' => 'radio',
                        'identifier' => 'typeexpiration',
                        'desc' => isset($desc) ? $desc : '信息的有效期',
                        'required' => '1',
                        'maxlength' => '',
                        'select' => array(
                            '0'=>array(
                                'content'=>isset($zero)? $zero : '3天',
                                'optionid'=>'259200'
                            ),
                            '1'=>array(
                                'content'=>isset($one)? $one : '5天',
                                'optionid'=>'432000'
                            ),
                            '2'=>array(
                                'content'=>isset($two)? $two : '7天',
                                'optionid'=>'604800'
                            ),
                            '3'=>array(
                                'content'=>isset($three)? $three : '1月',
                                'optionid'=>'2592000'
                            ),
                            '4'=>array(
                                'content'=>isset($four)? $four : '3月',
                                'optionid'=>'7776000'
                            ),
                            '5'=>array(
                                'content'=>isset($five)? $five : '半年',
                                'optionid'=>'15552000'
                            ),
                            '6'=>array(
                                'content'=>isset($six)? $six : '1年',
                                'optionid'=>'31104000'
                            )
                        ),
                    );

                    $sortTemp['data'][] = $array;
                }
                $threadSort['types'][] = $sortTemp;
            }
        }

        $data['type'] = $threadType;
        $data['sort'] = $threadSort;
        foreach($data['type']['types'] as $key => $value){
            $value['typename'] = strip_tags($value['typename'],chr(32));
            $data['type']['types'][$key]['typename'] = $value['typename'];
        }
        Tool::getInstance()->success_json($data);
    }

    /**
     * 根据fids，获取各个板块主题分类情况
     */
    public function actionGetTypeByFids() {

        $fids = WebHelper::getPost('fids', '');
        $fidArr = explode(',', $fids);

        if( count($fidArr) >= 100 ) {
            Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
        }

        $forums = C::t('forum_forum')->fetch_all_info_by_fids($fidArr);
        $forumArr = $data = $typeTemp = array();
        if( !empty($forums) ) {
            foreach( $forums as $k => $forum ) {
                foreach(array('threadtypes', 'threadsorts') as $key) {
                    $forum[$key] = !empty($forum[$key]) ? dunserialize($forum[$key]) : array();
                    if(!is_array($forum[$key])) {
                        $forum[$key] = array();
                    }
                }
                $forumArr['fid'] = $forum['fid'];
                $forumArr['type'] = $forum['threadtypes'];
                $forumArr['is_sort'] = !empty($forum['threadsorts']) ? 1 : 0;  // 是否可以发布分类信息

                if( !empty($forumArr['type']) ) {
                    $forumArray = array(
                        'required' => '',
                        'types' => array()
                    );
                    $forumArray['required'] = $forumArr['type']['required'] ? 1 : 0;
                    foreach( $forumArr['type']['types'] as $typeid => $v ) {
                        if(!empty($forumArr['type']['moderators'][$typeid])) continue;
                        $typeTemp[] = array(
                            'typeid' => $typeid,
                            'typename' => strip_tags($v)
                        );
                    }
                    $forumArray['types'] = $typeTemp;
                    $forumArr['type'] = $forumArray;
                    unset($typeTemp);
                }
				//2.0.1 新增 配置
                $fid = $forum['fid'];
                $forums = C::t('forum_forum')->fetch_all_info_by_fids($fid);
                $simple = 0;
                if(isset($forums[$fid]['simple'])) $simple = $forums[$fid]['simple'];
                $orderby = bindec((($simple & 128) ? 1 : 0).(($simple & 64) ? 1 : 0));

                if($orderby != 0 && $orderby != 1) $orderby = 0;

                $forumArr['default_order'] = $orderby;
				
                unset($forum);
                $data[] = $forumArr;
            }
        }

        Tool::getInstance()->success_json($data);
    }
	//分类信息图片统一处理，开启远程附件后不显示data/attachment路径的图片
    private function _Sortimg($attach,$ftp,$sortid){
	
        $attachurl = ForumThread::getAttachUrl($attach);
        if($sortid != 0){
            if($ftp == 1){
                if(is_int(strpos(strtolower($attachurl),'data/attachment'))){
                    return false;
                }
            }
        }
        return $attachurl;
    }
}