<?php
if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ManagerController extends Controller
{

    public function __construct()
    {
        global $_G;
        if(!$_G['uid'] && !$_POST['qianfan_admin']){
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }
    }
    //获取指定用户的 禁言状态，帖子版块的 置顶是否开启  置顶状态
    public function actionManagerinfo(){
        global $_G;

        $_GET['tid']  = intval(WebHelper::getPost('tid', '0'));
        $pid = intval(WebHelper::getPost('pid', '0'));

        if(!$_GET['tid'])
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        $re = array(
            'uid'=>0,
            'isadmin'=>0,       //是否是管理员用户组
            'userstatus'=> 0,   //指定用户禁言状态 0  正常  1 禁言
            'foruminfo'=>array(
                'stick'=>'',
                'sticktime'=>'',
                'fname'=>'',
                'fid'=>'',
                'subject'=>'',
                'globalstick'=>'',          //开启全局置顶
                'allowglobalstick'=>'',     //本版是否显示全局 分类置顶

            ),
            'replyinfo'=>array(
                'stick'=>'',
                'ban'=>'',
                'content'=>'',
                'invisible'=>'',
            ),
            'auth'=>array(
                'stickthread'=>0,   //帖子置顶
                'stickreply'=>0,    //回复置顶
                'banuser'=>0,       //用户禁言
                'banreply'=>0,      //回复屏蔽
                'movethread'=>0,    //帖子移动
                'edittitle'=>0,     //帖子标题修改
                'delpost'=>0,       //帖子,回复删除
            ),
        );
        if($_GET['tid']){
            $thread = C::t('forum_thread')->fetch($_GET['tid']);
            if(!empty($thread)){
                $re['foruminfo']['stick'] = $thread['displayorder'];  // 3 全局置顶 2 分类置顶 1 版本置顶 0 普通帖 -1 回收站 -2 审核中  -3 审核忽略 -4 草稿
                $re['foruminfo']['subject'] = $thread['subject'];
                $re['foruminfo']['fid'] = $thread['fid'];
                //置顶时间
                $row = C::t('forum_threadmod')->fetch_by_tid_action_status($_GET['tid'], 'EST');
                $sticktime =  $row['expiration'] ? date('Y-m-d H:i', $row['expiration']) : '';
                $re['foruminfo']['sticktime'] = $sticktime;
                $_GET['uid'] = $thread['authorid'];
            }else{
                //帖子不存在
                Tool::getInstance()->fail_json( Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists') );
            }
        }

        if($pid){
            //分表的话需要确定表名
            $tablename = table_forum_post::get_tablename('tid:'.$_GET['tid'] );
            $post = DB::fetch_first('select * from %t where pid=%d limit 1',array($tablename,$pid));

            $_GET['uid'] = $post['authorid'];
            //回帖是否置顶
            $poststick = C::t('forum_poststick')->fetch_all_by_tid($_GET['tid']);
            if(isset($poststick[$pid]) && !empty($poststick[$pid])){
                $re['replyinfo']['stick'] = 1;
            }
            //回帖是否屏蔽
            if(!empty($post)){
                if($post['status'] & 1){
                    $re['replyinfo']['ban'] = 1;
                }
                //去除字符
                $search= array(
                    '/<embed src=\"(.+?)\".*?>(<\/embed>)?/',
                    '/\[(audio|media|flash).*?\](.*?)\[\/\1\]/s',
                    '/\[quote\](.*?)\[\/quote\]/',
                    '/\[img=(.+?)\](.*?)\[\/img\]/',
                    '/\[url=(.+?)\](.*?)\[\/url\]/',
                    '/\[font=(.+?)\](.*?)\[\/font\]/',
                    '/\[i=s\](.*?)\[\/i\]/',
                    '/\[i\](.*?)\[\/i\]/',
                    '/\[u\](.*?)\[\/u\]/',
                    '/\[[a-z]+\]([^\[]+)[\/[a-z]+\]/'  //attach  qq
                );
                $replace = array(
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                );
                //去除空格
                $ban=array(" ","　","\t","\n","\r");
                $rep=array("","","","","");
                $post['message'] = str_replace($ban,$rep,$post['message']);

                $content = preg_replace($search,$replace,$post['message']);

                $re['replyinfo']['content'] = $content;
                $re['replyinfo']['invisible'] = $post['invisible'];
//                    *  invisible ：0 正常
//                    *  invisible ：-3  已忽略
//                    *  invisible ：-2  待审核
//                    *  invisible ：-5  回收站
//                    *  invisible : -1 主题帖在回收站中
            }else{
                //帖子不存在
                Tool::getInstance()->fail_json( Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists') );
            }

        }
        //用户信息
        if(!$_GET['uid'])
            Tool::getInstance()->fail_json(Code::USER_NOT_EXISTS, Tool::getInstance()->lang('the_user_is_not_exists'));
        $member = C::t('common_member')->fetch($_GET['uid'], false, 1);
        if(empty($member)) {
            //指定用户不存在或未同步到论坛
            Tool::getInstance()->fail_json(Code::USER_NOT_EXISTS, Tool::getInstance()->lang('the_user_is_not_exists'));
        }
        if($member['groupid'] == 4){
            $re['userstatus'] = 1;
        }
        //加载板块信息
        if( !function_exists('loadforum') )
        {
            require_once( libfile( 'function/forum' ) );
        }
        loadforum(null,$_GET['tid']);
        $re['foruminfo']['allowglobalstick'] = $_G['forum']['allowglobalstick'];
        $re['foruminfo']['globalstick'] = $_G['setting']['globalstick'];
        $re['foruminfo']['fname'] = $_G['forum']['name'];

        $re['uid'] = $_GET['uid'];

        if(in_array($_G['group']['radminid'],array('1','2','3')) ){
            $re['isadmin'] = 1;
            $re['auth']['stickthread'] = $_G['group']['allowstickthread'] > 0 ? 1 : 0;
            $re['auth']['stickreply'] = $_G['group']['allowstickreply'];
            $re['auth']['banuser'] = $_G['group']['allowbanuser'];
            $re['auth']['banreply'] = $_G['group']['allowbanpost'];
            $re['auth']['movethread'] = $_G['group']['allowmovethread'];
            $re['auth']['edittitle'] = $_G['group']['alloweditpost'];
            $re['auth']['delpost'] = $_G['group']['allowdelpost'];

        }
        //var_dump($_G['forum']);
        Tool::getInstance()->success_json( $re );

    }

    //参数
    public function actionUsermanager(){
        global $_G;
        require_once libfile('function/forum') ;

        $_GET['banexpirynew'] = $time =  WebHelper::getPost('time', '');    //时间  天数
        $_GET['bannew'] = WebHelper::getPost('bannew', '');                 //禁言 post   解除  ''  禁止访问 visit  锁定 status 现在状态 now
        $_GET['uid']  = intval(WebHelper::getPost('uid', '0'));
        $_GET['reason'] = WebHelper::getPost('reason', '');                 // 理由
		$qianfan_admin = WebHelper::getPost('qianfan_admin', '0');          //小后台的管理员凭证
		
        //参数验证
        if(!$_GET['uid'] || ( $_GET['bannew'] != 'post' && $_GET['bannew'] != '' && $_GET['bannew'] != 'now')){
            //参数错误
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        }

        //禁言权限
        if(!$_G['group']['allowbanuser']  && !$qianfan_admin){
            //无权限
            Tool::getInstance()->fail_json(Code::UN_BAN_USER, Tool::getInstance()->lang('no_privilege_banuser'));
        }

        $member = C::t('common_member')->fetch($_GET['uid'], false, 1);
        if(empty($member)) {
            //指定用户不存在或未同步到论坛
            Tool::getInstance()->fail_json(Code::USER_NOT_EXISTS, Tool::getInstance()->lang('the_user_is_not_exists'));
        }
        $tableext = isset($member['_inarchive']) ? '_archive' : '';
        $membermf = C::t('common_member_field_forum'.$tableext)->fetch($_GET['uid']);
        $membergroup = C::t('common_usergroup')->fetch($member['groupid']);
        $membergroupfield = C::t('common_usergroup_field')->fetch($member['groupid']);

        $member = array_merge($member, $membermf, $membergroup, $membergroupfield);
        //$member['groupid'] 4=禁言  5=禁止访问  $member['status'] == '-1'  锁定


        //相关权限验证
        if(($member['type'] == 'system' && in_array($member['groupid'], array(1, 2, 3, 6, 7, 8))) || $member['type'] == 'special') {
            //'您不能直接禁止该用户,请先去掉其管理组身份
            Tool::getInstance()->fail_json(Code::UN_BNA_SPECIAL_USER, Tool::getInstance()->lang('cant_ban_special_user'));
        }
        if($member['allowadmincp']) {
            //'您不能直接禁止该用户，请先去掉其管理组身份
            Tool::getInstance()->fail_json(Code::UN_BNA_SPECIAL_USER, Tool::getInstance()->lang('cant_ban_special_user'));
        }
        $member['groupterms'] = dunserialize($member['groupterms']);
        $member['banexpiry'] = !empty($member['groupterms']['main']['time']) && ($member['groupid'] == 4 || $member['groupid'] == 5) ? dgmdate($member['groupterms']['main']['time'], 'Y-n-j') : '';

        $reason = trim($_GET['reason']);
        if(!$reason && ($_G['group']['reasonpm'] == 1 || $_G['group']['reasonpm'] == 3)) {
            //您没有输入执行此变更的理由
            //Tool::getInstance()->fail_json(Code::EMPTY_REASON, Tool::getInstance()->lang('empty_reason'));
        }

        $status = 0;
        if($member['groupid'] == 4) $status = 1;
        if($member['groupid'] == 5) $status = 2;
        if($member['status'] == '-1') $status = -1;
        $data =array(
            'uid'       =>  $member['uid'],
            'username'  =>  $member['username'],
            'status'    =>  $status,  //状态  0=正常  1=禁止发言  2=禁止访问  -1=锁定
        );
        //禁言已禁言的，解禁正常的用户 直接返回参数
        if($_GET['bannew'] == 'now' ||  ($_GET['bannew'] == '' && $status == 0) ){
            Tool::getInstance()->success_json( $data );
        }
        $setarr = array();
        $my_data = array();
        $mylogtype = '';
        // 禁言还是 解除禁言  其他
        if(in_array($_GET['bannew'], array('post', 'visit', 'status'))) {
            $my_data = array('uid' => $member['uid']);
            if($_GET['delpost']) {
                $my_data['otherid'] = 1;
            }
            $mylogtype = 'banuser';
        } elseif($member['groupid'] == 4 || $member['groupid'] == 5 || $member['status'] == '-1' ) {
            $my_data = array('uid' => $member['uid']);
            $mylogtype = 'unbanuser';
        }

        //此处只处理发帖禁言
        if($_GET['bannew'] == 'post' || $_GET['bannew'] == 'visit') {
            $groupidnew = $_GET['bannew'] == 'post' ? 4 : 5;
            $_GET['banexpirynew'] = !empty($_GET['banexpirynew']) ? TIMESTAMP + $_GET['banexpirynew'] * 86400 : 0;
            $_GET['banexpirynew'] = $_GET['banexpirynew'] > TIMESTAMP ? $_GET['banexpirynew'] : 0;
            if($_GET['banexpirynew']) {
                $adminid = $member['adminid'];
                $groupid = $member['groupid'];
                //防止禁言已被禁言用户 变成永久禁言的 情况
                if($groupid == 4){
                    $groups = C::t('common_usergroup')->fetch_by_credits($member['credits']);
                    $groupid = $groups['groupid'];
                    $adminid = 0;
                }
                $member['groupterms']['main'] = array('time' => $_GET['banexpirynew'], 'adminid' => $adminid, 'groupid' => $groupid);
                $member['groupterms']['ext'][$groupidnew] = $_GET['banexpirynew'];
                $setarr['groupexpiry'] = groupexpiry($member['groupterms']);
            } else {
                $setarr['groupexpiry'] = 0;
            }
            $adminidnew = -1;
            $my_data['expiry'] = groupexpiry($member['groupterms']);
            $postcomment_cache_pid = array();
            foreach(C::t('forum_postcomment')->fetch_all_by_authorid($member['uid']) as $postcomment) {
                $postcomment_cache_pid[$postcomment['pid']] = $postcomment['pid'];
            }
            C::t('forum_postcomment')->delete_by_authorid($member['uid'], false, true);
            if($postcomment_cache_pid) {
                C::t('forum_postcache')->delete($postcomment_cache_pid);
            }
            if(!$member['adminid']) {
                $member_status = C::t('common_member_status')->fetch($member['uid']);
                if($member_status) {
                    //改
                    $ca = new captcha();
                    $ca->report($member_status['lastip']);
                }
            }
            $data['status'] = $_GET['bannew'] == 'post' ? 1 : 2;
            //解除禁言
        } elseif($member['groupid'] == 4 || $member['groupid'] == 5) {
            if(!empty($member['groupterms']['main']['groupid'])) {
//                $groupidnew = $member['groupterms']['main']['groupid'];
//                $adminidnew = $member['groupterms']['main']['adminid'];
                unset($member['groupterms']['main']);
                unset($member['groupterms']['ext'][$member['groupid']]);
                $setarr['groupexpiry'] = groupexpiry($member['groupterms']);
            }
            $groupnew = C::t('common_usergroup')->fetch_by_credits($member['credits']);
            $groupidnew = $groupnew['groupid'];
            $adminidnew = 0;
            $data['status'] = 0;
        }else{
            //非法操作
            Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal operation'));

        }
        if(!empty($my_data) && !empty($mylogtype)) {
            $log_handler = Cloud::loadClass('Cloud_Service_SearchHelper');
            $log_handler->myThreadLog($mylogtype, $my_data);
        }
        $setarr['adminid'] = $adminidnew;   //管理员状态
        $setarr['groupid'] = $groupidnew;   //新用户组
        $setarr['status'] = $_GET['bannew'] == 'status' ? -1 : 0;  //是否锁定状态

        C::t('common_member'.$tableext)->update($member['uid'], $setarr);

        //日志吗？稍微改了下 和原版不一样
        if($_G['group']['allowbanuser'] && (DB::affected_rows())) {
            $this->_banlog($member['username'], $member['groupid'], $groupidnew, $_GET['banexpirynew'], $reason, $_GET['bannew'] == 'status' ? -1 : 0,$_GET['bannew']);
        }

        C::t('common_member_field_forum'.$tableext)->update($member['uid'],array('groupterms' => ($member['groupterms'] ? serialize($member['groupterms']) : '')));

        if($_GET['bannew'] == 'post') {
            $crimeaction = 'crime_banspeak';
            $noticekey = 'member_ban_speak';
            $from_idtype = 'banspeak';
        } elseif($_GET['bannew'] == 'visit') {
            $crimeaction = 'crime_banvisit';
            $noticekey = 'member_ban_visit';
            $from_idtype = 'banvisit';
        } elseif($_GET['bannew'] == 'status') {
            $crimeaction = 'crime_banstatus';
            $noticekey = 'member_ban_status';
            $from_idtype = 'banstatus';
        }
        if($crimeaction) {
			//禁言记录 小后台管理员名字
			if($qianfan_admin && !$_G['username']) $_G['username'] = 'qianfan_admin';
            crime('recordaction', $member['uid'], $crimeaction, lang('forum/misc', 'crime_reason', array('reason' => $reason)));
        }
        if($noticekey) {
            $notearr = array(
                'user' => "<a href=\"home.php?mod=space&uid=$_G[uid]\">$_G[username]</a>",
                'day' => intval($time),
                'reason' => $reason,
                'from_id' => 0,
                'from_idtype' => $from_idtype
            );
            notification_add($member['uid'], 'system', $noticekey, $notearr, 1);
        }

        //修改成功
        Tool::getInstance()->success_json( $data );
    }


    public function actionThreadmanager(){
        global $_G;

        require_once libfile('function/post');
        require_once libfile('function/forum');
        require_once libfile('function/misc');

        $operation = WebHelper::getPost('operation', '');  //stick  置顶     move  移动版块   delete 删除帖子
        $_GET['tid'] = WebHelper::getPost('tid', '');
        $_G['tid'] = $_GET['tid'];
        //stick 参数
        $_GET['sticklevel'] = WebHelper::getPost('toptype', '');
        $expiration = WebHelper::getPost('time', '');                 //时间戳 置顶
        //move参数
        $_GET['moveto'] = WebHelper::getPost('tofid', '');
        $_GET['threadtypeid'] = WebHelper::getPost('totypeid', '');
        $_GET['type'] = WebHelper::getPost('movetype', 'normal');  //保留转向  normal 普通移动  redirect 保留转向             无用参数

        //delete参数
        $_GET['crimerecord'] = WebHelper::getPost('crimerecord', '0');  //违规登记 1 登记  0 不登记                          无用参数

        //edit参数
        $_GET['newtitle'] = WebHelper::getPost('newtitle', ''); //新标题

        $_GET['sendreasonpm'] = intval(WebHelper::getPost('sendreasonpm', '0'));  //通知作者？？？？  1 通知   0 不通知       无用参数
        $_GET['reason'] = WebHelper::getPost('reason', '');                                                         //理由 无用参数
        if(!empty($_G['tid'])) {
            $_GET['moderate'] = array($_G['tid']);
        }
        //云数据参数解析
        if($operation == '0'){
            $operation = 'delete';
        }elseif($operation == '1'){
            $operation = 'move';
        }elseif($operation == '2'){
            $operation = 'stick';
        }elseif($operation == '3'){
            $operation = 'edit';
        }
        //参数验证
        if(!$operation || !$_GET['tid'] || !in_array($operation,array('move','stick','delete','edit'))){
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        }elseif($operation == 'stick' && $_GET['sticklevel'] == ''){
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        }elseif($operation == 'move' && !$_GET['moveto']){
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        }
        //加载板块信息
        if( !function_exists('loadforum') )
        {
            require_once( libfile( 'function/forum' ) );
        }
        loadforum(null,$_GET['tid']);

        //修改标题
        if($operation == 'edit'){
			//分表确定表名
            $tablename = table_forum_post::get_tablename('tid:'.$_GET['tid'] );
            //看帖子的权限什么的 不用判断
            $special = DB::result_first('SELECT special FROM %t WHERE tid=%d  LIMIT 1', array('forum_thread', $_G['tid']));
            $orig = DB::fetch_first('SELECT * FROM %t WHERE tid=%d AND first=%d LIMIT 1', array($tablename, $_G['tid'], 1));
            $user = getuserbyuid($orig['authorid']);
            $orig['adminid'] = $user['adminid'];

            $isfirstpost = $orig['first'] ? 1 : 0;

            if($isfirstpost && (($special == 1 && !$_G['group']['allowpostpoll']) || ($special == 2 && !$_G['group']['allowposttrade']) || ($special == 3 && !$_G['group']['allowpostreward']) || ($special == 4 && !$_G['group']['allowpostactivity']) || ($special == 5 && !$_G['group']['allowpostdebate']))) {
                //抱歉，您所在的用户组无法进行此操作
                Tool::getInstance()->fail_json(Code::GROUP_NOPERMISSION, Tool::getInstance()->lang('group_nopermission'));

            }
            $isorigauthor = $_G['uid'] && $_G['uid'] == $orig['authorid'];
            if(empty($orig)) {
                //帖子不存在
                Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
            } elseif((!$_G['forum']['ismoderator'] || !$_G['group']['alloweditpost'] || (in_array($orig['adminid'], array(1, 2, 3)) && $_G['adminid'] > $orig['adminid'])) && !(($_G['forum']['alloweditpost'] || $orig['invisible'] == -3)&& $isorigauthor)) {
                //无编辑权限
                Tool::getInstance()->fail_json(Code::EDIT_NOPERMISSION, Tool::getInstance()->lang('post_edit_nopermission'));
            } elseif($isorigauthor && !$_G['forum']['ismoderator'] && $orig['invisible'] != -3) {
                $alloweditpost_status = getstatus($_G['setting']['alloweditpost'], $special + 1);
                if(!$alloweditpost_status && $_G['group']['edittimelimit'] && TIMESTAMP - $orig['dateline'] > $_G['group']['edittimelimit'] * 60) {
                    Tool::getInstance()->fail_json(Code::EDIT_TIMEOUT, Tool::getInstance()->lang('post_edit_timelimit'));
                }
            }

            if(dstrlen($_GET['newtitle']) > 80) {
                Tool::getInstance()->fail_json(Code::SUBJECT_TOOLONG, Tool::getInstance()->lang('post_subject_toolong'));
            }elseif(trim($_GET['newtitle']) == ''){
                Tool::getInstance()->fail_json(Code::SUBJECT_EMPTY, Tool::getInstance()->lang('post_subject_empty'));
            }
            //在一个站点发现DB::update更新不了 换个写法
            C::t('forum_thread')->update($_G['tid'], array( "subject" => $_GET['newtitle'] ) );
            //DB::update( "forum_thread", array("subject" => $_GET['newtitle']), "tid=" . $_G['tid'] );
            DB::update( $tablename, array("subject" => $_GET['newtitle']), "pid=" . $orig['pid'] );


            if($_G['forum']['threadcaches']) {
                deletethreadcaches($_G['tid']);
            }

            $data = array(
                'action'=>$operation,
                'status'=>'success'
            );
            Tool::getInstance()->success_json( $data );

        }

        //是否有版主 权限判断
        //$_G['forum_thread']['is_archived']  这个不做判断
        if($_G['forum']['ismoderator']){
            if(!$_G['group']['allowstickthread'] && !($_G['forum_thread']['displayorder'] <= 3 || $_G['adminid'] == 1)){
                if($operation == 'stick'){
                    Tool::getInstance()->fail_json(Code::UN_STICK_THREAD, Tool::getInstance()->lang('no_privilege_stick'));
                }
            }
            if(!$_G['group']['allowmovethread']  || $_G['forum']['status'] == 3){
                if($operation == 'move'){
                    Tool::getInstance()->fail_json(Code::UN_MOVE_THREAD, Tool::getInstance()->lang('no_privilege_move'));
                }

            }
            if(!$_G['group']['allowdelpost']){
                if($operation == 'detete'){
                    Tool::getInstance()->fail_json(Code::UN_DEL_THREAD, Tool::getInstance()->lang('no_privilege_delete'));
                }
            }
        }else{
            //TODO
            //无权限管理
            Tool::getInstance()->fail_json(Code::NO_PERMISSION, Tool::getInstance()->lang('admin_nopermission'));
        }

        $threadlist = $loglist = $posttablearr = $authors = array();
        $recommend_group_count = 0;
        loadcache('threadtableids');
        $threadtableids = !empty($_G['cache']['threadtableids']) ? $_G['cache']['threadtableids'] : array();
        if(!in_array(0, $threadtableids)) {
            $threadtableids = array_merge(array(0), $threadtableids);
        }

        if($_GET['moderate']) {
            foreach($threadtableids as $tableid) {
                foreach(C::t('forum_thread')->fetch_all_by_tid_fid_displayorder($_GET['moderate'], $_G['fid'], null, '', 0, $_G['tpp'], '', '', $tableid) as $thread) {
                    if($thread['closed'] > 1 && $operation && !in_array($operation, array('delete', 'highlight', 'stick', 'digest', 'bump', 'down')) || $thread['displayorder'] < 0 && $thread['displayorder'] != -4) {
                        if($operation == 'recommend_group') {
                            $recommend_group_count ++;
                        }
                        continue;
                    }
                    $thread['lastposterenc'] = rawurlencode($thread['lastposter']);
                    $thread['dblastpost'] = $thread['lastpost'];
                    $thread['lastpost'] = dgmdate($thread['lastpost'], 'u');
                    $posttablearr[$thread['posttableid'] ? $thread['posttableid'] : 0][] = $thread['tid'];
                    $authors[$thread['authorid']] = 1;
                    $threadlist[$thread['tid']] = $thread;
                    $_G['tid'] = empty($_G['tid']) ? $thread['tid'] : $_G['tid'];
                }
                if(!empty($threadlist)) {
                    break;
                }
            }
        }
        $modpostsnum = count($threadlist);


        $tidsarr = array_keys($threadlist);
        $moderatetids = dimplode($tidsarr);
        $stampstatus = 0;
        $stampaction = 'SPA';
        //edit $reason = checkreasonpm();
        $reason = trim(strip_tags($_GET['reason']));
//        if(($_G['group']['reasonpm'] == 1 || $_G['group']['reasonpm'] == 3) && !$reason) {
//            //您没有输入执行此变更的理由,app没理由这个东西所以注释了
//            //Tool::getInstance()->fail_json(Code::EMPTY_REASON, Tool::getInstance()->lang('empty_reason'));
//        }
        $updatemodlog = TRUE;
        //置顶操作
        if ($operation == 'stick') {

            $sticklevel = intval($_GET['sticklevel']);
            if ($sticklevel < 0 || $sticklevel > 3 || $sticklevel > $_G['group']['allowstickthread']) {
                //这里又判断了下 置顶的权限
                Tool::getInstance()->fail_json(Code::UN_STICK_THREAD, Tool::getInstance()->lang('no_privilege_stick'));
            }
            //$expiration = checkexpiration($_GET['expirationstick'], $operation);
            if(!empty($expiration) && in_array($operation, array('recommend', 'stick', 'digest', 'highlight', 'close', 'open', 'bump'))) {
                $expiration = $expiration - $_G['setting']['timeoffset'] * 3600 + date('Z');
                if(dgmdate($expiration, 'YmdHi') <= dgmdate(TIMESTAMP, 'YmdHi') || ($expiration > TIMESTAMP + 86400 * 180)) {
                    //抱歉，有效期无效, 有效期应该介于{min}至{max}之间
                    Tool::getInstance()->fail_json( Code::INVALID_EXPIRATION,Tool::getInstance()->lang('admin_expiration_invalid',
                        array('min'=>dgmdate(TIMESTAMP, 'Y-m-d H:i'), 'max'=>dgmdate(TIMESTAMP + 86400 * 180, 'Y-m-d H:i') ) ) );
                }
            } else {
                $expiration = 0;
            }

            //$expirationstick = $sticklevel ? $_GET['expirationstick'] : 0;

            $forumstickthreads = $_G['setting']['forumstickthreads'];
            $forumstickthreads = isset($forumstickthreads) ? dunserialize($forumstickthreads) : array();
            C::t('forum_thread')->update($tidsarr, array('displayorder' => $sticklevel, 'moderated' => 1), true);
            $delkeys = array_keys($threadlist);
            foreach ($delkeys as $k) {
                unset($forumstickthreads[$k]);
            }
            C::t('common_setting')->update('forumstickthreads', $forumstickthreads);

            $stickmodify = 0;
            foreach ($threadlist as $thread) {
                $stickmodify = (in_array($thread['displayorder'], array(2, 3)) || in_array($sticklevel, array(2, 3))) && $sticklevel != $thread['displayorder'] ? 1 : $stickmodify;
                C::t('common_member_secwhite')->add($thread['authorid']);
            }

            if ($_G['setting']['globalstick'] && $stickmodify) {
                require_once libfile('function/cache');
                updatecache('globalstick');
            }

            $modaction = $sticklevel ? ($expiration ? 'EST' : 'STK') : 'UST';
            C::t('forum_threadmod')->update_by_tid_action($tidsarr, array('STK', 'UST', 'EST', 'UES'), array('status' => 0));
            C::t('forum_threadhidelog')->delete_by_tid($tidsarr);

            if (!$sticklevel) {
                $stampaction = 'SPD';
            }

            $stampstatus = 1;


        } elseif ($operation == 'move') {

            $moveto = $_GET['moveto'];
            $toforum = C::t('forum_forum')->fetch_info_by_fid($moveto);
            if (!$toforum || ($_G['adminid'] != 1 && $toforum['status'] != 1) || $toforum['type'] == 'group') {
                //目标版块不存在
                Tool::getInstance()->fail_json(Code::FORUM_NONEXISTENCE, Tool::getInstance()->lang('admin_move_invalid'));
            } elseif ($_G['fid'] == $toforum['fid']) {
                //TODO
                //非法操作  移动板块不可以为当前板块
                Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal operation'));
            } else {
                $moveto = $toforum['fid'];
                $modnewthreads = (!$_G['group']['allowdirectpost'] || $_G['group']['allowdirectpost'] == 1) && $toforum['modnewposts'] ? 1 : 0;
                $modnewreplies = (!$_G['group']['allowdirectpost'] || $_G['group']['allowdirectpost'] == 2) && $toforum['modnewposts'] ? 1 : 0;
                if ($modnewthreads || $modnewreplies) {
                    //目标版块需要内容审核
                    Tool::getInstance()->fail_json(Code::NEED_CHECK, Tool::getInstance()->lang('admin_move_have_mod'));
                }
            }

            if ($_G['adminid'] == 3) {
                $priv = C::t('forum_forumfield')->check_moderator_for_uid($moveto, $_G['uid'], $_G['member']['accessmasks']);
                if ((($priv['postperm'] && !in_array($_G['groupid'], explode("\t", $priv['postperm']))) || ($_G['member']['accessmasks'] && ($priv['allowview'] || $priv['allowreply'] || $priv['allowgetattach'] || $priv['allowpostattach']) && !$priv['allowpost'])) && !$priv['istargetmod']) {
                    //目标版块无发帖权
                    Tool::getInstance()->fail_json(Code::UN_POST_THREAD, Tool::getInstance()->lang('admin_move_nopermission'));
                }
            }

            $moderate = array();
            $stickmodify = 0;
            $toforumallowspecial = array(
                1 => $toforum['allowpostspecial'] & 1,
                2 => $toforum['allowpostspecial'] & 2,
                3 => isset($_G['setting']['extcredits'][$_G['setting']['creditstransextra'][2]]) && ($toforum['allowpostspecial'] & 4),
                4 => $toforum['allowpostspecial'] & 8,
                5 => $toforum['allowpostspecial'] & 16,
                127 => $_G['setting']['threadplugins'] ? dunserialize($toforum['threadplugin']) : array(),
            );
            foreach ($threadlist as $tid => $thread) {
                //$allowmove = 0;
                if (!$thread['special']) {
                    $allowmove = 1;
                } else {
                    if ($thread['special'] != 127) {
                        $allowmove = $toforum['allowpostspecial'] ? $toforumallowspecial[$thread['special']] : 0;
                    } else {
                        if ($toforumallowspecial[127]) {
                            $posttable = getposttablebytid($thread['tid']);
                            $message = C::t('forum_post')->fetch_threadpost_by_tid_invisible($thread['tid']);
                            $message = $message['message'];
                            $sppos = strrpos($message, chr(0) . chr(0) . chr(0));
                            $specialextra = substr($message, $sppos + 3);
                            $allowmove = in_array($specialextra, $toforumallowspecial[127]);
                        } else {
                            $allowmove = 0;
                        }
                    }
                }

                if ($allowmove) {
                    $moderate[] = $tid;
                    if (in_array($thread['displayorder'], array(2, 3))) {
                        $stickmodify = 1;
                    }
                    if ($_GET['type'] == 'redirect') {

                        $insertdata = array(
                            'fid' => $thread['fid'],
                            'readperm' => $thread['readperm'],
                            'author' => $thread['author'],
                            'authorid' => $thread['authorid'],
                            'subject' => $thread['subject'],
                            'dateline' => $thread['dateline'],
                            'lastpost' => $thread['dblastpost'],
                            'lastposter' => $thread['lastposter'],
                            'views' => 0,
                            'replies' => 0,
                            'displayorder' => 0,
                            'digest' => 0,
                            'closed' => $thread['tid'],
                            'special' => 0,
                            'attachment' => 0,
                            'typeid' => $_GET['threadtypeid']
                        );
                        $newtid = C::t('forum_thread')->insert($insertdata, true);
                        if ($newtid) {
                            C::t('forum_threadclosed')->insert(array('tid' => $thread['tid'], 'redirect' => $newtid), true, true);
                        }
                    }
                }
            }

            if (!$moderatetids = implode(',', $moderate)) {
                //您尚未选择主题或主题不可执行此类管理
                Tool::getInstance()->fail_json(Code::UN_DO_ACTION, Tool::getInstance()->lang('admin_moderate_invalid'));
            }
            $fieldarr = array(
                'fid' => $moveto,
                'isgroup' => 0,
                'typeid' => $_GET['threadtypeid'],
                'moderated' => 1
            );
            if ($_G['adminid'] == 3) {
                $fieldarr['displayorder'] = 0;
            }
            C::t('forum_thread')->update($tidsarr, $fieldarr, true);
            C::t('forum_forumrecommend')->update($tidsarr, array('fid' => $moveto));
            loadcache('posttableids');
            $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array('0');
            foreach ($posttableids as $id) {
                C::t('forum_post')->update_by_tid($id, $tidsarr, array('fid' => $moveto));
            }
            $typeoptionvars = C::t('forum_typeoptionvar')->fetch_all_by_tid_optionid($tidsarr);
            foreach ($typeoptionvars as $typeoptionvar) {
                C::t('forum_typeoptionvar')->update_by_tid($typeoptionvar['tid'], array('fid' => $moveto));
                C::t('forum_optionvalue')->update($typeoptionvar['sortid'], $typeoptionvar['tid'], $_G['fid'], "fid='$moveto'");
            }

            if ($_G['setting']['globalstick'] && $stickmodify) {
                require_once libfile('function/cache');
                updatecache('globalstick');
            }
            $modaction = 'MOV';
            $_G['toforum'] = $toforum;
            updateforumcount($moveto);
            updateforumcount($_G['fid']);
        }elseif($operation == 'delete') {

            loadcache('threadtableids');
            $stickmodify = 0;
            $deleteredirect = $remarkclosed = array();
            foreach($threadlist as $thread) {
                if($thread['digest']) {
                    updatecreditbyaction('digest', $thread['authorid'], array('digestposts' => -1), '', -$thread['digest']);
                }
                if(in_array($thread['displayorder'], array(2, 3))) {
                    $stickmodify = 1;
                }
                if($_G['forum']['status'] == 3 && $thread['closed'] > 1) {
                    $deleteredirect[] = $thread['closed'];
                }
                if($thread['isgroup'] == 1 && $thread['closed'] > 1) {
                    $remarkclosed[] = $thread['closed'];
                }
            }

            $modaction = 'DEL';
            require_once libfile('function/delete');
            $tids = array_keys($threadlist);
            //回收站开启
            if($_G['forum']['recyclebin']) {

                deletethread($tids, true, true, true);
                manage_addnotify('verifyrecycle', $modpostsnum);
            } else {

                deletethread($tids, true, true);
                $updatemodlog = FALSE;
            }

            $forumstickthreads = $_G['setting']['forumstickthreads'];
            $forumstickthreads = !empty($forumstickthreads) ? dunserialize($forumstickthreads) : array();
            $delkeys = array_keys($threadlist);
            foreach($delkeys as $k) {
                unset($forumstickthreads[$k]);
            }
            C::t('common_setting')->update('forumstickthreads', $forumstickthreads);

            C::t('forum_forum_threadtable')->delete_none_threads();
            if(!empty($deleteredirect)) {
                deletethread($deleteredirect);
            }
            if(!empty($remarkclosed)) {
                C::t('forum_thread')->update($remarkclosed, array('closed'=>0));
            }

            if($_G['setting']['globalstick'] && $stickmodify) {
                require_once libfile('function/cache');
                updatecache('globalstick');
            }

            updateforumcount($_G['fid']);

            if($_GET['crimerecord']) {
                include_once libfile('function/member');
                foreach($threadlist as $thread) {
                    crime('recordaction', $thread['authorid'], 'crime_delpost', lang('forum/misc', 'crime_postreason', array('reason' => $reason, 'tid' => $thread['tid'], 'pid' => 0)));
                }
            }
        }


        //之后的处理
        if($updatemodlog) {
            if($operation != 'delete') {
                updatemodlog($moderatetids, $modaction, $expiration);
            } else {
                updatemodlog($moderatetids, $modaction, $expiration, 0, $reason);
            }
        }

        updatemodworks($modaction, $modpostsnum);
        foreach($threadlist as $thread) {
            modlog($thread, $modaction);
        }
        //通知？
        if(($_G['group']['reasonpm'] == 2 || $_G['group']['reasonpm'] == 3) || $_GET['sendreasonpm'] == 1) {
            $modactioncode = lang('forum/modaction');
            $modtype = $modaction;
            $modaction = $modactioncode[$modaction];
            foreach($threadlist as $thread) {
                if($operation == 'move') {
                    sendreasonpm($thread, 'reason_move', array('tid' => $thread['tid'], 'subject' => $thread['subject'], 'modaction' => $modaction, 'reason' => $reason, 'tofid' => $toforum['fid'], 'toname' => $toforum['name'], 'from_id' => 0, 'from_idtype' => 'movethread'), 'post');
                } else {
                    sendreasonpm($thread, 'reason_moderate', array('tid' => $thread['tid'], 'subject' => $thread['subject'], 'modaction' => $modaction, 'reason' => $reason, 'from_id' => 0, 'from_idtype' => 'moderate_'.$modtype), 'post');
                }
            }
        }
        //更新数据
        if($stampstatus) {
            //edit  set_stamp($stampstatus, $stampaction, $threadlist, $expiration);
            $typeid = $stampstatus;
            $moderatetids = array_keys($threadlist);
//            if(empty($threadlist)) {
//                return false;
//            }
            if(array_key_exists($typeid, $_G['cache']['stamptypeid'])) {
                if($stampaction == 'SPD') {
                    C::t('forum_thread')->update($moderatetids, array('stamp'=>-1), true);
                } else {
                    C::t('forum_thread')->update($moderatetids, array('stamp'=>$_G['cache']['stamptypeid'][$typeid]), true);
                }
                !empty($moderatetids) && updatemodlog($moderatetids, $stampaction, $expiration, 0, '', $_G['cache']['stamptypeid'][$typeid]);
            }

        }
        $data = array(
            'action'=>$operation,
            'status'=>'success'
        );
        Tool::getInstance()->success_json( $data );
    }



    public function actionReplymanager(){
        global $_G;
        $operation = WebHelper::getPost('operation', '');   //  stickreply  banpost  delpost
        $_G['tid'] =intval( WebHelper::getPost('tid', ''));

        $_GET['stickreply'] =  WebHelper::getPost('sticktype', '');    //  1  置顶   0  解除置顶
        $_GET['banned'] = WebHelper::getPost('bantype', '');     // 屏蔽 1  解除 0

        $_GET['crimerecord'] = WebHelper::getPost('crimerecord', '0');  //违规登记 1 登记  0 不登记   delpost参数                        无用参数

        $_GET['sendreasonpm'] = intval(WebHelper::getPost('sendreasonpm', '0'));  //通知作者？？？？  1 通知   0 不通知       无用参数

        $_GET['reason'] = WebHelper::getPost('reason', '');                                                                    //理由 无用参数                                                                                                    //无用参数

        $pids  = WebHelper::getPost('pid', '');

        if($pids){
            $list = explode(',',$pids);
            $_GET['topiclist'] = $list;
        }else{
            $_GET['topiclist'] = array();
        }
        //云数据参数解析
        if($operation == '0'){
            $operation = 'delpost';
        }elseif($operation == '1'){
            $operation = 'banpost';
        }elseif($operation == '2'){
            $operation = 'stickreply';
        }
        $_GET['action'] = $operation;
        //参数验证
        if(!$_GET['action'] || !in_array($_GET['action'],array('stickreply','banpost','delpost')) || !$_G['tid'] || empty($_GET['topiclist'])){
            //参数错误
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        }

        require_once libfile('function/misc');
        if( !function_exists('loadforum') )
        {
            require_once( libfile( 'function/forum' ) );
        }
        loadforum(null,$_G['tid']);

        // 回帖管理 预处理--------------------------------------
        loadcache(array('modreasons', 'stamptypeid', 'threadtableids'));
        $modpostsnum = 0;
        $resultarray = $thread = array();

        $threadtableids = !empty($_G['cache']['threadtableids']) ? $_G['cache']['threadtableids'] : array();
        $specialperm = $_GET['action'] == 'stickreply' && $_G['thread']['authorid'] == $_G['uid'];

        if(!$specialperm && (!$_G['uid'] || !$_G['forum']['ismoderator'])) {
            //您没有权限使用管理功能
            Tool::getInstance()->fail_json(Code::NO_PERMISSION, Tool::getInstance()->lang('admin_nopermission'));
        }

        //$frommodcp = !empty($_GET['frommodcp']) ? intval($_GET['frommodcp']) : 0;

        if(!empty($_G['tid'])) {
            $_GET['archiveid'] = intval($_GET['archiveid']);
            $archiveid = 0;
            if(!empty($_GET['archiveid']) && in_array($_GET['archiveid'], $threadtableids)) {
                $archiveid = $_GET['archiveid'];
            }
            $displayorder = !$_G['forum_auditstatuson'] ? 0 : null;
            $thread = C::t('forum_thread')->fetch_by_tid_fid_displayorder($_G['tid'], $_G['fid'], $displayorder, $archiveid);
            if(!$thread) {
                //您没有权限使用管理功能
                Tool::getInstance()->fail_json(Code::NO_PERMISSION, Tool::getInstance()->lang('admin_nopermission'));
            }

        }
        if(($_G['group']['reasonpm'] == 2 || $_G['group']['reasonpm'] == 3) || !empty($_GET['sendreasonpm'])) {
            //$forumname = strip_tags($_G['forum']['name']);
            $sendreasonpm = 1;
        } else {
            $sendreasonpm = 0;
        }

        $_GET['handlekey'] = 'mods';

        //处理置顶，删除，屏蔽------------------------------
        if($_GET['action'] == 'stickreply'){
            $specialperm = $_GET['action'] == 'stickreply' && $_G['thread']['authorid'] == $_G['uid'];

            if(!$_G['group']['allowstickreply'] && !$specialperm) {
                //无权限管理
                Tool::getInstance()->fail_json(Code::UN_STICK_THREAD, Tool::getInstance()->lang('no_privilege_stick'));
            }

            $topiclist = $_GET['topiclist'];
            $sticktopiclist = $posts = array();
            foreach($topiclist as $pid) {
                $post = C::t('forum_post')->fetch('tid:'.$_G['tid'], $pid, false);
                $sticktopiclist[$pid] = $post['position'];
            }
            if($_GET['stickreply']) {
                foreach($sticktopiclist as $pid => $postnum) {
                    C::t('forum_poststick')->insert(array(
                        'tid' => $_G['tid'],
                        'pid' => $pid,
                        'position' => $postnum,
                        'dateline' => $_G['timestamp'],
                    ), false, true);
                }
            } else {
                foreach($sticktopiclist as $pid => $postnum) {
                    C::t('forum_poststick')->delete($_G['tid'], $pid);
                }
            }
            $sticknum = C::t('forum_poststick')->count_by_tid($_G['tid']);
            $stickreply = intval($_GET['stickreply']);
            if($sticknum == 0 || $stickreply == 1) {
                C::t('forum_thread')->update($_G['tid'], array('moderated'=>1, 'stickreply'=>$stickreply));
            }
            $modaction = $_GET['stickreply'] ? 'SRE' : 'USR';
            $reason = trim(strip_tags($_GET['reason']));
            $resultarray = array(
                //'redirect'	=> "forum.php?mod=viewthread&tid=$_G[tid]&page=$page",
                'reasonpm'	=> ($sendreasonpm ? array('data' => array(array('authorid' => $post['authorid'])), 'var' => 'post', 'notictype' => 'post', 'item' => $_GET['stickreply'] ? 'reason_stickreply': 'reason_stickdeletereply') : array()),
                'reasonvar'	=> array('tid' => $thread['tid'], 'subject' => $thread['subject'], 'modaction' => $modaction, 'reason' => $reason),
                'modlog'	=> $thread
            );

        }elseif($_GET['action'] == 'banpost'){
            $topiclist = $_GET['topiclist'];
            //$modpostsnum = count($topiclist);
            if(!($banpids = dimplode($topiclist))) {
                //您尚未选择要屏蔽的帖子
                Tool::getInstance()->fail_json(Code::UN_DO_ACTION, Tool::getInstance()->lang('admin_banpost_invalid'));
            } elseif(!$_G['group']['allowbanpost'] || !$_G['tid']) {
                //无权限
                Tool::getInstance()->fail_json(Code::UN_DO_BAN_POST, Tool::getInstance()->lang('no_privilege_banpost'));
            }

            $posts = $authors = array();
            $banstatus = 0;
            foreach(C::t('forum_post')->fetch_all('tid:'.$_G['tid'], $topiclist) as $post) {
                if($post['tid'] != $_G['tid']) {
                    continue;
                }
                $banstatus = ($post['status'] & 1) || $banstatus;
                $authors[$post['authorid']] = 1;
                $posts[] = $post;
            }

            //$authorcount = count(array_keys($authors));
            $banned = intval($_GET['banned']);
            include_once libfile('function/member');
            $modaction = $banned ? 'BNP' : 'UBN';

            $reason = trim(strip_tags($_GET['reason']));
            if(($_G['group']['reasonpm'] == 1 || $_G['group']['reasonpm'] == 3) && !$reason) {
                //您没有输入执行此变更的理由,app没理由这个东西所以注释了
                //Tool::getInstance()->fail_json(Code::EMPTY_REASON, Tool::getInstance()->lang('empty_reason'));
            }
            foreach($posts as $k => $post) {
                if($banned) {
                    C::t('forum_postcomment')->delete_by_rpid($post['pid']);
                    C::t('forum_post')->increase_status_by_pid('tid:'.$_G['tid'], $post['pid'], 1, '|', true);
                    crime('recordaction', $post['authorid'], 'crime_banpost', lang('forum/misc', 'crime_postreason', array('reason' => $reason, 'tid' => $_G['tid'], 'pid' => $post['pid'])));

                } else {
                    C::t('forum_post')->increase_status_by_pid('tid:'.$_G['tid'], $post['pid'], 1, '^', true);
                }
            }
            $resultarray = array(
                //'redirect'	=> "forum.php?mod=viewthread&tid=$_G[tid]&page=$page",
                'reasonpm'	=> ($sendreasonpm ? array('data' => $posts, 'var' => 'post', 'item' => 'reason_ban_post', 'notictype' => 'post') : array()),
                'reasonvar'	=> array('tid' => $thread['tid'], 'subject' => $thread['subject'], 'modaction' => $modaction, 'reason' => $reason),
                'modtids'	=> 0,
                'modlog'	=> $thread
            );
        }elseif($_GET['action'] == 'delpost'){
            require_once libfile('function/post');
            if(!$_G['group']['allowdelpost']) {
                Tool::getInstance()->fail_json(Code::UN_DEL_THREAD, Tool::getInstance()->lang('no_privilege_delete'));
            }

            $topiclist = $_GET['topiclist'];
            $modpostsnum = count($topiclist);

            $authorcount = $crimenum = 0;
            $crimeauthor = '';
            $crimeauthor = '';
            $pids = $posts = $authors = array();

            if(!($deletepids = dimplode($topiclist))) {
                //您尚未选择要删除的帖子
                Tool::getInstance()->fail_json(Code::UN_DO_ACTION, Tool::getInstance()->lang('admin_delpost_invalid'));
            }  else {
                $posttable = getposttablebytid($_G['tid']);
                foreach(C::t('forum_post')->fetch_all('tid:'.$_G['tid'], $topiclist, false) as $post) {
                    if($post['tid'] != $_G['tid']) {
                        continue;
                    }
                    if($post['first'] == 1) {
                        //TODO
                        //非法操作 不可操作主题帖
                        Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal operation'));
                        //dheader("location: $_G[siteurl]forum.php?mod=topicadmin&action=moderate&operation=delete&optgroup=3&fid=$_G[fid]&moderate[]=$thread[tid]&inajax=yes".($_GET['infloat'] ? "&infloat=yes&handlekey={$_GET['handlekey']}" : ''));
                    } else {
                        $authors[$post['authorid']] = 1;
                        $pids[] = $post['pid'];
                        $posts[] = $post;
                    }
                }
            }
            $reason = trim(strip_tags($_GET['reason']));
            if(($_G['group']['reasonpm'] == 1 || $_G['group']['reasonpm'] == 3) && !$reason) {
                //您没有输入执行此变更的理由,app没理由这个东西所以注释了
                //Tool::getInstance()->fail_json(Code::EMPTY_REASON, Tool::getInstance()->lang('empty_reason'));
            }
            $thread = C::t('forum_thread')->fetch($_G['tid']);
            $uidarray = $puidarray = $auidarray = array();
            $losslessdel = $_G['setting']['losslessdel'] > 0 ? TIMESTAMP - $_G['setting']['losslessdel'] * 86400 : 0;

            if($pids) {
                require_once libfile('function/delete');
                //回收站
                if($_G['forum']['recyclebin']) {
                    deletepost($pids, 'pid', true, false, true);
                    manage_addnotify('verifyrecyclepost', $modpostsnum);
                } else {
                    //帖子评分记录，，，，这个还是还是不加了吧，源码都有问题
//                    $logs = array();
//                    $ratelog = C::t('forum_ratelog')->fetch_all_by_pid($pids);
//                    $rposts = C::t('forum_post')->fetch_all('tid:'.$_G['tid'], $pids, false);
//                    foreach(C::t('forum_ratelog')->fetch_all_by_pid($pids) as $rpid => $author) {
//                        if($author['score'] > 0) {
//                            $rpost = $rposts[$rpid];
//                            updatemembercount($rpost['authorid'], array($author['extcredits'] => -$author['score']));
//                            $author['score'] = $_G['setting']['extcredits'][$id]['title'].' '.-$author['score'].' '.$_G['setting']['extcredits'][$id]['unit'];
//                            $logs[] = dhtmlspecialchars("$_G[timestamp]\t{$_G[member][username]}\t$_G[adminid]\t$rpost[author]\t$author[extcredits]\t$author[score]\t$thread[tid]\t$thread[subject]\t$delpostsubmit");
//                        }
//                    }
//                    if(!empty($logs)) {
//                        writelog('ratelog', $logs);
//                        unset($logs);
//                    }
                    deletepost($pids, 'pid', true);
                }

                if($_GET['crimerecord']) {
                    include_once libfile('function/member');

                    foreach($posts as $post) {
                        crime('recordaction', $post['authorid'], 'crime_delpost', lang('forum/misc', 'crime_postreason', array('reason' => $reason, 'tid' => $post['tid'], 'pid' => $post['pid'])));
                    }
                }
            }

            updatethreadcount($_G['tid'], 1);
            updateforumcount($_G['fid']);

            $_G['forum']['threadcaches'] && deletethreadcaches($thread['tid']);

            $modaction = 'DLP';

            $resultarray = array(
                //'redirect'	=> "forum.php?mod=viewthread&tid=$_G[tid]&page=$_GET[page]",
                'reasonpm'	=> ($sendreasonpm ? array('data' => $posts, 'var' => 'post', 'item' => 'reason_delete_post', 'notictype' => 'post') : array()),
                'reasonvar'	=> array('tid' => $thread['tid'], 'subject' => $thread['subject'], 'modaction' => $modaction, 'reason' => $reason),
                'modtids'	=> 0,
                'modlog'	=> $thread
            );

        }
        //处理后 日志记录
        if($resultarray['modtids']) {
            updatemodlog($resultarray['modtids'], $modaction, $resultarray['expiration']);
        }

        updatemodworks($modaction, $modpostsnum);
        if(is_array($resultarray['modlog'])) {
            if(isset($resultarray['modlog']['tid'])) {
                modlog($resultarray['modlog'], $modaction);
            } else {
                foreach($resultarray['modlog'] as $thread) {
                    modlog($thread, $modaction);
                }
            }
        }

        if($resultarray['reasonpm']) {
            $modactioncode = lang('forum/modaction');
            $modaction = $modactioncode[$modaction];
            foreach($resultarray['reasonpm']['data'] as $var) {
                sendreasonpm($var, $resultarray['reasonpm']['item'], $resultarray['reasonvar'], $resultarray['reasonpm']['notictype']);
            }
        }
        //TODO
        $data = array(
            'action'=>$_GET['action'],
            'status'=>'success'
        );
        Tool::getInstance()->success_json( $data );

    }

    private function _banlog($username, $origgroupid, $newgroupid, $expiration, $reason, $status = 0,$bannew) {
        global $_G;
        $cloud_apps = dunserialize($_G['setting']['cloud_apps']);
        if (isset($bannew) && $cloud_apps['security']['status'] == 'normal') { //判断不加   && $_POST['formhash']
            $securityService = Cloud::loadClass('Service_Security');
            if ($bannew) {
                $securityService->logBannedMember($username, $reason);
            } else {
                $securityService->updateMemberRecover($username);
            }
        }
        writelog('banlog', dhtmlspecialchars("$_G[timestamp]\t{$_G[member][username]}\t$_G[groupid]\t$_G[clientip]\t$username\t$origgroupid\t$newgroupid\t$expiration\t$reason\t$status"));
    }


}
?>