<?php
/**
 * QIANFAN搜索
 *
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2016/12/2
 * Time: 14:03
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class SearchController extends PluginController
{
    public $scriptPath;
    public $s;

    public function init() {

        parent::init();

        $pathAry = array(
            '.', 'source', 'plugin', 'qianfan', 'static', 'search', 'js', ''
        );
        $this->scriptPath = implode(DIRECTORY_SEPARATOR, $pathAry);

        $this->s = !empty(Yii::app()->params['search_id']) ? Yii::app()->params['search_id'] : '';
    }

    public function actionIndex() {
        global $_G;
        require_once( libfile('function/forum') );
        require_once( libfile('function/search') );
        loaducenter();

        $keyword = $_GET['keyword'] ? $_GET['keyword'] : '李';
        $page = $_GET['page'] ? intval($_GET['page']) : 1;

        if( strtoupper( Yii::app()->params['site_charset'] ) != 'UTF-8' ) {
            $keyword = mb_convert_encoding($keyword, 'GBK', 'UTF-8');
        }

        // 搜索用户
        $srchuid = array_keys(C::t('common_member')->fetch_all_by_like_username($keyword, 0, 50));
        $user_num = count($srchuid);
        $usernames = C::t('common_member')->fetch_all_username_by_uid($srchuid);

        $i = 0;
        foreach( $srchuid as $uid ) {
            $i++;
            $user['id'] = $uid;
            $user['username'] = $usernames[$uid];
            $user['icon'] = discuz_uc_avatar($uid, 'middle', true);
            $user['def_icon'] = UC_API ? UC_API.'/images/noavatar_middle.gif' : '';
            $users[] = $user;
            if($i>2) break;
        }

        // 帖子
        if( !empty($this->s) ) {
            $page = $page-1;
            $tids = $this->_soThread($keyword, $page);
        }else {
            $start = ($page-1)*10;
            $limit = 10;
            $tids = $this->_searchThread($keyword);
        }
        $data = array();
        if(!empty($tids))
                $data = C::t('forum_thread')->fetch_all_by_tid_fid_displayorder($tids, 0, 0, 'dateline', $start, $limit);
        $posts = array();
        if(!empty($data)) {
            foreach($data as $key => $val) {
                $posts[] = array(
                    'id' => $val['tid'],
                    'subject' => bat_highlight($val['subject'], $keyword),
                    'author' => $val['author'],
                    'postdate' => date("y-m-d",$val['dateline']),
                    'fname' => '',
                );
            }
        }

        if($_GET['type']=='ajax')
        {
            echo CJSON::encode($posts);
        }
        else
        {
			if( strtoupper( Yii::app()->params['site_charset'] ) != 'UTF-8' ) {
                $code = 'gbk';
            }else{
                $code = 'utf-8';
            }
            $_keyword = mb_substr($keyword,0,10,$code);
            if($keyword != $_keyword) $_keyword .= '...';
			
            $this->render( 'index', array(
                'keyword' => $_keyword,
                'user_num' => $user_num,
                'users' => $users,
                'posts' => $posts,
            ) );
        }
    }

    public function actionUser() {
        global $_G;
        require_once( libfile('function/forum') );
        loaducenter();

        $keyword = $_GET['keyword'] ? $_GET['keyword'] : '';
        // 搜索用户
        $srchuid = array_keys(C::t('common_member')->fetch_all_by_like_username($keyword, 0, 50));
        $user_num = count($srchuid);
        $usernames = C::t('common_member')->fetch_all_username_by_uid($srchuid);

        foreach( $srchuid as $uid ) {
            $user['id'] = $uid;
            $user['username'] = $usernames[$uid];
            $user['icon'] = discuz_uc_avatar($uid, 'middle', true);
            $user['def_icon'] = UC_API ? UC_API.'/images/noavatar_middle.gif' : '';
            $users[] = $user;
        }

        $this->render( 'user', array(
            'keyword' => $keyword,
            'user_num' => $user_num,
            'users' => $users,
        ) );
    }

    private function _searchThread($srchtxt) {
        global $_G;
        require_once libfile('class/sphinx');

        $s = new SphinxClient();
        $s->setServer($_G['setting']['sphinxhost'], intval($_G['setting']['sphinxport']));
        $s->setMaxQueryTime(intval($_G['setting']['sphinxmaxquerytime']));
        $s->SetRankingMode($_G['setting']['sphinxrank']);
        $s->setLimits(0, intval($_G['setting']['sphinxlimit']), intval($_G['setting']['sphinxlimit']));
        $s->setGroupBy('tid', SPH_GROUPBY_ATTR);

        if($srchtxt) {
            if(preg_match("/\".*\"/", $srchtxt)) {
                $spx_matchmode = "PHRASE";
                $s->setMatchMode(SPH_MATCH_PHRASE);
            } elseif(preg_match("(AND|\+|&)", $srchtxt) && !preg_match("(OR|\|)", $srchtxt)) {
                $srchtxt = preg_replace("/( AND |&)/is", "+", $srchtxt);
                $spx_matchmode = "ALL";
                $s->setMatchMode(SPH_MATCH_ALL);
            } else {
                $srchtxt = preg_replace("/( OR |\|)/is", "+", $srchtxt);
                $spx_matchmode = 'ANY';
                $s->setMatchMode(SPH_MATCH_ANY);
            }
            $srchtxt = str_replace('*', '%', addcslashes($srchtxt, '%_'));
        }

        // $result = $s->query("'$srchtxt'", $_G['setting']['sphinxmsgindex']);    // 全文搜索
        $result = $s->query($srchtxt, $_G['setting']['sphinxsubindex']);      // 只搜标题

        $tids = array();
        if($result) {
            if(is_array($result['matches'])) {
                foreach($result['matches'] as $value) {
                    if($value['attrs']['tid']) {
                        $tids[$value['attrs']['tid']] = $value['attrs']['tid'];
                    }
                }
            }
        }
        return $tids;
    }

    /**
     * 百度站内搜索
     *
     * @param $keyword
     * @param $page
     * @param string $srt  搜索结果排序，默认  cse_createTime：发布时间  cse_category2：回复数
     * @param int $fst  搜索类型，0：帖子 1：板块 2：用户
     * @param int $stp 是否全文检索 0：全文 1：标题
     * @param int $nsid
     * @param int $nojc 是否模糊搜索，0:模糊搜索(例如keyword=qianfan，搜索为'千帆'的结果)，1:精确搜索
     * @return array
     */
    private function _soThread($keyword, $page, $srt='cse_createTime', $fst=0, $stp=1, $nsid=0, $nojc=1) {
        $urlThread="http://zhannei.baidu.com/api/customsearch/searchwap?q=".urlencode($keyword)."&s=".$this->s."&p=".$page."&srt=".$srt."&stp=".$stp."&fst=".$fst."&nsid=".$nsid."&nojc=".$nojc;
        $content = dfsockopen($urlThread, 0, '', '', FALSE, '', $time=5);
        $thread = CJSON::decode($content);
        $data = array();
        if( !empty($thread['results']) ) {
            foreach($thread['results'] as $k => $v) {
                $data[] = self::getTidByThreadurl($v['url']);
            }
        }
        return $data;
    }

    /**
     * 解析url,获取tid
     *
     * @param $url
     * @return int|mixed
     */
    public static function getTidByThreadurl($url) {
        $matchUrl = Yii::app()->params['thread_match'];
        $tid = 0;
        if( !empty($matchUrl) && is_int(strpos($matchUrl, '{ID}')) ) {
            $matchStr = explode('{ID}', $matchUrl);
            $tid = str_replace(array($matchStr[0], $matchStr[1]), '', $url);
        }
        return $tid;
    }

}