<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 16/2/1
 * Time: 下午2:45
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
require_once DISCUZ_ROOT . './config/config_ucenter.php';

class SettingController extends Controller
{

    public function actionFetchsmiles()
    {
        global $_G;

        $smileCategory = C::t('forum_imagetype')->fetch_all_by_type('smiley');

        $fetched = array(
            'face' => array()
        );

        $smileRootUrl = rtrim( $_G['setting']['siteurl'] , '/' ) . '/' . './static/image/smiley/';

        if( !empty($smileCategory) )
        {
            $smileRoot = DISCUZ_ROOT . './static/image/smiley/';

            //循环表情分类
            foreach( $smileCategory as $key => $category )
            {
                if( $category['available'] )
                {
                    $smileDir = $smileRoot . $category['directory'];
                    if( is_dir( $smileDir) )
                    {
                        $smiles = C::t('common_smiley')->fetch_all_by_typeid_type($category['typeid'], 'smiley', 0, 0);
                        if( !empty($smiles) )
                        {
                            foreach( $smiles as $k => $v )
                            {
                                $smiles[$k]['path'] = $category['directory'] . '/' . $v['url'];
                                $smiles[$k]['url'] = $smileRootUrl . $smiles[$k]['path'];
                                unset($smiles[$k]['type']);
                                unset($smiles[$k]['typeid']);
                                unset($smiles[$k]['displayorder']);

                                $fetched['face'][] = $smiles[$k];
                            }
                        }
                    }
                }
            }
        }

        Tool::getInstance()->success_json( $fetched );
    }

    /**
     * 查看API版本号
     */
    public function actionVer()
    {
        if( isset(Yii::app()->params['api_version']) )
        {
            Tool::getInstance()->success_json(array('api_version' => Yii::app()->params['api_version']));
        }
        else
        {
            Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
        }
    }

    /**
     * 根据原密码修改密码
     * tpye=0 根据uid修改
     * type=1 根据用户名密码修改
     *
     */
    public function actionChangePwd() {
        global $_G;

        $username = WebHelper::getPost('pwuser', '');
        $password = WebHelper::getPost('pwpwd', '');
        $newPwd = WebHelper::getPost('newpwd', '');
        $type = WebHelper::getPost('type', 0);
        $uid = $_G['uid'];

        $_GET['username'] = $username;
        $_GET['password'] = $password;
        $_GET['questionid'] = $_GET['answer'] = '';
        $_GET['loginfield'] = 'username';

        require_once libfile('class/member');
        loaducenter();

        // 根据uid直接修改
        if( $type == 0 && !empty($uid) && !empty($newPwd)) {
            $ucuser = uc_get_user( $uid, 1 );
            if( $ucuser ) {
                $ucresult = uc_user_edit( $ucuser[1], NULL, $newPwd, NULL, 1 );
                if( $ucresult == -8 ) {
                    Tool::getInstance()->fail_json( Code::USER_PROTECTED, Tool::getInstance()->lang('user_protected') );
                } else {
                    C::t('common_member')->update($uid, array('password' => md5(random(10))));
                    Tool::getInstance()->success_json(array());
                }
            }else {
                Tool::getInstance()->fail_json( Code::USER_NOT_EXISTS, Tool::getInstance()->lang( 'user_not_exists' ) );
            }
        }

        // 用户名是否为空
        if ( trim($_GET['username']) == '' ) {
            Tool::getInstance()->fail_json( Code::USERNAME_EMPTY, Tool::getInstance()->lang('username can not be empty') );
        }

        // 密码是否为空或者包含非法字符
        if( !$_GET['password'] || $_GET['password'] != addslashes($_GET['password']) || !$newPwd ||  $newPwd != addslashes($newPwd)) {
            Tool::getInstance()->fail_json( Code::PASSWORD_ILLEGAL, Tool::getInstance()->lang('profile password illegal') );
        }

        // 更新密码
        $ucresult = uc_user_edit(addslashes($_GET['username']), $_GET['password'], $newPwd, NULL);
        if( $ucresult == -8 ) {
            Tool::getInstance()->fail_json( Code::USER_PROTECTED, Tool::getInstance()->lang('user_protected') );
        }elseif( $ucresult == -1 ) {
            Tool::getInstance()->fail_json( Code::OLD_PASSWORD_INCORRECT, Tool::getInstance()->lang('old password incorrect') );
        }else {
            C::t('common_member')->update($_G['uid'], array('password' => md5(random(10))));
            Tool::getInstance()->success_json( array() );
        }
    }


    /**
     * 账号绑定和解绑第三方平台
     * BIND 绑定
     * UNBIND 解绑
     *
     */
    public function actionChangeThirdPlatform() {
        global $_G;

        $uid = WebHelper::getPost('uid', 0);
        $operation = WebHelper::getPost('operation', 'BIND');
        $weibotype = WebHelper::getPost('weibotype', '');
        $openid = WebHelper::getPost('openid', '');
        $unionid = WebHelper::getPost('unionid', '');
        $nickname = WebHelper::getPost('nickname', '');
		
        if($weibotype == 'weibo'){
            $weibotype = 'sinaweibo';
        }
        if( !empty($uid) && $uid>0 ) {
            $_G['uid'] = $uid;
        }
        loaducenter();
        $ucuser = uc_get_user( $_G['uid'], 1 );
        if( !$_G['uid'] || !($operation == 'BIND' || $operation == 'UNBIND') || !$weibotype || empty($ucuser) ) {
            Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) );
        }
        $this->_updateUserToDiscuz($_G['uid'], $ucuser);
        $uid = $_G['uid'];

        $result = DB::result_first("SELECT uid FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array("thirdbind", $uid, $weibotype));
        if( $weibotype == 'qq' && empty($result) ) {
            $result = DB::fetch_first( "SELECT * FROM %t WHERE uid = %s", array(
                'common_member_connect',
                $uid
            ) );
        }
        if( $operation == 'UNBIND' ) {
            if( empty($result) ) {
                Tool::getInstance()->fail_json( Code::NOT_BIND_PLATFORM, Tool::getInstance()->lang('not bind platform') );
            }
            DB::delete('thirdbind', "uid='$uid' AND weibotype='$weibotype'");
            if( $weibotype == 'qq' ) {
                DB::delete( 'common_member_connect', DB::field('uid', $uid) );
                C::t('common_member')->update( $uid,array('conisbind'=>0) );
            }
            Tool::getInstance()->success_json( array() );
        }else {
            // 判断用户是否绑定了同样的第三方账号
            if( !empty($result) ) {
                Tool::getInstance()->fail_json( Code::BIND_OTHER_PLATFORM, Tool::getInstance()->lang('bind_other_platform') );
            }

            // 判断平台账号是否绑定了本地用户
            if( $weibotype == 'wechat' && !empty($unionid) ) {
                $user = DB::fetch_first("SELECT * FROM %t WHERE unionid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $unionid,
                    $weibotype
                ));
            }else {
                $user = DB::fetch_first("SELECT * FROM %t WHERE openid = %s AND weibotype = %s LIMIT 1", array(
                    'thirdbind',
                    $openid,
                    $weibotype
                ));
            }
            if( $weibotype == 'qq' && !$user ) {
                $user = DB::fetch_first( "SELECT * FROM %t WHERE conopenid = %s", array(
                    'common_member_connect',
                    $openid
                ) );
            }

            if( !empty($user) ) {
                Tool::getInstance()->fail_json( Code::BIND_OTHER_ACCOUNT, Tool::getInstance()->lang('bind_other_account') );
            }

            // 更新绑定信息
            $insertData = array();
            $insertData['uid'] = $uid;
            $insertData['weibotype'] = $weibotype;
            $insertData['openid'] = $openid;
            $insertData['dateline'] = time();
            if( $unionid ) {
                $insertData['unionid'] = $unionid;
            }
            if( $nickname ) {
                $insertData['nickname'] = $nickname;
            }
            $platformId = DB::insert( 'thirdbind', $insertData, true );

            if( $weibotype == 'qq' ) {
                $insertConnect['conopenid'] = $openid;
                $insertConnect['uid'] = $uid;
                if( $openid && $uid ) {
                    $platformId = DB::insert('common_member_connect', $insertConnect, false);
                }
                C::t('common_member')->update($uid, array('conisbind'=>1));
            }

            if( !$platformId ) {
                Tool::getInstance()->fail_json( Code::BIND_PLATFORM_FAIL, Tool::getInstance()->lang('bind_platform_fail') );
            }

            Tool::getInstance()->success_json(array());
        }
    }

    /**
     * 根据uids获取用户手机号，第三方绑定情况
     *
     */
    public function actionGetUserinfoByUid() {
        $uid = WebHelper::getPost('uid', 0);

        if( !$uid ) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }
        $phone = DB::result_first("SELECT phone FROM %t WHERE uid=%s LIMIT 1", array('phonebind', $uid));
        $phone = $phone ? $phone : '';

        $wechat = DB::fetch_first("SELECT * FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array('thirdbind', $uid, 'wechat'));

        $qq = DB::fetch_first("SELECT * FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array('thirdbind', $uid, 'qq'));

        if( empty($qq) ) {
            $qq = DB::fetch_first("SELECT * FROM %t WHERE uid=%s LIMIT 1", array('common_member_connect', $uid));
            if( !empty($qq) ){
                $qq['openid'] = $qq['conopenid'];
            }
        }

        $weibo = DB::fetch_first("SELECT * FROM %t WHERE uid=%s AND weibotype=%s LIMIT 1", array('thirdbind', $uid, 'sinaweibo'));

        $data = array(
            'phone' => $phone,
            'wechat' => $wechat ? $wechat : array(),
            'qq' => $qq ? $qq : array(),
            'weibo' => $weibo ? $weibo : array()
        );

        Tool::getInstance()->success_json($data);
    }

    /**
     * 绑定和解绑手机号
     * 绑定更新 BIND
     * 解绑    UNBIND
     *
     */
    public function actionChangeUsermobile() {
        global $_G;

        $mobile = WebHelper::getPost('mobile', '');
        $uid = WebHelper::getPost('uid', 0);
        $operation = WebHelper::getPost('operation', 'BIND');

        if( !empty($uid) && $uid>0 ) {
            $_G['uid'] = $uid;
        }

        loaducenter();
        $ucuser = uc_get_user( $_G['uid'], 1 );
        // 登录判断
        if( !$_G['uid'] && empty($ucuser) ) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login') );
        }
        $uid = $_G['uid'];
        $this->_updateUserToDiscuz($uid, $ucuser);

        if( !empty($operation) && $operation == 'UNBIND' ) {
            $phone = DB::result_first("SELECT phone FROM %t WHERE uid=%s LIMIT 1", array('phonebind', $_G['uid']));
            if( !empty($phone) ) {
                DB::delete('phonebind', DB::field('uid', $uid));
//                DB::query( "DELETE" . DB::table("phonebind") . " WHERE uid=" . $uid );
                Tool::getInstance()->success_json(array());
            }else {
                Tool::getInstance()->fail_json( Code::NOT_BIND_PHONE, Tool::getInstance()->lang( 'not bind phone' ) );
            }
        }

        // 验证手机号合法性
        if( !preg_match( '/^1[34578]{1}\d{9}$/', $mobile ) ) {
            Tool::getInstance()->fail_json( Code::ILLEGAL_MOBILE, Tool::getInstance()->lang( 'illegal_mobile' ) );
        }

        // 手机号是否绑定了账号
        if( $uid = DB::result_first("SELECT uid FROM %t WHERE phone=%s LIMIT 1", array('phonebind', $mobile)) ) {
            $username = DB::result_first("SELECT username FROM %t WHERE uid=%d LIMIT 1", array("common_member", $uid));
            $shortUserName = mb_substr( $username, 0, mb_strlen($username, Yii::app()->charset) - 1, Yii::app()->charset ) . '**';
            Tool::getInstance()->fail_json( Code::MOBILE_EXISTS, Tool::getInstance()->lang('mobile_exists', array('{username}' => $shortUserName)) );
        }

        if( DB::result_first("SELECT uid FROM %t WHERE uid=%d LIMIT 1", array("phonebind", $_G['uid'])) ) {
            DB::update( "phonebind", array("phone" => $mobile), "uid=" . $_G['uid'] );
        } else {
            DB::insert( "phonebind", array("uid" => $_G['uid'], "phone" => $mobile, "dateline" => TIMESTAMP) );
        }

        Tool::getInstance()->success_json(array());
    }

    /**
     * 根据uids, usernames, phones,unionids,来查找用户信息
     * type为查询方式参数,1:uids 2:usernames 3:phones 4:unionids
     * 最多100条，否则视为攻击
     * 返回uid username avatar phone
     *
     */
    public function actionGetUserinfoByType() {
        global $_G;
        require_once( libfile('function/forum') );

        $type =  WebHelper::getPost('type', 1);
        $uids = WebHelper::getPost('uids', '');
        $usernames = WebHelper::getPost('usernames', '');
        $phones = WebHelper::getPost('phones', '');
        $unionids = WebHelper::getPost('unionids', '');

        $result = array();

        if( $type == 1 && !empty($uids) ) {
            $uidArr = explode(',', $uids);
            if( count($uidArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $uidName = C::t('common_member')->fetch_all_username_by_uid($uidArr);
            $uidPhone = DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $uidArr));
            $phone = array();
            foreach($uidPhone as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }

            foreach( $uidArr as $k => $v ) {
                $result[$k]['uid'] = $v;
                $result[$k]['username'] = $uidName[$v] ? $uidName[$v] : '';
                $result[$k]['phone'] = $phone[$v] ? $phone[$v] : '';
                $result[$k]['avatar'] = discuz_uc_avatar( $v, 'big', true );

            }

        }elseif( $type == 2 && !empty($usernames) ) {
            $usernameArr = explode(',', $usernames);
            if( count($usernameArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $usernameArr = C::t('common_member')->fetch_all_uid_by_username($usernameArr);
            $usernameUid = array_flip($usernameArr);

            $uidPhone = DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $usernameArr));
            $phone = array();
            foreach($uidPhone as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }

            foreach( $usernameUid as $k => $v ) {
                $results['uid'] = $k;
                $results['username'] = $v;
                $results['phone'] = $phone[$k] ? $phone[$k] : '';
                $results['avatar'] = discuz_uc_avatar( $k, 'big', true );

                $result[] = $results;
            }
        }elseif( $type == 3 && !empty($phones) ) {
            $phoneArr = explode(',', $phones);
            if( count($phoneArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $phoneUid = DB::fetch_all("SELECT * FROM %t WHERE phone in (%n)", array('phonebind', $phoneArr));
            $phone = array();
            foreach($phoneUid as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }
            $uidArr = array_flip($phone);
            $uidName = C::t('common_member')->fetch_all_username_by_uid($uidArr);

            foreach( $phone as $k => $v ) {
                $results['uid'] = $k;
                $results['username'] = $uidName[$k] ? $uidName[$k] : '';
                $results['phone'] = $v ? $v : '';
                $results['avatar'] = discuz_uc_avatar( $k, 'big', true );

                $result[] = $results;
            }

        }elseif( $type == 4 && $unionids) {
            $unionidArr = explode(',', $unionids);
            if( count($unionidArr) >= 100 ) {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            $unionidUid = DB::fetch_all("SELECT * FROM %t WHERE unionid in (%n)", array('thirdbind', $unionidArr));
            $unionid = array();
            foreach($unionidUid as $k => $v) {
                $unionid[$v['uid']] = $v['unionid'];
            }
            $uidArr = array_flip($unionid);

            $uidName = C::t('common_member')->fetch_all_username_by_uid($uidArr);

            $uidPhone = DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $uidArr));
            $phone = array();
            foreach($uidPhone as $k => $v) {
                $phone[$v['uid']] = $v['phone'];
            }

            foreach( $unionid as $k => $v ) {
                $results['uid'] = $k;
                $results['username'] = $uidName[$k] ? $uidName[$k] : '';
                $results['phone'] = $phone[$k] ? $phone[$k] : '';
                $results['avatar'] = discuz_uc_avatar( $k, 'big', true );

                $result[] = $results;
            }
        }else {
            Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) );
        }

        Tool::getInstance()->success_json($result);
    }


    /**
     * 修改用户名
     * 优化为只主动更新uc和论坛用户表，其余按照ucenter机制以uc消息队列的方式更新
     */
    public function actionChangeUsername() {
        global $_G;
        require libfile('class/member');

        $newusername =  WebHelper::getPost('newusername', '');
        $ctlObj = new register_ctl();
        $ctlObj->setting = $_G['setting'];
        loaducenter();

        $ucuser = uc_get_user( $_G['uid'], 1 );
        $username = $ucuser[1];
        $uid = $ucuser[0];
        $email = $ucuser[2];
        $newusername = trim($newusername);

        if( empty($_G['uid']) || $_G['uid']<=0 || empty($username) ) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }

        /**********新用户名的相关限制*********/
        // 论坛禁用用户名关键字
        $censorexp = '/^('.str_replace(array('\\*', "\r\n", ' '), array('.*', '|', ''), preg_quote(($ctlObj->setting['censoruser'] = trim($ctlObj->setting['censoruser'])), '/')).')$/i';
        if($ctlObj->setting['censoruser'] && @preg_match($censorexp, $newusername)) {
            Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_PROTECT, Tool::getInstance()->lang( 'profile username protect' ) );
        }

        // 判断用户名长度
        $usernamelen = dstrlen($newusername);
        if($usernamelen < 3) {
            Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_TOOSHORT, Tool::getInstance()->lang( 'profile username tooshort' ) );
        } elseif($usernamelen > 15) {
            Tool::getInstance()->fail_json( Code::PROFILE_USERNAME_TOOLONG, Tool::getInstance()->lang( 'profile username toolong' ) );
        }

        // 用户名是否已经存在
        if( uc_get_user($newusername) ) {
            Tool::getInstance()->fail_json( Code::USERNAME_EXISTS, Tool::getInstance()->lang('username_exists') );
        }
        /********************************/


        // 自定义DB类,初始化uc_server数据库
        $db = new UcServerDb();
        $db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, UC_DBCHARSET, UC_DBCONNECT, UC_DBTABLEPRE);
        $apps = $db->fetch_all("SELECT * FROM ".UC_DBTABLEPRE."applications limit 100");
        if( empty($apps) ) {
            Tool::getInstance()->fail_json( Code::UC_DATABASE_CONNECT_FAIL, Tool::getInstance()->lang( 'uc database connect fail' ) );
        }

        // uc发送通知
        $operation = 'renameuser';
        $getdata = 'uid='.$uid.'&oldusername='.urlencode($username).'&newusername='.urlencode($newusername);
        $postdata = '';
        $appids = array();
        $pri = 0;
        foreach( $apps as $k => $app ) {
//            if( is_int(strpos(strtoupper($app['type']), 'DISCUZ')) ) continue;
            $appid = $app['appid'];
            if($appid == intval($appid)) {
                if($appids && !in_array($appid, $appids)) {
                    $appadd[] = 'app'.$appid."='1'";
                } else {
                    $varadd[] = "('noteexists{$appid}', '1')";
                }
            }
        }
        if($appadd) {
            $extra = implode(',', $appadd);
            $extra = $extra ? ', '.$extra : '';
        }
        if($varadd) {
            $varextra = implode(', ', $varadd);
            $varextra = $varextra ? ', '.$varextra : '';
        }
        $getdata = addslashes($getdata);
        $postdata = addslashes($postdata);
        $db->query("INSERT INTO ".UC_DBTABLEPRE."notelist SET getdata='$getdata', operation='$operation', pri='$pri', postdata='$postdata'$extra");
        $insert_id = $db->insert_id();
        $insert_id && $db->query("REPLACE INTO ".UC_DBTABLEPRE."vars (name, value) VALUES ('noteexists', '1')$varextra");

        // 更新用户名
        $sqladd = "username='$newusername', ";
        $db->query("UPDATE ".UC_DBTABLEPRE."members SET $sqladd email='$email' WHERE uid='$uid'");
        $user = uc_get_user($uid, 1);

        // 同步到discuz论坛
        $get = array(
            'uid' => $uid,
            'newusername' => $newusername
        );
        $result = $this->_rename($get);

        if( empty($user[1]) || $newusername != $user[1] || !$result ) {
            Tool::getInstance()->fail_json( Code::RENAME_FAIL, Tool::getInstance()->lang( 'rename fail' ) );
        }

        Tool::getInstance()->success_json(array('newusername' => $user[1]));
    }

    /**
     * 搜索接口
     *
     */
    public function actionSearch() {
        global $_G;
        require_once( libfile('function/forum') );

        $keyword = WebHelper::getPost('keyword', '');
        $type = WebHelper::getPost('type', 0); // 0默认全部搜索，1：只搜索用户，2只搜索帖子
        $page = WebHelper::getPost('page', 0);
        $data = array(
            'thread' => array(),
            'user' => array()
        );

        // 搜索用户
        if( isset($type) && $type != 2 ) {
            $uids = WebHelper::zhanneiSearch($keyword,$page,'def', 2);
            $usernames = C::t('common_member')->fetch_all_username_by_uid($uids);
            $userGenders = DB::fetch_all("SELECT uid,gender FROM %t WHERE uid in (%n)", array("common_member_profile", $uids));
            $userSigns = DB::fetch_all("SELECT uid,sightml FROM %t WHERE uid in (%n)", array("common_member_field_forum", $uids));
            if( !empty($userGenders) && is_array($userGenders) ) {
                foreach( $userGenders as $k => $v ) {
                    $userGender[$v['uid']] = intval($v['gender']);
                }
            }

            if( !empty($userSigns) && is_array($userSigns) ) {
                foreach( $userSigns as $k => $v ) {
                    $userSign[$v['uid']] = strip_tags($v['sightml']);
                }
            }

            $users = array();
            foreach( $uids as $uid ) {
                $user['id'] = $uid;
                $user['username'] = $usernames[$uid];
                $user['icon'] = discuz_uc_avatar($uid, 'middle', true);
                $user['gender'] = isset($userGender[$uid]) ? $userGender[$uid] : 0;
                $user['sign'] = isset($userSign[$uid]) ? $userSign[$uid] : '';
                $users[] = $user;
            }
            $data['user'] = $users;

        }

        // 搜索帖子
        if( isset($type) && $type != 1 ) {
            $tids = WebHelper::zhanneiSearch($keyword,$page);
//            $thread = array();
//            if(!empty($tids)) {
//                $thread = C::t('forum_thread')->fetch_all_by_tid_fid_displayorder($tids, 0, 0, 'dateline');
//            }
            $posts = array();
            if(!empty($tids)) {
                $offset = 0;
                foreach($tids as $key => $val) {
                    $posts[$offset]['tid'] = $val['tid'];
                    $posts[$offset]['subject'] = $val['subject'];
                    $posts[$offset]['author'] = $val['author'];
                    $posts[$offset]['postdate'] = $val['postdate'];
                    $posts[$offset]['views'] = $val['views'];
                    $posts[$offset]['attachs'] = array();

                    //获取附件
                    $attach = array();
                    $pre = DB::$db->tablepre;
                    $v['pid'] = DB::result_first('SELECT pid FROM '.$pre.'forum_post WHERE tid = '.intval($val['tid']).' AND first = 1');

                    if(!empty($val['attachment'])) {
                        $attachments = C::t('forum_attachment')->fetch_all_by_id('tid', array($val['tid']));
                        if($attachments && is_array($attachments) && !empty($attachments)) {
                            $i = 1;
                            foreach ($attachments as $attachment) {
                                if($v['pid'] == $attachment['pid']){
                                    $table_index = $attachment['tableid'];
                                    $attachment = C::t('forum_attachment_n')->fetch($table_index, $attachment['aid'], false);
                                    if(!$attachment['isimage']) continue;
                                    //获取附件数量
                                    $temp['attnum'] = C::t('forum_attachment_n')->count_image_by_id($table_index,'pid',$attachment['pid']);
                                    if( $temp['attnum'] == 2 ) {
                                        if($i>1) break;
                                    }else {
                                        if($i>3) break;
                                    }

                                    if( !empty($attachment) ) {
                                        if( $attachment['remote'] == 1 ) {
                                            $attach[] = $_G['setting']['ftp']['attachurl'].'forum/' . $attachment['attachment'];
                                        } else {
                                            $attach[] = $_G['setting']['attachurl'].'forum/'.$attachment['attachment'];
                                        }
                                    }
                                    $i++;
                                }
                            }
                            $posts[$offset]['attachs'] = $attach;
                            unset($attach);
                        }
                    }
                    $offset++;
                }
            }
            $data['thread'] = $posts;
        }
        Tool::getInstance()->success_json($data);
    }

    private function _rename( $get ) {
        global $_G;

        if( empty($get) || intval($get['uid'])<=0 ) {
            return false;
        }

        $tables = array(
            'common_block' => array('id' => 'uid', 'name' => 'username'),
            'common_invite' => array('id' => 'fuid', 'name' => 'fusername'),
            'common_member_verify_info' => array('id' => 'uid', 'name' => 'username'),
            'common_mytask' => array('id' => 'uid', 'name' => 'username'),
            'common_report' => array('id' => 'uid', 'name' => 'username'),

            'forum_thread' => array('id' => 'authorid', 'name' => 'author'),
            'forum_activityapply' => array('id' => 'uid', 'name' => 'username'),
            'forum_groupuser' => array('id' => 'uid', 'name' => 'username'),
            'forum_pollvoter' => array('id' => 'uid', 'name' => 'username'),
            'forum_post' => array('id' => 'authorid', 'name' => 'author'),
            'forum_postcomment' => array('id' => 'authorid', 'name' => 'author'),
            'forum_ratelog' => array('id' => 'uid', 'name' => 'username'),

            'home_album' => array('id' => 'uid', 'name' => 'username'),
            'home_blog' => array('id' => 'uid', 'name' => 'username'),
            'home_clickuser' => array('id' => 'uid', 'name' => 'username'),
            'home_docomment' => array('id' => 'uid', 'name' => 'username'),
            'home_doing' => array('id' => 'uid', 'name' => 'username'),
            'home_feed' => array('id' => 'uid', 'name' => 'username'),
            'home_feed_app' => array('id' => 'uid', 'name' => 'username'),
            'home_friend' => array('id' => 'fuid', 'name' => 'fusername'),
            'home_friend_request' => array('id' => 'fuid', 'name' => 'fusername'),
            'home_notification' => array('id' => 'authorid', 'name' => 'author'),
            'home_pic' => array('id' => 'uid', 'name' => 'username'),
            'home_poke' => array('id' => 'fromuid', 'name' => 'fromusername'),
            'home_share' => array('id' => 'uid', 'name' => 'username'),
            'home_show' => array('id' => 'uid', 'name' => 'username'),
            'home_specialuser' => array('id' => 'uid', 'name' => 'username'),
            'home_visitor' => array('id' => 'vuid', 'name' => 'vusername'),

            'portal_article_title' => array('id' => 'uid', 'name' => 'username'),
            'portal_comment' => array('id' => 'uid', 'name' => 'username'),
            'portal_topic' => array('id' => 'uid', 'name' => 'username'),
            'portal_topic_pic' => array('id' => 'uid', 'name' => 'username'),
        );

        if(!C::t('common_member')->update($get['uid'], array('username' => $get['newusername'])) && isset($_G['setting']['membersplit'])){
            C::t('common_member_archive')->update($get['uid'], array('username' => $get['newusername']));
        }

        return true; // 只主动更新论坛用户表，其余以uc通知的方式更新

        loadcache("posttableids");
        if($_G['cache']['posttableids']) {
            foreach($_G['cache']['posttableids'] AS $tableid) {
                $tables[getposttable($tableid)] = array('id' => 'authorid', 'name' => 'author');
            }
        }

        foreach($tables as $table => $conf) {
            DB::query("UPDATE ".DB::table($table)." SET `$conf[name]`='$get[newusername]' WHERE `$conf[id]`='$get[uid]'");
        }

        return true;
    }

    /**
     * 把uc里面的用户在论坛激活
     * @param $uid
     * @param $ucuser
     */
    private function _updateUserToDiscuz($uid, $ucuser) {
        global $_G;
        if($uid>0 && !empty($ucuser)) {
            $member = getuserbyuid($uid, 1);
            if(!$member || empty($member['uid'])) {
                $init_arr = explode( ',' , $_G['setting']['initcredits'] );
                $groupid = $_G['setting']['regverify'] == 2 ? 8 : $_G['setting']['newusergroupid'];
                C::t( 'common_member' )->insert( $uid, $ucuser[1], md5(random(10)), $ucuser[2], $_G['clientip'], $groupid, $init_arr );
            }
        }
    }


}