<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/10
 * Time: 上午10:27
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ThreadController extends Controller
{

    /**
     * 主题详细页
     */
    public function actionGetthread()
    {
        global $_G;

        $data = array(
            'thread' => array(),//主题内容
            'replies' => array(),//主题回复
            'hotpings' => array()//热门评论
        );

        //主题帖ID
        $tid = Yii::app()->request->getPost( 'tid' , 0 );
        //只看某个回复
        $replypid = WebHelper::getPost('replypid', 0);
        //是否只看楼主
        $isseemaster = Yii::app()->request->getPost( 'isseemaster', 0 );
        //回复排序
        $replyorder = Yii::app()->request->getPost( 'replyorder', 0 );
        //点赞排序
        $supportorder = Yii::app()->request->getPost( 'supportorder', 2 );
        //SQL OFFSET
        $offset = Yii::app()->request->getPost( 'offset', 0 );
        //SQL limit
        $limit = Yii::app()->request->getPost( 'limit' , 10 );

        //多少条评论显示热门
        $commentlimit = Yii::app()->request->getPost( 'commentlimit' , 10 );
        //多少赞上热门
        $supportnum = Yii::app()->request->getPost( 'supportnum' , 5 );
        //最多显示多少热门
        $supportlimit = Yii::app()->request->getPost( 'supportlimit' , 10 );

        //缓存期间的阅读量（前面设置的是10秒）
        $readnum = Yii::app()->request->getPost( 'readnum' , 1 );
	
	    //判断是否为新APP的接口
    	$is_new = Yii::app()->request->getPost( 'is_new' , 0 );

        /********************************************加载主题帖*********************************************************/
        $topic = C::t('forum_thread')->fetch_by_tid_displayorder( $tid, ForumThread::DISPLAY_ORDER_NORMAL );
        $topicCheck = C::t('forum_thread')->fetch_by_tid_displayorder( $tid, ForumThread::DISPLAY_ORDER_CHECK, '=');
        // 审核中,用户可以看见自己的审核中的帖子
        if( !empty($topicCheck) ) {
            if(isset($_G['uid']) && $_G['uid'] > 0 &&  $topicCheck['authorid'] == $_G['uid']){
                $topic = $topicCheck;
            }else{
                Tool::getInstance()->fail_json( Code::THREAD_CHECK, Tool::getInstance()->lang('thread is check') );
            }
        }

        //主题帖不存在
        if( empty($topic) )
        {
            Tool::getInstance()->fail_json( Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists') );
        }
		//保留移动贴
		//大坑 closed =1 可能代表是关闭主题，不是新移动帖地址
        if( $topic['closed'] && $topic['closed'] != 1 )
        {
            $tid = $topic['closed'];
            $topic['tid'] = $tid;
        }
        /*************************************************************************************************************/

        /******************************加载板块信息****************************/
        $_GET['tid'] = $tid;
        $_GET['fid'] = $topic['fid'];

        if( !function_exists('loadforum') )
        {
            require_once( libfile( 'function/forum' ) );
        }

        loadforum();

        //兼容手机端 DISCUZ 模板，主要是为了返回的图片的SRC是静态地址
        //手机版也使用网页端的模板
        $tempMobileTpl = $_G['mobiletpl'][IN_MOBILE];
        if( defined('IN_MOBILE') )
        {
            if( !defined('TPL_DEFAULT') )
            {
                define( 'TPL_DEFAULT', true );
            }
            $_G['mobiletpl'][IN_MOBILE] = '';
        }

        /********************************************************************/
        //检查板块访问权限
        require_once( Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php' );
        if( empty($_G['forum']['allowview']) )
        {
            if( !$_G['forum']['viewperm'] && !$_G['group']['readaccess'] )
            {
                Tool::getInstance()->fail_json( Code::GROUP_HAS_NOT_PERMISSION, Tool::getInstance()->lang('your group:{group} can not read this content', array('{group}' => $_G['group']['grouptitle'])) );
            }
            elseif($_G['forum']['viewperm'] && !forumperm($_G['forum']['viewperm']))
            {
                $res = qf_showmessagenoperm( 'viewperm', $_G['fid'], $_G['forum']['formulaperm'] );
                $res = qf_rebuild4formulaperm( $res );
                Tool::getInstance()->fail_json( Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags( lang('message' ,$res['message'], $res['params']) ) );
                //Tool::getInstance()->fail_json();
                die('to do');
            }

        }
        elseif($_G['forum']['allowview'] == -1)
        {
            //板块不允许被访问
            Tool::getInstance()->fail_json( Code::FORUM_NOPERMISSION, Tool::getInstance()->lang('forum can not read') );
        }

        /*
        if( $_G['forum']['formulaperm'] ) {
            die('to do');
        }
        */
        //需要密码才能访问板块
        if( $_G['forum']['password'] )
        {
            Tool::getInstance()->fail_json( Code::NEED_PASSWORD, Tool::getInstance()->lang('need password to visit') );
        }

        /*
        if($_G['forum']['price'] && !$_G['forum']['ismoderator']) {
            $membercredits = C::t('common_member_forum_buylog')->get_credits($_G['uid'], $_G['fid']);
            $paycredits = $_G['forum']['price'] - $membercredits;
            if($paycredits > 0) {
                // dheader("Location: $_G[siteurl]forum.php?mod=forumdisplay&fid=$_G[fid]");
            }
        }
        */

        //应该是帖子阅读权限的判断
        if( $_G['forum_thread']['readperm'] && $_G['forum_thread']['readperm'] > $_G['group']['readaccess'] && !$_G['forum']['ismoderator'] && $_G['forum_thread']['authorid'] != $_G['uid'] )
        {
            Tool::getInstance()->fail_json( Code::THREAD_READPERM, Tool::getInstance()->lang('read permission should over {readperm}', array('{readperm}' => $_G['forum_thread']['readperm'])) );
        }
        /*******************************主题帖、回帖******************************************/
        //topic post
        $topicInfo = array();
        $post = DB::fetch_first( "SELECT * FROM %t WHERE tid = %d AND first = 1",
                array(C::t('forum_post')->get_tablename('tid:' . $topic['tid']) , $topic['tid']) );

        if( !empty($post) )
        {
            $topicAuthor = C::t('common_member')->fetch_by_username( $post['author'] );

            //设置作者的STATUS（禁言等）
            $post['memberstatus'] = $topic['memberstatus'] = $topicAuthor['memberstatus'];

            $msg1 = Tool::getInstance()->lang( 'shield by manager to user' );
            $msg2 = Tool::getInstance()->lang( 'shield by manager' );
            $msg3 = Tool::getInstance()->lang( 'author shield by manager to user' );
            $msg4 = Tool::getInstance()->lang( 'author shield by manager' );
            //处理主题帖内容：CONTENT
            $content = ForumThread::parsePostMessage( $post ,1);
            //分类信息显示
            $sortContent = '';
			$sortImg = array();
            //帖子被屏蔽的话 分类信息不显示
            if(!in_array($content,array($msg1,$msg2,$msg3,$msg4))){
                if($topic['sortid'] && $_G['forum']['threadsorts']['types'][$topic['sortid']]) {
                    $sort = $_G['forum']['threadsorts']['types'][$_G['forum_thread']['sortid']];
                    $threadsortshow = ForumThread::getSortInfo($topic['sortid'], $_G['tid'], $sort, $topic['dateline']);
                    list($sortContent, $sortImg) = $threadsortshow;
                }
            }

            // 处理图片重复问题
            if( !empty($sortImg) ) {
                foreach( $sortImg as $k => $v ) {
                    $v = str_replace('/', '\/', $v);
                    if( preg_match('/<img([^<]*)src=\"'.$v.'\".*?>/i', $content, $matches) ) {
                        $content = str_replace($matches[0], '', $content);
                    }
                }
            }
            $content = $sortContent.$content;

            // 修正帖子查看数
            if (isset($_G['forum_thread']['views']) && $_G['forum_thread']['tid'] == $topic['tid'] && $_G['forum_thread']['views'] > $topic['views'])
            {
                $topic['views'] = $_G['forum_thread']['views'];
            }
            //活动贴的重新组织
            if( $topic['special'] == 4){

                $re = ForumThread::getActivityThread( $topic);
                $content = $re['act'].$content.$re['app'];
            }
            //商品的重新组织
            if( $topic['special'] == 2){
                $re = ForumThread::getTradeThread($topic);
                $extra_pid = $re['pid'];
                $content = $content.$re['con'];
            }

            //组织云端内容字段
            $topicInfo['tid'] = $topic['tid'];
            $topicInfo['subject'] = $topic['subject'];
            $topicInfo['fid'] = $topic['fid'];
            $topicInfo['fname'] = $_G['forum']['name'];
            $topicInfo['icon'] = discuz_uc_avatar( $topic['authorid'], 'big', true );
            $topicInfo['author'] = $topic['author'];
            $topicInfo['authorid'] = $topic['authorid'];
            $topicInfo['ifcheck'] = $topic['displayorder'] < 0 ? 0 : 1;
            $topicInfo['postdate'] = $topic['dateline'];
            $topicInfo['lastpost'] = $topic['lastpost'];
            $topicInfo['lastposter'] = $topic['lastposter'];
            $topicInfo['hits'] = $topic['views'];
            $topicInfo['replies'] = $topic['replies'];
            $topicInfo['favors'] = $topic['favtimes'];
            $topicInfo['topped'] = $topic['displayorder'] > 0 ? 1 : 0;
            $topicInfo['digest'] = $topic['digest'];
            $topicInfo['special'] = $topic['special'];
            $topicInfo['ifupload'] = $topic['attachment'] > 0 ? 1 : 0;
            //获取作者的性别
            $topicInfo['gender'] = DB::result_first( "SELECT gender FROM " . DB::table("common_member_profile") . " WHERE uid=%d", array( $topic['authorid'] ) );
            $topicInfo['content'] = $content;
            $topicInfo['isFavored'] = DB::result_first('SELECT id FROM ' . DB::table('home_favorite') .' WHERE id = %d AND uid = %d', array($topic['tid'], $_G['uid'] )) ? 1 : 0;
            $topicInfo['isFollow'] = 0;

            //获取特殊用户组
            if(!empty(Yii::app()->params['qianfan_groupid']) && isset($topicAuthor['groupid']) && Yii::app()->params['qianfan_groupid'] == $topicAuthor['groupid']) {
                $topicInfo['specialgid'] = true;
            }

            //是否被赞
            if( $_G['uid'] )
            {
                $isping = C::t('forum_memberrecommend')->fetch_by_recommenduid_tid($_G['uid'], $topic['tid']);
            }
            else
            {
                $isping = 0;
            }
            $topicInfo['isping'] = $isping;
            $topicInfo['pingCount'] = $topic['recommend_add'];

            //点评的用户
            $allPing = DB::fetch_all('SELECT recommenduid FROM '. DB::table('forum_memberrecommend') .' WHERE tid = %d limit 30', array($topic['tid']));
            $pinger = array();
            if( !empty($allPing) )
            {
                $pingUids = array();
                foreach( $allPing as $key => $ping )
                {
                    $pingUids[] = $ping['recommenduid'];
                }
                if( !empty($pingUids) )
                {
                    $pingerUsername = C::t('common_member')->fetch_all_username_by_uid($pingUids);
                    if( !empty($pingerUsername) )
                    {
                        foreach( $pingerUsername as $key => $val )
                        {
                            $pinger[] = array(
                                'uid' => $key,
                                'username' => $val,
                                'icon' => discuz_uc_avatar( $key, 'big', true )
                            );
                        }
                    }
                }
            }

            $topicInfo['pinger'] = $pinger;
            if( !empty($post['attachments']) )
            {
                $allAttachs = array();
                foreach( $post['attachments'] as $key => $val )
                {
                    $allAttachs[]['url'] = $val['url'] . $val['attachment'];
                }
            }
            $topicInfo['allAttachs'] = $allAttachs;
            $topicInfo['unUsedAttachs'] = array();


            $_G['tid'] = $topicInfo['tid'];
            //特殊帖子处理 投票
            if( $topicInfo['special'] == 1 )
            {
                $topicInfo['poll'] = ForumThread::getVoteInfo($_G['tid']);
            }

        }
        /************************************************************************************/

        /************************************获取回帖*****************************************/
        // 贴内置顶
        $sticklist = array();
        if( !$replypid )
        {
            if( $offset == 0 && $_G['forum_thread']['stickreply'] && !$isseemaster )
            {
                $poststick = C::t('forum_poststick')->fetch_all_by_tid($_G['tid']);
                foreach(C::t('forum_post')->fetch_all($_G['forum_thread']['posttableid'], array_keys($poststick)) as $post)
                {
                    $post['position'] = $poststick[$post['pid']]['position'];
                    $post['avatar'] = avatar($post['authorid'], 'small');
                    $post['isstick'] = true;
                    $sticklist[$post['pid']] = $post;
                }
            }
        }

        // 推荐帖子
        if($is_new == 0){
        $hiddenreplies = getstatus($_G['forum_thread']['status'], 2);
        $rushreply = getstatus($_G['forum_thread']['status'], 3);
        $hotpids = array();
        $hotpostarr = array();

        $remainhots = ($offset == 0 && !$rushreply && !$hiddenreplies && !$_G['forum_thread']['special'] && !$_G['forum']['noforumrecommend'] && empty($isseemaster)) ? $_G['setting']['threadhotreplies'] : 0;
        if($remainhots) {
            $hotpids = array_keys(C::t('forum_hotreply_number')->fetch_all_by_tid_total($_G['tid'], 10));
            $remainhots = $remainhots - count($hotpids);
        }
        if($_G['setting']['nofilteredpost'] && $_G['forum_thread']['replies'] > $_G['setting']['postperpage'] && $remainhots) {
            $hotpids = array_merge($hotpids, array_keys(C::t('forum_filter_post')->fetch_all_by_tid_postlength_limit($_G['tid'], $remainhots)));
        }
        if($hotpids) {
            $hotposts = C::t('forum_post')->fetch_all_by_pid($_G['forum_thread']['posttableid'], $hotpids);
            foreach($hotpids as $hotpid) {
                if($hotposts[$hotpid]) {
                    $hotpostarr[$hotpid] = $hotposts[$hotpid];
                    $hotpostarr[$hotpid]['hotrecommended'] = true;
                }
            }
            unset($hotposts);
        }

        }else{


        $hotpostarr = array();
           
        $postSql = " SELECT a.*,b.support FROM %t a LEFT JOIN %t b ON a.pid = b.pid WHERE a.tid = $tid AND a.first != 1 AND a.invisible >= 0 AND b.support >=$supportnum ORDER BY b.support DESC LIMIT $supportlimit";

        $hotpostarrs = DB::fetch_all( $postSql,array('forum_post','forum_hotreply_number') );
        foreach($hotpostarrs as $key=>$post)
        {
            $hotpostarr[$post['pid']] = $post;
        }
        unset($hotpostarrs);

	}


        //是否仅作者可见
        $isOnlyAuthorTopic = getstatus($_G['forum_thread']['status'], 2) == 1 ? 1 : 0;

        //组织获取回帖SQL
        //invisible 审核状态
        $isseemaster = intval($isseemaster);//只看楼主
        $authorid = intval($topicInfo['authorid']);




        if( !$replypid )
        {
            if($is_new==0 || $supportorder==2) //状态值为2的时候  表示关闭最赞排序,以楼层排序为主
            {
                if($replyorder)
                {
                    $order = "dateline DESC";
                }else{
                    $order = "dateline ASC";
                }
                $postSql = "SELECT * FROM %t WHERE tid = %d AND `first` != %d AND invisible >= %d" .($isseemaster ? ' AND authorid ='.$authorid : ''). " ORDER BY " . $order . "
                LIMIT
                %d, %d";
            }else{
                if($supportorder)
                {
                    $order = "b.support DESC";
                }else{
                    $order = "b.support ASC";
                }
                $postSql = "SELECT a.* FROM %t a LEFT JOIN " . DB::table("forum_hotreply_number ") . " b ON a.pid = b.pid WHERE a.tid = %d AND `first` != %d AND invisible >= %d" .($isseemaster ? ' AND a.authorid ='.$authorid : ''). " ORDER BY " . $order . "
                LIMIT
                %d, %d";

            }

            $postList = DB::fetch_all( $postSql, array(
                C::t('forum_post')->get_tablename('tid:'.$tid),
                $tid, 1, 0,
                dintval($offset), dintval($limit) ) );
        }
        else
        {
            $postList = DB::fetch_all( "SELECT * FROM %t WHERE tid = %d AND `first` != %d AND invisible >= %d AND pid
             = %d LIMIT 1", array(
                C::t('forum_post')->get_tablename('tid:'.$tid),
                $tid, 1, 0, $replypid
            ) );
        }

        if( $postList )
        {
            $tempPids = $tempUids = array();
            $tempPostRecommends = array();
            foreach ($postList as $post) {
                $tempPids[] = dintval( $post['pid'] );
                $tempUids[] = dintval($post['authorid']);
            }

            // 回帖点赞数量
            $hotreplyNumber = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($tempPids));
            if( !empty($hotreplyNumber) )
            {
                foreach( $hotreplyNumber as $pid => $post )
                {
                    $tempPostRecommends[$pid] = dintval($post['support']);
                }
            }

            // 当前用户是否点赞回复
            $isSupportAry = DB::fetch_all("SELECT pid FROM %t WHERE uid=%d AND pid IN (%n)", array('forum_hotreply_member', $_G['uid'], $tempPids));
            $isSupport = array();
            if( !empty( $isSupportAry ) )
            {
                foreach( $isSupportAry as $key => $val )
                {
                    $isSupport[] = $val['pid'];
                }
            }

            // 回复者的性别
            $genders = array();
            $tempUids = array_unique($tempUids);
            $genderArr = DB::fetch_all( "SELECT uid,gender FROM %t WHERE uid IN (%n)", array('common_member_profile', $tempUids) );
            if( !empty($genderArr) ) {
                foreach($genderArr as $k => $v) {
                    $genders[$v['uid']] = $v['gender'];
                }
            }

        }

        // 帖子内置顶组合回复列表，首页支持去重
        if( $is_new==0 ) //使用老版的置顶加推荐的方式
        {
                if( !empty($sticklist) || !empty($hotpostarr) )
                {
                    foreach( $postList as $key => $val )
                    {
                        if( isset($sticklist[$val['pid']]) )
                        {
                            unset( $postList[$key] );
                        }
                        if( isset($hotpostarr[$val['pid']]) )
                        {
                            unset( $postList[$key] );
                        }
                    }
                    $postList = (array)$sticklist + (array)$hotpostarr + $postList;
                }
        }else{
            $posthot = array();
            //获取全部评论数量
            $all_postlist_num = $topicInfo['replies'];
            if($all_postlist_num >= $commentlimit )
            {
                $posthot = (array)$sticklist + (array)$hotpostarr;
            }else if($all_postlist_num < $commentlimit && isset($sticklist)){
                $posthot = $sticklist;//只要有置顶的优先显示
            }
        }

        //遍历所有回复
        $replies = array();
        if( !empty( $postList) )
        {
            foreach( $postList as $key => $val ) {
                $postdateline = $val['dateline'];

                $content = ForumThread::parsePostMessage($val);
                //是否仅作者可见
                $isOnlyAuthorSeeReply = 0;
                if ($isOnlyAuthorTopic && $_G['uid'] != $val['authorid'] && $_G['uid'] != $_G['forum_thread']['authorid'] && !$val['first'] && !$_G['forum']['ismoderator']) {
                    $isOnlyAuthorSeeReply = 1;
                }

                $content = $isOnlyAuthorSeeReply ? Tool::getInstance()->lang( 'hiddenreplies' ) : $content;
                $attachs = C::t('forum_attachment_n')->fetch_all_by_id( 'pid:' . $val['pid'], 'pid', $val['pid'], '', 1 );

                $allAttachs = array();
                if( !empty($attachs) )
                {
                    foreach( $attachs as $k => $attach )
                    {
                        $attachs[$k]['url'] = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']).'forum/';
                        $attachs[$k]['attachment'] = $attachs[$k]['url'] . $attachs[$k]['attachment'];

                        $allAttachs[]['url'] = $attachs[$k]['attachment'];
                    }
                }

                //每个评论投票数和是否点赞
                $support_num = isset($tempPostRecommends[$val['pid']]) ? $tempPostRecommends[$val['pid']] : 0;

                //判断当前登录用户是否对该帖点赞没有
                $is_support = in_array($val['pid'], $isSupport) ? 1 : 0;

              

                $reply = array(
                    'pid' => $val['pid'],
                    'tid' => $val['tid'],
                    'author' => $val['author'],
                    'authorid' => $val['authorid'],
                    'icon' => discuz_uc_avatar($val['authorid'], 'big', 1),
                    'gender' => isset($genders[$val['authorid']]) ? $genders[$val['authorid']] : 0,
                    'postdate' => $postdateline,
                    'subject' => '',
                    'content' => $content,
                    'allAttachs' => $allAttachs,
                    'unUsedAttachs' => array(),


                    'support_num' => $support_num,
                    'is_support' => $is_support,
                    'position' => $val['position']
                );
				//针对商品中多余的楼层转移
                if( $topic['special'] == 2 && !empty($extra_pid) && in_array($val['pid'],$extra_pid) ){
                    $topicInfo['content'] = str_replace('[re]'.$val['pid'].'[/re]',$content,$topicInfo['content']);
                    continue;
                }
                $replies[] = $reply;
            }
        }


        //遍历所有的热门评论
	    if($is_new == 1){
            $hotpings = array();
            if( !empty( $posthot) )
            {

                $hotPids = $hotUids = array();
                $hotPostRecommends = array();
                foreach ($posthot as $post) {
                    $hotPids[] = dintval( $post['pid'] );
                    $hotUids[] = dintval($post['authorid']);
                }

                // 回帖点赞数量
                $hotreplyNumber = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($hotPids));
                if( !empty($hotreplyNumber) )
                {
                    foreach( $hotreplyNumber as $pid => $post )
                    {
                        $hotPostRecommends[$pid] = dintval($post['support']);
                    }
                }

                // 当前用户是否点赞回复
                $isSupportAry = DB::fetch_all("SELECT pid FROM %t WHERE uid=%d AND pid IN (%n)", array('forum_hotreply_member', $_G['uid'], $hotPids));
                $ishotSupport = array();
                if( !empty( $isSupportAry ) )
                {
                    foreach( $isSupportAry as $key => $val )
                    {
                        $ishotSupport[] = $val['pid'];
                    }
                }


                // 回复者的性别
                $genders = array();
                $hotUids = array_unique($hotUids);
                $hotgenderArr = DB::fetch_all( "SELECT uid,gender FROM %t WHERE uid IN (%n)", array('common_member_profile', $hotUids) );
                if( !empty($hotgenderArr) ) {
                    foreach($hotgenderArr as $k => $v) {
                        $hotgenders[$v['uid']] = $v['gender'];
                    }
                }


                foreach( $posthot as $key => $val ) {
                    $postdateline = $val['dateline'];

                    $content = ForumThread::parsePostMessage($val);
		      $msg1 = Tool::getInstance()->lang( 'shield by manager to user' );
                    $msg2 = Tool::getInstance()->lang( 'shield by manager' );
                    $msg3 = Tool::getInstance()->lang( 'author shield by manager to user' );
                    $msg4 = Tool::getInstance()->lang( 'author shield by manager' );
                    if(in_array($content,array($msg1,$msg2,$msg3,$msg4))){
                        unset($val);
                        continue;
                    }
		    
                    //是否仅作者可见
                    $isOnlyAuthorSeeReply = 0;
                    if ($isOnlyAuthorTopic && $_G['uid'] != $val['authorid'] && $_G['uid'] != $_G['forum_thread']['authorid'] && !$val['first'] && !$_G['forum']['ismoderator']) {
                        $isOnlyAuthorSeeReply = 1;
                    }

                    $content = $isOnlyAuthorSeeReply ? Tool::getInstance()->lang( 'hiddenreplies' ) : $content;
                    $attachs = C::t('forum_attachment_n')->fetch_all_by_id( 'pid:' . $val['pid'], 'pid', $val['pid'], '', 1 );

                    $allAttachs = array();
                    if( !empty($attachs) )
                    {
                        foreach( $attachs as $k => $attach )
                        {
                            $attachs[$k]['url'] = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']).'forum/';
                            $attachs[$k]['attachment'] = $attachs[$k]['url'] . $attachs[$k]['attachment'];

                            $allAttachs[]['url'] = $attachs[$k]['attachment'];
                        }
                    }

                    //每个评论投票数和是否点赞
                    //取消判断是否开启点赞功能
                    $support_num = isset($hotPostRecommends[$val['pid']]) ? $hotPostRecommends[$val['pid']] : 0;

                    //判断当前登录用户是否对该帖点赞没有
                    $is_support = in_array($val['pid'], $ishotSupport) ? 1 : 0;

                    //$is_stick = isset($val['isstick']) ? 1 : 0 ;//是否置顶
                    //$is_recommend = isset($val['hotrecommended']) ? 1 : 0 ;//是否推荐

                    $hotping = array(
                        'pid' => $val['pid'],
                        'tid' => $val['tid'],
                        'author' => $val['author'],
                        'authorid' => $val['authorid'],
                        'icon' => discuz_uc_avatar($val['authorid'], 'big', 1),
                        'gender' => isset($genders[$val['authorid']]) ? $hotgenders[$val['authorid']] : 0,
                        'postdate' => $postdateline,
                        'subject' => '',
                        'content' => $content,
                        'allAttachs' => $allAttachs,
                        'unUsedAttachs' => array(),

                        'support_num' => $support_num,
                        'is_support' => $is_support,
                        'position' => $val['position']
                    );
                    //针对商品中多余的楼层转移
                    if( $topic['special'] == 2 && !empty($extra_pid) && in_array($val['pid'],$extra_pid) ){
                        $topicInfo['content'] = str_replace('[re]'.$val['pid'].'[/re]',$content,$topicInfo['content']);
                        continue;
                    }
                    $hotpings[] = $hotping;
                }
            }
            $data['hotpings'] = $hotpings;
	    }
	
	
        $data['thread'] = $topicInfo;
        $data['replies'] = $replies;

        // 更新帖子阅读量
        ForumThread::updateThreadViews($topicInfo['threadtableid'],$readnum);

        echo Tool::getInstance()->success_json( $data );
        /************************************************************************************/
    }

    public function actionGetthreadsinfo()
    {
        global $_G;

        $tids = WebHelper::getPost('tids', '');
        // 验证参数的合法性
        if( !preg_match('/[0-9,]+/', $tids) )
        {
            Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
        }
        $data = array();
        if( $tids )
        {
            $tidAry = explode( ',', $tids );

            // 一次至多获取100条帖子基本信息，否则视为攻击
            if( count($tidAry) >= 100 )
            {
                Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
            }

            if( !empty($tidAry) )
            {
                $threads = C::t("forum_thread")->fetch_all_by_tid($tidAry);

                //特殊贴标记字段 specialgid
                $specialgid = Yii::app()->params['qianfan_groupid'];
                $groupid = array();
                if($specialgid) {
                    foreach($threads as $k => $v) {
                        $authoridArr[$k] = $v['authorid'];
                    }
                    if(!empty($authoridArr)) {
                        $groupidArr = DB::fetch_all('SELECT * FROM %t WHERE uid IN (%n)', array('common_member', $authoridArr));
                        if(!empty($groupidArr)) {
                            foreach($groupidArr as $kk => $vv) {
                                $groupid[$vv['uid']] = $vv['groupid'];
                            }
                        }
                    }
                }

                if( !empty($threads) )
                {
                    if( $_G['setting']['optimizeviews'] )
                    {
                        $threadsoptimize = DB::fetch_all("SELECT * FROM %t WHERE tid in (%n)", array
                        ("forum_threadaddviews", $tidAry));
                    }

                    foreach( $threads as $key => $thread )
                    {
                        $d = array();
                        $d['views_num'] = $thread['views'];
                        $d['replies_num'] = $thread['replies'];
                        $d['likes_num'] = $thread['favtimes'];
                        $d['specialgid'] = $groupid[$thread['authorid']] == $specialgid ? true : false;

                        //2.0需要使用字段,所以添加以下的
                        $d['tid'] = $thread['tid'];
                        $d['subject'] = $thread['subject'];
                        $d['author'] = $thread['author'];

                        if( !empty($threadsoptimize) )
                        {
                            foreach( $threadsoptimize as $k => $v )
                            {
                                if( $v['tid'] == $thread['tid'] && $v['addviews'] )
                                {
                                    $d['views_num'] += $v['addviews'];
                                }
                            }
                        }

                        $data[$thread['tid']] = $d;
                    }
                }
            }
        }

        Tool::getInstance()->success_json( $data );
    }

}
