<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2015/11/26
 * Time: 15:27
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class UserController extends Controller
{
    /**
     * 用户收藏帖子
     */
    public function actionCollectthread()
    {
        global $_G;
        $idType = 'tid';

        //帖子ID
        $tid = dintval(WebHelper::getPost('tid', 0));

        /************************************验证登录，帖子信息*****************************************/
        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }
        $uid = $_G['uid'];

        //判断帖子是否存在
        $thread = C::t('forum_thread')->fetch($tid);
        $title = $thread['subject'];
        if(empty($title)) {
            Tool::getInstance()->fail_json( Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists') );
        }

        //判断是否已经收藏该帖子
        $fav = C::t('home_favorite')->fetch_by_id_idtype($tid, $idType, $_G['uid']);
        if($fav) {
            Tool::getInstance()->fail_json( Code::ALREADY_COLLECTED, Tool::getInstance()->lang('thread is collected') );
        }
        /************************************************************************************/

        /************************************收藏成功，更新收藏信息*****************************************/
        $fav_count = C::t('home_favorite')->count_by_id_idtype($tid, $idType);
        $description = '';
        require_once libfile('function/home');
        $arr = array(
            'uid' => intval($uid),
            'idtype' => $idType,
            'id' => $tid,
            'spaceuid' => $thread['authorid'],
            'title' => getstr($title, 255),
            'description' => getstr($description, '', 0, 0, 1),
            'dateline' => TIMESTAMP
        );
        $favid = C::t('home_favorite')->insert($arr, true);
        if($favid) {
            if ($_G['setting']['cloud_status']) {
                $favoriteService = Cloud::loadClass('Service_Client_Favorite');
                $favoriteService->add($arr['uid'], $favid, $arr['id'], $arr['idtype'], $arr['title'], $arr['description'], TIMESTAMP);
            }
            C::t('forum_thread')->increase($tid, array('favtimes' => 1));
            require_once libfile('function/forum');
            update_threadpartake($tid);
            $data = array();
            Tool::getInstance()->success_json( $data );
        }else{
            Tool::getInstance()->fail_json( Code::COLLECT_FAIL, Tool::getInstance()->lang('fail to collect') );
        }
        /************************************************************************************/
    }

    /**
     * 收藏版块
     */
    public function actionCollectforum()
    {
        global $_G;
        $idType = 'fid';
        $spaceuid = empty($_GET['spaceuid']) ? 0 : intval($_GET['spaceuid']);

        //版块ID
        $fid = dintval(WebHelper::getPost('fid', 0));

        /************************************验证登录，版块信息*****************************************/
        //判断用户登录
        if(empty($_G['uid'])) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }
        $uid = $_G['uid'];

        //判断版块是否可收藏
        $foruminfo = C::t('forum_forum')->fetch($fid);
        loadcache('forums');
        $forum = $_G['cache']['forums'][$fid];
        if(!empty($foruminfo['fup']) && !$forum['viewperm'] || ($forum['viewperm'] && forumperm($forum['viewperm'])) || strstr($forum['users'], "\t$_G[uid]\t")) {
            $title = $foruminfo['status'] != 3 ? $foruminfo['name'] : '';
            // $icon = '<img src="static/image/feed/discuz.gif" alt="forum" class="vm" /> ';
        }
        if(empty($title)) {
            Tool::getInstance()->fail_json( Code::FORUM_CANNOT_COLLECT, Tool::getInstance()->lang('forum cannot be collected') );
        }

        //判断是否已经收藏该版块
        $fav = C::t('home_favorite')->fetch_by_id_idtype($fid, $idType, $uid);
        if($fav) {
            Tool::getInstance()->fail_json( Code::ALREADY_COLLECTED, Tool::getInstance()->lang('forum is collected') );
        }
        /************************************************************************************/

        /************************************收藏成功，更新收藏信息**************************************/
        $fav_count = C::t('home_favorite')->count_by_id_idtype($fid, $idType);
        $description = '';
        require_once libfile('function/home');
        $arr = array(
            'uid' => intval($uid),
            'idtype' => $idType,
            'id' => $fid,
            'spaceuid' => $spaceuid,
            'title' => getstr($title, 255),
            'description' => getstr($description, '', 0, 0, 1),
            'dateline' => TIMESTAMP
        );
        $favid = C::t('home_favorite')->insert($arr, true);
        if($favid) {
            if ($_G['setting']['cloud_status']) {
                $favoriteService = Cloud::loadClass('Service_Client_Favorite');
                $favoriteService->add($arr['uid'], $favid, $arr['id'], $arr['idtype'], $arr['title'], $arr['description'], TIMESTAMP);
            }
            C::t('forum_forum')->update_forum_counter($fid, 0, 0, 0, 0, 1);
            //$extrajs = '<script type="text/javascript">$("number_favorite_num").innerHTML = parseInt($("number_favorite_num").innerHTML)+1;$("number_favorite").style.display="";</script>';
            dsetcookie('nofavfid', '', -1);

            //列出用户所有关注的版块
            $data = array();
            $forums = C::t('home_favorite')->fetch_all_by_uid_idtype($_G['uid'], $idType);
            foreach($forums as $row) {
                $data[] = $row['id'];
            }
            $data = array('shortcut' => implode(',',$data));
            Tool::getInstance()->success_json( $data );
        }else{
            Tool::getInstance()->fail_json( Code::COLLECT_FAIL, Tool::getInstance()->lang('fail to collect') );
        }
        /************************************************************************************/
    }

    /**
     * 取消收藏版块
     */
    public function actionUncollectforum()
    {
        global $_G;
        $idType = 'fid';

        $fid = dintval(WebHelper::getPost('fid', 0));

        //判断用户登录
        if(empty($_G['uid'])) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }
        $uid = $_G['uid'];

        //判断版块是否可收藏
        $foruminfo = C::t('forum_forum')->fetch($fid);
        loadcache('forums');
        $forum = $_G['cache']['forums'][$fid];
        if(!empty($foruminfo['fup']) && !$forum['viewperm'] || ($forum['viewperm'] && forumperm($forum['viewperm'])) || strstr($forum['users'], "\t$_G[uid]\t")) {
            $title = $foruminfo['status'] != 3 ? $foruminfo['name'] : '';
            // $icon = '<img src="static/image/feed/discuz.gif" alt="forum" class="vm" /> ';
        }
        if(empty($title)) {
            Tool::getInstance()->fail_json( Code::FORUM_CANNOT_COLLECT, Tool::getInstance()->lang('forum cannot be collected') );
        }

        //判断是否已经收藏
        $fav = C::t('home_favorite')->fetch_by_id_idtype($fid, $idType, $uid);
        if(!$fav) {
            Tool::getInstance()->fail_json( Code::NOT_COLLECTED, Tool::getInstance()->lang('not collected') );
        }

        //取消收藏,更新信息
        $favid = $fav['favid'];

        C::t('home_favorite')->delete($favid);
        C::t('forum_forum')->update_forum_counter($fid, 0, 0, 0, 0, -1);

        if($_G['setting']['cloud_status']) {
            $favoriteService = Cloud::loadClass('Service_Client_Favorite');
            $favoriteService->remove($_G['uid'], $favid);
        }
        //列出用户所有关注的版块
        $data = array();
        $forums = C::t('home_favorite')->fetch_all_by_uid_idtype($_G['uid'], $idType);
        foreach($forums as $row) {
            $data[] = $row['id'];
        }
        $data = array('shortcut' => implode(',',$data));
        Tool::getInstance()->success_json( $data );
    }

    /**
     * 取消收藏帖子
     */
    public function actionUncollectthread()
    {
        global $_G;
        $idType = 'tid';

        //帖子ID
        $tid = dintval(WebHelper::getPost('tid', 0));

        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }
        $uid = $_G['uid'];

        //判断帖子是否存在
        $thread = C::t('forum_thread')->fetch($tid);
        $title = $thread['subject'];
        if(empty($title)) {
            Tool::getInstance()->fail_json( Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists') );
        }

        //判断是否已经收藏该帖子
        $fav = C::t('home_favorite')->fetch_by_id_idtype($tid, $idType, $_G['uid']);
        if(!$fav) {
            Tool::getInstance()->fail_json( Code::NOT_COLLECTED, Tool::getInstance()->lang('not collected') );
        }

        //取消收藏,更新信息
        $favid = $fav['favid'];
        C::t('home_favorite')->delete($favid);
        if($_G['setting']['cloud_status']) {
            $favoriteService = Cloud::loadClass('Service_Client_Favorite');
            $favoriteService->remove($_G['uid'], $favid);
        }
        $data = array();
        Tool::getInstance()->success_json( $data );
    }

    /**
     * 帖子点赞
     */
    public function actionPingthread()
    {
        global $_G;
        $action = 'ping';
        //帖子ID
        $_G['tid'] = dintval(WebHelper::getPost('tid', 0));

        /************************************验证登录，帖子，后台设置信息*****************************************/
        //判断用户登录
        if(empty($_G['uid'])) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }

        //判断帖子是否存在
        $thread = C::t('forum_thread')->fetch($_G['tid']);
        if(empty($thread['tid'])) {
            Tool::getInstance()->fail_json( Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists') );
        }

        //判断主题评价功能是否开启
        if(!$_G['setting']['recommendthread']['status'] || !$_G['group']['allowrecommend']) {
            Tool::getInstance()->fail_json( Code::NO_PRIVILEGE_RECOMMEND, Tool::getInstance()->lang('no_privilege_recommend') );
        }

        //判断是否评价自己的主题
        if($thread['authorid'] == $_G['uid'] && !$_G['setting']['recommendthread']['ownthread']) {
            Tool::getInstance()->fail_json( Code::RECOMMEND_SELF_DISALLOW, Tool::getInstance()->lang('recommend_self_disallow') );
        }

        //判断是否赞过该主题
        if(C::t('forum_memberrecommend')->fetch_by_recommenduid_tid($_G['uid'], $_G['tid'])) {
            Tool::getInstance()->fail_json( Code::RECOMMEND_DUPLICATE, Tool::getInstance()->lang('recommend_duplicate') );
        }

        //判断24小时点赞次数
        $recommendcount = C::t('forum_memberrecommend')->count_by_recommenduid_dateline($_G['uid'], $_G['timestamp']-86400);
        if($_G['setting']['recommendthread']['daycount'] && $recommendcount >= $_G['setting']['recommendthread']['daycount']) {
            Tool::getInstance()->fail_json( Code::RECOMMEND_OUTOFTIMES, Tool::getInstance()->lang('recommend_outoftimes') );
        }
        /************************************************************************************/

        /************************************点赞成功，更新信息**************************************/
        $_G['group']['allowrecommend'] = intval($action == 'ping' ? $_G['group']['allowrecommend'] : -$_G['group']['allowrecommend']);
        $fieldarr = array();
        if($action == 'ping') {
            $heatadd = 'recommend_add=recommend_add+1';
            $fieldarr['recommend_add'] = 1;
        } else {
            $heatadd = 'recommend_sub=recommend_sub+1';
            $fieldarr['recommend_sub'] = 1;
        }
        require_once libfile('function/forum');
        update_threadpartake($_G['tid']);
        $fieldarr['heats'] = 0;
        $fieldarr['recommends'] = $_G['group']['allowrecommend'];
        C::t('forum_thread')->increase($_G['tid'], $fieldarr);
        //C::t('forum_thread')->update($_G['tid'], array('lastpost' => TIMESTAMP));//禁止点赞更新lastpost
        C::t('forum_memberrecommend')->insert(array('tid'=>$_G['tid'], 'recommenduid'=>$_G['uid'], 'dateline'=>$_G['timestamp']));

        dsetcookie('recommend', 1, 43200);
        $data = array();
        Tool::getInstance()->success_json( $data );
        /************************************************************************************/
    }


    /**
     * 帖子评论点赞
     */
    public function actionPingcomment()
    {
        //-------forum.php?mod=misc&action=postreview&do=support&tid=2&pid=5&hash=a56f11c9&ajaxmenu=1&inajax=1&ajaxtarget=_menu_content
        global $_G;

        //判断是否开启点赞
        //绕过论坛的设置,直接默认开启,所以注释掉了
//        if(!$_G['setting']['repliesrank']){
//            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('site did not open this function') );
//        }

        //判断是否登录
        if(empty($_G['uid'])) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }

        //主题（帖子）ID
        $tid = dintval(WebHelper::getPost('tid', 0));
        //帖子（评论）ID
        $pid = dintval(WebHelper::getPost('pid', 0));
        //方法
        $do = WebHelper::getPost('do');
        $do = !empty($do) ? $do : 'support';

        $doArray = array('support', 'against');
        $post = C::t('forum_post')->fetch('tid:'.$tid, $pid, false);

        //多少赞上热门
        $supportnum = dintval(WebHelper::getPost('supportnum', 10));
        //最多显示多少热门
        $supportlimit = dintval(WebHelper::getPost('supportlimit', 20));
        //评论楼层
        $position = dintval(WebHelper::getPost('position', 1));
        //兼容类型
        $type = dintval(WebHelper::getPost('type', 0));
        if($type == 1){
            $stick_num = C::t('forum_poststick')->count_by_tid($tid);  //获取置顶个数
            if($stick_num < $supportlimit){
                $is_stick = C::t('forum_poststick')->count_by_pid($pid);  //获取是否已经置顶
                if($is_stick == 0){
                    $zan_arr_pid = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($pid)); //获取当前评论点赞个数
                    if(count($zan_arr_pid)+1 == $supportnum){
                        //主题修改字段
                        if($stick_num == 0) {
                            C::t('forum_thread')->update($tid, array('moderated'=>1, 'stickreply'=>1));
                        }
                        //条件都复合进行置顶操作
                        C::t('forum_poststick')->insert(array(
                            'tid' => $tid,
                            'pid' => $pid,
                            'position' => $position,
                            'dateline' => time(),
                        ), false, true);

                    }
                }
            }
        }

        if(empty($post)) {//评论不存在
            Tool::getInstance()->fail_json( Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_not_exist') );
        }

        //($_G['setting']['threadfilternum'] && $_G['setting']['filterednovote'] && getstatus($post['status'], 11))  此处是水帖不能参与回帖投票的设置


        if(!in_array($do, $doArray) || $post['first'] == 1) {
            Tool::getInstance()->fail_json( Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request') );
        }

        //判断是否可以自己给自己点赞
        /*
        if($_G['setting']['commentpostself']==0 && $_G['uid'] == $post['authorid']) {
            Tool::getInstance()->fail_json( Code::RECOMMEND_SELF_DISALLOW, Tool::getInstance()->lang('noreply_yourself_error') );
        }
        */

        $hotreply = C::t('forum_hotreply_number')->fetch_by_pid($post['pid']);
        if(empty($hotreply)) {
            $hotreply['pid'] = C::t('forum_hotreply_number')->insert(array(
                'pid' => $post['pid'],
                'tid' => $post['tid'],
                'support' => 0,
                'against' => 0,
                'total' => 0,
            ), true);
        } else {
            if(C::t('forum_hotreply_member')->fetch($post['pid'], $_G['uid'])) {
                Tool::getInstance()->fail_json( Code::THREAD_POLL_VOTED, Tool::getInstance()->lang('noreply_voted_error') );
            }
        }

        $typeid = $do == 'support' ? 1 : 0;
        C::t('forum_hotreply_number')->update_num($post['pid'], $typeid);
        C::t('forum_hotreply_member')->insert(array(
            'tid' => $post['tid'],
            'pid' => $post['pid'],
            'uid' => $_G['uid'],
            'attitude' => $typeid,
        ));

        $hotreply[$do]++;

        $data = array();
        Tool::getInstance()->success_json( $data );

    }


    /**
     * 获取大头像
     */
    public function actionGetavatar()
    {
        $uid = WebHelper::getPost( 'uid', 0 );

        require_once( libfile('function/forum') );

        Tool::getInstance()->success_json( array( 'icon' => discuz_uc_avatar($uid, 'big', true) ) );
    }

    /**
     * 通过一组UID，获取用户基本信息
     * 增加返回用户手机号优先取phonebind表后取common_memeber_profile
     */
    public function actionUserinfoes()
    {
        $uids = WebHelper::getPost( 'uids', '' );

        if( !empty($uids) )
        {
            $uidAry = explode( ',' , $uids );
        }

        $result = DB::fetch_all( "SELECT t.uid, t.username, p.gender, p.mobile,  s.extcredits1, s.extcredits2 FROM %t as t INNER JOIN %t as p ON t.uid = p.uid INNER JOIN %t as s ON t.uid=s.uid  WHERE t.uid in (%n)", array('common_member', 'common_member_profile', 'common_member_count', $uidAry) );

        //获取phonbind表的手机号
        $userPhone = DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $uidAry));
//        $phone = array_column($userPhone, 'phone', 'uid');
        //兼容5.5以下版本
        $re = $phone = array();
        foreach($userPhone as $k => $v) {
            $re[$v['uid']] = $v['phone'];
        }
        $phone = $re;
        if( !empty($result) )
        {
            require_once( libfile('function/forum') );
            foreach( $result as $key => $val )
            {
                $result[$key]['icon'] = discuz_uc_avatar( $val['uid'], 'big', true );
                $result[$key]['money'] = $val['extcredits1'];
                $result[$key]['rvrc'] = $val['extcredits2'];
                $result[$key]['mobile'] = $phone[$val['uid']] ? $phone[$val['uid']] : $val['mobile'];
                unset( $result[$key]['extcredits1'] );
                unset( $result[$key]['extcredits2'] );
            }
        }

        Tool::getInstance()->success_json( $result );
    }

    /**
     * 通过一组USERNAME，获取用户基本信息
     */
    public function actionUserinfoesbyuname() {
        $username = WebHelper::getPost( 'username', '' );

        if( !empty($username) )
        {
            $usernameAry = explode( ',' , $username );
        }

        $result = DB::fetch_all( "SELECT t.uid, t.username, p.gender FROM %t as t INNER JOIN %t as p ON t.uid = p.uid WHERE t.username in (%n)", array('common_member', 'common_member_profile', $usernameAry) );

        if( !empty($result) )
        {
            require_once( libfile('function/forum') );
            foreach( $result as $key => $val )
            {
                $result[$key]['icon'] = discuz_uc_avatar( $val['uid'], 'big', true );
            }
        }

        Tool::getInstance()->success_json( $result );
    }

    /**
     * 用户发表的帖子列表
     */
    public function actionUserthread()
    {
        global $_G;
        $offset = WebHelper::getPost('offset', '');
        $offset = $offset ? $offset : 0;
        $limit = WebHelper::getPost('limit', '');
        $lastid = WebHelper::getPost('lastid', '');

        $uid = WebHelper::getPost('uid', '');
        $uid = $uid ? $uid : $_G['uid'];
        if(!$uid) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }

		//用户自己可以看到待审核帖子
        $displayorder = $_G['uid'] == $uid ? 'displayorder in (0,1,2,3,-2)' : 'displayorder >= 0';

        if($lastid > 0) {
            $result = DB::fetch_all( '
                SELECT *
                FROM %t
                WHERE authorid = %d
                AND '.$displayorder.'
                AND tid < %d
                ORDER BY dateline DESC
                LIMIT %d
                ',
                array( "forum_thread", $uid, $lastid, $limit ) );
        }else {
            $result = DB::fetch_all( '
                SELECT *
                FROM %t
                WHERE authorid = %d
                AND '.$displayorder.'
                ORDER BY dateline DESC
                LIMIT %d ,%d
                ',
                array( "forum_thread", $uid, $offset, $limit ) );
        }

        $data =array();
        require_once( libfile('function/forum') );
        foreach($result as $k => $v){
            $data_temp['tid'] = $v['tid'];
            $data_temp['fid'] = $v['fid'];
            $data_temp['subject'] = $v['subject'];
            $data_temp['digest'] = $v['digest'];
            $data_temp['authorid'] = $v['authorid'];
            $data_temp['hits'] = $v['views'];
            $data_temp['author'] = $v['author'];
            $data_temp['postdate'] = $v['dateline'];
            $data_temp['favors'] = $v['rate'];
            $data_temp['pingcount'] = DB::result_first('SELECT COUNT(*) AS wa FROM '.DB::table('forum_memberrecommend').' WHERE tid = '.intval($v['tid']));
            $data_temp['replies'] = $v['replies'];
            $data_temp['ifupload'] = $v['attachment'] > 0 ? 1 : 0;
            $data_temp['special'] = $v['special'];
            $data_temp['topped'] = $v['displayorder'] > 0 ? 1 : 0;
            $data_temp['icon'] = discuz_uc_avatar($v['authorid'], 'big', 1);
            $data_temp['attach'] = array();
            $data_temp['attnum'] = '';
			
			$allPing = DB::fetch_all('SELECT recommenduid FROM '. DB::table('forum_memberrecommend') .' WHERE tid = %d', array(intval($v['tid'])));
            $pingUids = '';
            if( !empty($allPing) )
            {
                $arr = array();
                foreach( $allPing as $key => $ping )
                {
                    $arr[] = $ping['recommenduid'];
                }
                $pingUids = implode(',',$arr);
            }
            $data_temp['pinguids'] = $pingUids;
			
            $thread['pid'] = DB::result_first("SELECT pid FROM %t WHERE tid = %d AND first = 1", array("forum_post" , intval($data_temp['tid'])));
            //获取帖子附件
            if( $v['attachment'] == 2 || $v['attachment'] == 1 ) {
                $attachs = C::t('forum_attachment_n')->fetch_all_by_id( 'tid:' . $v['tid'], 'tid', $v['tid'], '', 1 );
                if( !empty($attachs) ) {
                    $i = 0;
                    foreach( $attachs as $key => $attach ) {
                        if($thread['pid'] == $attach['pid']) {
                            if(!$attach['isimage']) continue;
                            $data_temp['attach'][] = ForumThread::getAttachUrl($attach);
                            $i++;
                        }
                    }
                    $data_temp['attnum'] = ''.$i;
                }
            }
            $data[] = $data_temp;
        }
        Tool::getInstance()->success_json( $data );
    }

    /**
     * 用户回复的帖子列表
     */
    public function actionUserreplies()
    {
        global $_G;
        $offset = WebHelper::getPost('offset', '');
        $offset = $offset ? $offset : 0;
        $limit = WebHelper::getPost('limit', '');

        $uid = $_G['uid'];
        if(!$uid) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }

        $result = DB::fetch_all( '
            SELECT post.*, thread.views, thread.replies, thread.digest, thread.special, thread.displayorder
            FROM %t post INNER JOIN %t thread
            ON post.tid = thread.tid
            WHERE post.authorid = %d
            AND post.first = 0
            ORDER BY post.pid DESC
            LIMIT %d, %d
            ',
            array('forum_post', 'forum_thread', $uid, $offset, $limit) );

        $data =array();
        require_once libfile('function/discuzcode');
        foreach($result as $k => $v){
            $data_temp['pid'] = $v['pid'];
            $data_temp['tid'] = $v['tid'];
            $data_temp['subject'] = discuzcode($v['message']);
            $data_temp['digest'] = $v['digest'];
            $data_temp['authorid'] = $v['authorid'];
            $data_temp['hits'] = $v['views'];
            $data_temp['author'] = $v['author'];
            $data_temp['postdate'] = $v['dateline'];
            $data_temp['replies'] = $v['replies'];
            $data_temp['ifupload'] = $v['attachment'] > 0 ? 1 : 0;
            $data_temp['special'] = $v['special'];
            $data_temp['topped'] = $v['displayorder'] > 0 ? 1 : 0;
            $data[] = $data_temp;
        }

        if($data){
            foreach($data as $ks => $vs){
                $subject = DB::result_first('
                    SELECT subject
                    FROM %t
                    WHERE tid = %d
                    AND first = 1
                    ',
                    array('forum_post', $data[$ks]['tid']));
                $data[$ks]['subject'] = $subject;
            }
        }

        Tool::getInstance()->success_json( $data );
    }

    /**
     * 用户收藏的帖子列表
     * 1.5.1要改动lastid为favid
     */
    public function actionMycollectthread() {
        global $_G;
        $offset = WebHelper::getPost('offset', '');
        $offset = $offset ? $offset : 0;
        $limit = WebHelper::getPost('limit', '');
        $lastid = WebHelper::getPost('lastid', '');
        $lastid = $lastid ? $lastid : 0;
        $idType = 'tid';
        $uid = $_G['uid'];

        if(!$uid) {
            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first') );
        }

        if($lastid > 0) {
            $result = DB::fetch_all('
            SELECT thread.*, favorite.title
            FROM %t favorite INNER JOIN %t thread
            ON favorite.id = thread.tid
            WHERE favorite.uid = %d
            AND favorite.idtype = %s
            AND tid < %d
            ORDER BY favorite.favid DESC
            LIMIT %d
            ',
                array('home_favorite', 'forum_thread', $uid, $idType, $lastid, $limit));
        } else{
            $result = DB::fetch_all('
            SELECT thread.*, favorite.title
            FROM %t favorite INNER JOIN %t thread
            ON favorite.id = thread.tid
            WHERE favorite.uid = %d
            AND favorite.idtype = %s
            ORDER BY favorite.favid DESC
            LIMIT %d, %d
            ',
                array('home_favorite', 'forum_thread', $uid, $idType, $offset, $limit));
        }

        $data =array();
        foreach($result as $k => $v){
            $data_temp['tid'] = $v['tid'];
            $data_temp['fid'] = $v['fid'];
            $data_temp['subject'] = $v['title'];
            $data_temp['digest'] = $v['digest'];
            $data_temp['authorid'] = $v['authorid'];
            $data_temp['favors'] = $v['favtimes'];
            $data_temp['author'] = $v['author'];
            $data_temp['postdate'] = $v['dateline'];
            $data_temp['replies'] = $v['replies'];
            $data_temp['ifupload'] = $v['attachment'] > 0 ? 1 : 0;
            $data_temp['special'] = $v['special'];
            $data[] = $data_temp;
        }

        Tool::getInstance()->success_json( $data );
    }

    /**
     * 投票接口
     * 参数polloptions为用户选择的投票项polloptionid
     */
    public function actionVote() {
        global $_G;
        $_G['tid'] = dintval(WebHelper::getPost('tid', 0));
        $polloptions = WebHelper::getPost('polloptions', ''); //用户选择的投票项polloptionid

        require_once libfile('function/post');
        $thread = C::t('forum_thread')->fetch($_G['tid']);
        if(!$_G['group']['allowvote']) {
            Tool::getInstance()->fail_json( Code::GROUP_NOPERMISSION, Tool::getInstance()->lang( 'group_nopermission' ) );
        } elseif(!empty($thread['closed'])) {
            Tool::getInstance()->fail_json( Code::THREAD_POLL_CLOSED, Tool::getInstance()->lang( 'thread_poll_closed' ) ); // 本主题已关闭，无法继续投票
        } elseif(empty($polloptions)) {
            Tool::getInstance()->fail_json( Code::THREAD_POLL_INVALID, Tool::getInstance()->lang( 'thread_poll_invalid' ) ); // 您没有选择投票选项
        }

        $_GET['pollanswers'] = explode(',', $polloptions);
        $pollarray = C::t('forum_poll')->fetch($_G['tid']);
        $overt = $pollarray['overt'];
        if(!$pollarray) {
            Tool::getInstance()->fail_json( Code::POLL_NOT_FOUND, Tool::getInstance()->lang( 'poll_not_found' ) ); // 投票未找到
        } elseif($pollarray['expiration'] && $pollarray['expiration'] < TIMESTAMP) {
            Tool::getInstance()->fail_json( Code::POLL_OVERDUE, Tool::getInstance()->lang( 'poll_overdue' ) ); // 投票已过期
        } elseif($pollarray['maxchoices'] && $pollarray['maxchoices'] < count($_GET['pollanswers'])) {
            // 抱歉，此投票最多只能选择 {maxchoices} 项
            Tool::getInstance()->fail_json( Code::POLL_CHOOSE_MOST, Tool::getInstance()->lang( 'poll_choose_most {maxchoices}', array('{maxchoices}' => $pollarray['maxchoices'])) );

        }

        $voterids = $_G['uid'] ? $_G['uid'] : $_G['clientip'];
        $polloptionid = array();
        $query = C::t('forum_polloption')->fetch_all_by_tid($_G['tid']);
        foreach($query as $v) {
            if(strexists("\t".$v['voterids']."\t", "\t".$voterids."\t")) {
                Tool::getInstance()->fail_json( Code::THREAD_POLL_VOTED, Tool::getInstance()->lang( 'thread_poll_voted' ) ); // 已经投过票了
            }
            $polloptionid[] = $v['polloptionid'];
        }

        $polloptionids = '';
        foreach($_GET['pollanswers'] as $key => $id) {
            if(!in_array($id, $polloptionid)) {
                Tool::getInstance()->fail_json( Code::UNDEFINED_ACTION, Tool::getInstance()->lang( 'undefined action' ) ); // 参数错误
            }
            unset($polloptionid[$key]);
            $polloptionids[] = $id;
        }

        //更新,返回数据
        foreach($_GET['pollanswers'] as $key =>$value) {
            C::t('forum_polloption')->update_vote($value, $voterids."\t", 1);
            C::t('forum_thread')->update($_G['tid'], array('lastpost'=>$_G['timestamp']), true);
            C::t('forum_poll')->update_vote($_G['tid']);
            C::t('forum_pollvoter')->insert(array(
                'tid' => $_G['tid'],
                'uid' => $_G['uid'],
                'username' => $_G['username'],
                'options' => $value,
                'dateline' => $_G['timestamp'],
            ));
            updatecreditbyaction('joinpoll');
            $space = array();
            space_merge($space, 'field_home');
        }
        require_once( Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php' );
        $data = ForumThread::getVoteInfo($_G['tid']);
        Tool::getInstance()->success_json( $data );
    }
}